2015-04-06  Alan Mackenzie  <acm@muc.de>

	Fix miscellaneous glitches in cc-mode.el.  (Bug#20245)
	* progmodes/cc-mode.el (c-common-init): bind
	\(before\|after\)-change-functions to nil around invocations of
	c-get-state-before-change-functions and
	c-before-font-lock-functions to prevent recursive invocations.
	(c-neutralize-syntax-in-and-mark-CPP): On c-beginning-of-macro,
	check that point has actually moved back.
	(c-fl-decl-start): Check whether c-beginning-of-decl-1 has
	actually found a boundary (as contrasted with hitting a search
	limit).

2015-02-01  Alan Mackenzie  <acm@muc.de>

	CC Mode: Stop Font Lock forcing fontification from BOL.
	* progmodes/cc-mode.el (c-font-lock-init): Setq
	font-lock-extend-region-functions to nil.  (Bug#19669)

2015-04-06  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	python.el: Do not break IPython magic completions.  (Bug#19736)
	* progmodes/python.el (python-shell-completion-setup-code):
	Cleaner setup; import rlcompleter as last resource.

2015-04-06  Artur Malabarba  <bruce.connor.am@gmail.com>

	* emacs-lisp/package.el: Fix lack of "new" packages.
	(package-menu--new-package-list)
	(package-menu--old-archive-contents): No longer local.
	(package-menu--list-to-prompt): New function.
	(package-menu--prompt-transaction-p): Use "Upgrade" to make the
	package-menu-execute prompt less verbose.

2015-04-06  Paul Eggert  <eggert@cs.ucla.edu>

	Spelling fix for 'hfy-optimizations'
	* htmlfontify.el (hfy-optimizations): Rename from hfy-optimisations,
	with an obsolete alias.  All uses changed.

2015-04-06  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	python.el: Enhance docstring detection following PEP-257.
	* progmodes/python.el (python-docstring-at-p): Remove function.
	(python-info-assignment-statement-p): New function.
	(python-info-assignment-continuation-line-p): Use it.
	(python-info-docstring-p): New function.
	(python-font-lock-syntactic-face-function)
	(python-fill-string): Use it.

2015-04-05  Eli Zaretskii  <eliz@gnu.org>

	* ses.el (ses-sym-rowcol): Move up, before the first use, to avoid
	byte-compiler warnings.

2015-04-05  Alan Mackenzie  <acm@muc.de>

	* jit-lock.el (jit-lock-after-change): Widen the buffer only
	whilst putting the 'fontified text properties.

2015-04-05  Alan Mackenzie  <acm@muc.de>

	Rationalize use of c[ad]+r, expunging cl-c[ad]\{3,4\}r.
	Also expunge eudc-c[ad]+r.
	* subr.el (internal--compiler-macro-cXXr): "New" function,
	copied from cl--compiler-macro-cXXr.
	(caar, cadr, cdar, cddr): Change from defsubsts to defuns with
	the above compiler-macro.
	* net/eudc.el (eudc-cadr, eudc-cdar, eudc-caar, eudc-cdaar): Remove.
	* emacs-lisp/cl.el (Top level dolist doing defaliases):
	Remove caaar, etc., from list of new alias functions.
	* emacs-lisp/cl-lib.el (cl-caaar, etc): Rename to caaar, etc.
	(gen-cXXr--rawname, gen-cXXr-all-cl-aliases): New function/macro
	which generate obsolete cl- aliases for caaar, etc.  Invoke them.
	* desktop.el, edmacro.el, emacs-lisp/cl-macs.el, frameset.el:
	* ibuffer.el, mail/footnote.el, net/dbus.el, net/eudc-export.el:
	* net/eudc.el, net/eudcb-ph.el, net/rcirc.el, net/secrets.el:
	* play/5x5.el, play/decipher.el, play/hanoi.el, progmodes/hideif.el:
	* ses.el: Replace cl-caaar, eudc-cadr, etc. with caaar and cadr, etc.

2015-04-05  Richard Stallman  <rms@gnu.org>

	* mail/rmail.el (rmail-show-message-1): When displaying a mime message,
	indicate start and finish in the echo area.

	* mail/rmail.el	(rmail-epa-decrypt): Disregard <pre> before armor.
	Ignore more kinds of whitespace in mime headers.
	Modify the decrypted mime part's mime type so it will be displayed
	by default when visiting this message again.

	* net/browse-url.el (browse-url-firefox-program): Prefer IceCat, doc.
	(browse-url-firefox-arguments)
	(browse-url-firefox-startup-arguments): Doc fix.

2015-04-05  Artur Malabarba  <bruce.connor.am@gmail.com>

	* emacs-lisp/package.el: Add package-initialize to user-init-file.
	(package--ensure-init-file): New function.
	(package-install, package-install-from-buffer): Use it.
	(package-download-transaction, package-install-from-archive): Add
	ASYNC and CALLBACK arguments.
	(package-menu--prompt-transaction-p): New function.
	(package-menu-execute): Use it to prompt the user about operations
	to be executed.
	(package-install): Add ASYNC and CALLBACK arguments.
	(package-menu--perform-transaction): New function.
	(package-menu-execute): Use it to install and delete packages.

2015-04-05  Pete Williamson  <petewil@chromium.org>  (tiny-change)

	Fix .emacs and .emacs.d/init file recursion problem for NaCl
	* files.el (file-truename): Add NaCl to the exception list ms-dos uses.

2015-04-04  Alan Mackenzie  <acm@muc.de>

	* progmodes/cc-mode.el (c-font-lock-init): Revert 2015-03-03 change
	"Stop Font Lock forcing fontification from BOL."  (Bug#20245)

2015-04-04  Artur Malabarba  <bruce.connor.am@gmail.com>

	* emacs-lisp/package.el (package--download-and-read-archives): Add
	`package-archives' to `package--downloads-in-progress' instead of
	overwriting it.
	(package--with-work-buffer-async): Protect macro arguments.
	(package--download-one-archive)
	(package--download-and-read-archives): Prevent
	downloads-in-progress list from becoming outdated.

2015-04-04  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp-cache.el (tramp-flush-directory-property): Quote directory
	name when used in regexp.

2015-04-04  Alan Mackenzie  <acm@muc.de>

	* jit-lock.el (jit-lock-after-change): Widen the buffer before
	putting 'fontified text properties.  (Bug#20240)

2015-04-03  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp-cache.el (tramp-flush-file-property)
	(tramp-flush-directory-property): Use `directory-file-name' of the
	truename.  (Bug#20249)

2015-04-03  Nicolas Richard  <theonewiththeevillook@yahoo.fr>

	* pcmpl-unix.el (pcmpl-ssh-known-hosts): Use `char-before' instead
	of `looking-back' (bug#17284).

2015-04-03  Dmitry Gutov  <dgutov@yandex.ru>

	* progmodes/js.el (js-indent-line): Do nothing when bol is inside
	a string (https://github.com/mooz/js2-mode/issues/227).

2015-04-02  Stefan Monnier  <monnier@iro.umontreal.ca>

	* abbrev.el (define-abbrev-table): Treat a non-string "docstring" as
	part of the "props" arguments rather than silently ignoring it.

	* emacs-lisp/lisp-mnt.el (lm-version): Don't burp in a non-file buffer.

2015-04-01  Alan Mackenzie  <acm@muc.de>

	Fix the CC Mode fixes from 2015-03-30.  (Bug#20240)
	* progmodes/cc-mode.el (c-extend-after-change-region):
	Widen before applying text properties.
	* progmodes/cc-langs.el (c-before-font-lock-functions):
	Update an entry to a new function name.

2015-04-01  Paul Eggert  <eggert@cs.ucla.edu>

	* emacs-lisp/package.el: Spelling fixes and use active voice.

2015-04-01  Artur Malabarba  <bruce.connor.am@gmail.com>

	* emacs-lisp/package.el: Implement asynchronous refreshing.
	(package--with-work-buffer-async)
	(package--check-signature-content)
	(package--update-downloads-in-progress): New functions.
	(package--check-signature, package--download-one-archive)
	(package--download-and-read-archives, package-refresh-contents):
	Optional arguments for async usage.
	(package--post-download-archives-hook): New variable.  Hook run
	after every refresh.

	* emacs-lisp/package.el: Make package-menu asynchronous.
	(package-menu-async): New variable.  Controls whether
	`list-packages' is asynchronous.
	(list-packages): Now asynchronous by default.
	(package-menu--new-package-list): Always buffer-local.
	(package-menu--post-refresh)
	(package-menu--find-and-notify-upgrades)
	(package-menu--populate-new-package-list): New functions.

2015-03-31  Simen Heggestøyl  <simenheg@gmail.com>

	* textmodes/css-mode.el (css-mode): Derive from `prog-mode'.

2015-03-31  Stefan Monnier  <monnier@iro.umontreal.ca>

	* jit-lock.el (jit-lock--run-functions): Fix min/max copy&paste error.

	Let jit-lock know the result of font-lock-extend-region-functions.
	* jit-lock.el (jit-lock--run-functions): New function.
	(jit-lock-fontify-now): Use it.  Handle fontification bounds more
	precisely in case the backend functions fontify more than requested.
	Don't round up to whole lines since that shouldn't be needed
	any more.
	* font-lock.el (font-lock-fontify-region-function): Adjust docstring.
	(font-lock-inhibit-thing-lock): Make obsolete.
	(font-lock-default-fontify-region): Return the bounds actually used.

	* emacs-lisp/eieio-base.el (eieio-persistent-validate/fix-slot-value):
	Fix compilation error.

2015-03-30  Artur Malabarba  <bruce.connor.am@gmail.com>

	* emacs-lisp/package.el: Reorganize package.el and divide it with
	page-breaks and comments.

2015-03-30  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/eieio-base.el (make-instance) <eieio-named>: New instance
	which stores the old-style object name argument into the
	object-name field.

2015-03-30  Alan Mackenzie  <acm@muc.de>

	Correct calculation of CC Mode's font-lock region.
	* progmodes/cc-mode.el (c-fl-decl-start): Rename from
	c-set-fl-decl-start.  Change signature such that nil is returned
	when no declaration is found.
	(c-change-expand-fl-region): Rename from
	c-change-set-fl-decl-start.  This now also handles expanding the
	font lock region to whole lines.
	(c-context-expand-fl-region): Rename from
	c-context-set-fl-decl-start.  This now also handles expanding the
	font lock region to whole lines.
	(c-font-lock-fontify-region): When a change font lock region is
	spuriously enlarged to the beginning-of-line by jit-lock, fontify
	the extra bit separately from the region calculated by CC Mode.
	(c-extend-after-change-region): Explicitly apply 'fontified
	properties to the extended bits of the font lock region.
	* progmodes/cc-langs.el (c-before-font-lock-functions)
	(c-before-context-fontification-functions): Use new names for
	existing functions (see above).

2015-03-30  Richard Ryniker  <ryniker@alum.mit.edu>  (tiny change)

	* mail/sendmail.el (sendmail-send-it): Do not attempt to switch
	to non-existent buffer (errbuf is not created when customization
	variable mail-interactive is nil).  (Bug#20211)

2015-03-29  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/smie.el (smie-backward-sexp-command)
	(smie-forward-sexp-command): Don't pretend the arg is optional
	(bug#20205).

2015-03-29  Dmitry Gutov  <dgutov@yandex.ru>

	* progmodes/ruby-mode.el (ruby-syntax-before-regexp-re):
	Detect regexps after `!'.  (Bug#19285)

	* progmodes/ruby-mode.el (ruby-font-lock-keywords):
	Use `font-lock-constant-face' for nil, true and false.
	Highlight `self' as a keyword.  (Bug#17733)

2015-03-29  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* progmodes/ruby-mode.el (ruby-syntax-before-regexp-re):
	Expect beginning of regexp also after open brace or vertical bar.
	(Bug#20026)

2015-03-28  Jan Djärv  <jan.h.d@swipnet.se>

	* emacs-lisp/package.el (package-refresh-contents): Fix spelling
	error in previous change.

2015-03-28  Tom Willemse  <tom@ryuslash.org>  (tiny change)

	* elec-pair.el (electric-pair-local-mode): New command.
	(electric-pair-mode): Mention `electric-pair-local-mode' in the
	docstring.

2015-03-28  Jan Djärv  <jan.h.d@swipnet.se>

	* emacs-lisp/package.el (package-refresh-contents): Add a message at
	the end so it does not appear to have hanged (Bug#17879).

2015-03-27  Wolfgang Jenkner  <wjenkner@inode.at>

	* font-lock.el (font-lock--remove-face-from-text-property):
	New function.  Adapted from the previously commented out
	remove-single-text-property.
	Remove previously unused and commented out auxiliary function
	remove-text-property and obsolete comment.
	* comint.el (comint-output-filter): Use it to remove
	comint-highlight-prompt.
	(comint-snapshot-last-prompt, comint-output-filter):
	Use font-lock-prepend-text-property for comint-highlight-prompt.
	(Bug#20084)

2015-03-26  Daniel Colascione  <dancol@dancol.org>

	* progmodes/python.el
	(python-indent-guess-indent-offset-verbose): New defcustom.
	(python-indent-guess-indent-offset): Use it.

2015-03-26  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/eieio.el (defclass): Change internal name so as to make
	sure only EIEIO files should have "eieio--" prefixes in their .elc.

	* emacs-lisp/cl-macs.el (cl-dolist, cl-dotimes): Silence byte-compiler.

2015-03-26  Boruch Baum  <boruch_baum@gmx.com>  (tiny change)

	* bookmark.el (bookmark-show-all-annotations): Sort them (bug#20177).

2015-03-25  Dmitry Gutov  <dgutov@yandex.ru>

	* json.el (json-special-chars): Don't treat `/' specially, there's
	no need to.
	(json-encode-string): Only escape quotation mark, backslash and
	the control characters U+0000 to U+001F.

2015-03-25  Artur Malabarba  <bruce.connor.am@gmail.com>

	* emacs-lisp/checkdoc.el (checkdoc-this-string-valid-engine):
	Don't complain about args starting with _.

2015-03-25  Stefan Monnier  <monnier@iro.umontreal.ca>

	* international/mule-cmds.el (mule--ucs-names-annotation): New func.
	(read-char-by-name): Use it.

	* xt-mouse.el (xterm-mouse--read-number-from-terminal): Fix last commit.

2015-03-25  Nicolas Petton <nicolas@petton.fr>

	* emacs-lisp/seq.el: Documentation improvements.

2015-03-25  Glenn Morris  <rgm@gnu.org>

	* net/browse-url.el (browse-url-browser-function)
	(browse-url-default-browser):
	Remove obsolete items from the explicit listing.
	(browse-url-new-window-flag, browse-url-of-file-hook): Doc fixes.
	(browse-url-netscape-program, browse-url-netscape-arguments)
	(browse-url-netscape-startup-arguments)
	(browse-url-galeon-program, browse-url-galeon-arguments)
	(browse-url-galeon-startup-arguments)
	(browse-url-gnome-moz-program, browse-url-gnome-moz-arguments)
	(browse-url-galeon-new-window-is-tab)
	(browse-url-netscape-new-window-is-tab)
	(browse-url-mosaic-program, browse-url-mosaic-arguments)
	(browse-url-mosaic-pidfile, browse-url-CCI-port)
	(browse-url-CCI-host, browse-url-netscape-version)
	(browse-url-netscape, browse-url-netscape-sentinel)
	(browse-url-netscape-reload, browse-url-netscape-send)
	(browse-url-galeon, browse-url-galeon-sentinel)
	(browse-url-gnome-moz, browse-url-mosaic, browse-url-cci)
	(browse-url-w3-gnudoit): Make obsolete.
	* ffap.el (ffap-url-fetcher): Simplify default and doc.

2015-03-25  Olaf Rogalsky  <olaf.rogalsky@gmail.com>

	* xt-mouse.el: Add mouse-tracking support (bug#19416).
	(xterm-mouse-translate-1): Handle mouse-movement events.
	(xterm-mouse--read-event-sequence-1000)
	(xterm-mouse--read-event-sequence-1006): Delete functions.
	(xterm-mouse--read-event-sequence): New function that handles both at
	the same time.  Handle mouse-movements.
	(xterm-mouse--read-utf8-char, xterm-mouse--read-number-from-terminal):
	New functions.
	(xterm-mouse-event): Simplify.
	(xterm-mouse-tracking-enable-sequence)
	(xterm-mouse-tracking-disable-sequence): Enable mouse tracking.

	* mouse.el (mouse-drag-line): Also ignore `vertical-line' prefix events.

2015-03-24  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp-sh.el (tramp-do-file-attributes-with-ls)
	(tramp-do-file-attributes-with-stat): Quote file names in output.
	(tramp-do-directory-files-and-attributes-with-stat): Use "//" as marker.

2015-03-24  Daiki Ueno  <ueno@gnu.org>

	* epg.el (epg-start-generate-key): Fix typo in "gpg --gen-key"
	invocation; make the PARAMETERS documentation clearer.

2015-03-24  Stefan Monnier  <monnier@iro.umontreal.ca>

	Add cl-struct specific optimizations to pcase.
	* emacs-lisp/cl-macs.el (cl--struct-all-parents)
	(cl--pcase-mutually-exclusive-p): New functions.
	(pcase--mutually-exclusive-p): Advise to optimize cl-struct patterns.

	* emacs-lisp/pcase.el (pcase--split-pred): Handle quoted string.

2015-03-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	Add new `cl-struct' and `eieio' pcase patterns.
	* emacs-lisp/cl-macs.el (cl-struct): New pcase pattern.
	* emacs-lisp/eieio.el (eieio-pcase-slot-index-table)
	(eieio-pcase-slot-index-from-index-table): New functions.
	(eieio): New pcase pattern.
	* emacs-lisp/pcase.el (pcase--make-docstring): New function.
	(pcase): Use it to build the docstring.
	(pcase-defmacro): Make sure the macro is lazy-loaded.
	(\`): Move its docstring from `pcase'.

2015-03-23  Glenn Morris  <rgm@gnu.org>

	* emacs-lisp/authors.el (authors-aliases)
	(authors-obsolete-files-regexps): Additions.

2015-03-23  Jan Djärv  <jan.h.d@swipnet.se>

	* simple.el (deactivate-mark): Only modify PRIMARY if we own
	PRIMARY (Bug#18939).

2015-03-23  Martin Rudalics  <rudalics@gmx.at>

	* emacs-lisp/debug.el (debug): Don't try using "previous" window
	when its not live or on an invisible frame (Bug#17170).

2015-03-23  Dmitry Gutov  <dgutov@yandex.ru>

	* json.el (json-decode-char0): Delete this alias as well.
	(json-read-escaped-char): Don't call it (bug#20154).

2015-03-23  Daniel Colascione  <dancol@dancol.org>

	* emacs-lisp/lisp-mode.el (lisp--el-non-funcall-position-p): New function.
	(lisp--el-match-keyword): Use it.

2015-03-23  Daiki Ueno  <ueno@gnu.org>

	* subr.el (start-process): New function, ported from the C
	implementation.

2015-03-23  Daniel Colascione  <dancol@dancol.org>

	Automatically adjust process window sizes.

	* window.el (window-adjust-process-window-size-function):
	New customizable variable.
	(window-adjust-process-window-size)
	(window-adjust-process-window-size-smallest)
	(window-adjust-process-window-size-largest)
	(window--process-window-list, window--adjust-process-windows):
	New functions.
	(window-configuration-change-hook):
	Add `window--adjust-process-windows'.
	* term.el (term-mode): Observe result of
	`window-adjust-process-window-size-function'.
	(term-check-size): Delete.

2015-03-22  Jackson Ray Hamilton  <jackson@jacksonrayhamilton.com>

	* textmodes/sgml-mode.el (sgml-attribute-offset): New defcustom.
	(sgml-calculate-indent): Use `sgml-attribute-offset' for attribute
	indentation (bug#20161).

2015-03-22  Dmitry Gutov  <dgutov@yandex.ru>

	* json.el (json-encode-char0): Delete this alias.
	(json-encode-string): Rewrite to improve performance (bug#20154).
	(json-encode-char): Fold into `json-encode-string'.

2015-03-22  Artur Malabarba  <bruce.connor.am@gmail.com>

	* menu-bar.el (menu-bar-update-buffers): Count displayed buffers
	for `buffers-menu-max-size', not total buffers.

2015-03-21  Titus von der Malsburg  <malsburg@posteo.de>

	* window.el (window-font-width, window-font-height)
	(window-max-chars-per-line): New functions.

	* simple.el (default-font-height): Doc fix.
	(default-font-width): New function.

2015-03-21  Tassilo Horn  <tsdh@gnu.org>

	* emacs-lisp/lisp-mode.el (lisp-el-font-lock-keywords-1):
	Also recognize (cl-)defmethod with (setf method) name.

2015-03-20  Tassilo Horn  <tsdh@gnu.org>

	* emacs-lisp/lisp-mode.el (lisp-el-font-lock-keywords-1):
	Fix false positive in function name font-locking.
	(lisp-cl-font-lock-keywords-1): Ditto.

2015-03-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/cl-macs.el (cl-defsubst): Ignore false-positive
	occurrences of args via &cl-defs (bug#20149).

2015-03-20  Alan Mackenzie  <acm@muc.de>

	Fix Bug#20146

	* font-lock.el (font-lock-extend-jit-lock-region-after-change):
	Return the calculated values, as per spec.

2015-03-20  Dmitry Gutov  <dgutov@yandex.ru>

	* progmodes/ruby-mode.el (ruby-font-lock-keywords): Move `at_exit'
	and `callcc' to the "methods with required arguments" section,
	they need a block argument.  Remove a `throw' duplicate.

2015-03-19  Vibhav Pant  <vibhavp@gmail.com>

	* progmodes/cperl-mode.el (cperl-electric-backspace):
	Call delete-backward-space interactively instead of delete-char.

2015-03-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/pcase.el (pcase-lambda): Rewrite.

	* emacs-lisp/eieio.el (object-slots): Return slot names as before
	(bug#20141).

2015-03-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	EIEIO: Change class's representation to unify instance and class slots
	* emacs-lisp/eieio-core.el (eieio--class): Change field names and order
	to match those of cl--class; use cl--slot for both instance slots and
	class slots.
	(eieio--object-num-slots): Use cl-struct-slot-info.
	(eieio--object-class): Rename from eieio--object-class-object.
	(eieio--object-class-name): Remove.
	(eieio-defclass-internal): Adjust to new slot representation.
	Store doc in class rather than in `variable-documentation'.
	(eieio--perform-slot-validation-for-default): Change API to take
	a slot object.
	(eieio--slot-override): New function.
	(eieio--add-new-slot): Rewrite.
	(eieio-copy-parents-into-subclass): Rewrite.
	(eieio--validate-slot-value, eieio--validate-class-slot-value)
	(eieio-oref-default, eieio-oset-default)
	(eieio--class-slot-name-index, eieio-set-defaults): Adjust to new
	slot representation.
	(eieio--c3-merge-lists): Simplify.
	(eieio--class/struct-parents): New function.
	(eieio--class-precedence-bfs): Use it.

	* emacs-lisp/eieio.el (with-slots): Use macroexp-let2.
	(object-class-fast): Change recommend replacement.
	(eieio-object-class): Rewrite.
	(slot-exists-p): Adjust to new slot representation.
	(initialize-instance): Adjust to new slot representation.
	(object-write): Adjust to new slot representation.

	* emacs-lisp/eieio-opt.el (eieio--help-print-slot): New function
	extracted from eieio-help-class-slots.
	(eieio-help-class-slots): Use it.  Adjust to new slot representation.

	* emacs-lisp/eieio-datadebug.el (data-debug/eieio-insert-slots):
	Declare to silence warnings.
	(data-debug-insert-object-button): Avoid `object-slots'.
	(data-debug/eieio-insert-slots): Adjust to new slot representation.

	* emacs-lisp/eieio-custom.el (eieio-object-value-create)
	(eieio-object-value-get): Adjust to new slot representation.

	* emacs-lisp/eieio-compat.el
	(eieio--generic-static-symbol-specializers):
	Extract from eieio--generic-static-symbol-generalizer.
	(eieio--generic-static-symbol-generalizer): Use it.

	* emacs-lisp/eieio-base.el (eieio-persistent-convert-list-to-object):
	Manually map initargs to slot names.
	(eieio-persistent-validate/fix-slot-value): Adjust to new
	slot representation.

	* emacs-lisp/cl-preloaded.el (cl--class): Fix type of `parents'.

2015-03-19  Vibhav Pant  <vibhavp@gmail.com>

	* leim/quail/hangul.el (hangul-delete-backward-char)
	(hangul-to-hanja-conversion):
	* progmodes/cperl-mode.el (cperl-electric-keyword)
	(cperl-electric-backspace): Use delete-char instead of
	delete-backward-char, fixes compilation warnings.

2015-03-18  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp-sh.el (tramp-do-directory-files-and-attributes-with-stat):
	Mark apostrophs with ?/ instead of \037.  (Bug#20117)

2015-03-18  Stefan Monnier  <monnier@iro.umontreal.ca>

	Add classes as run-time descriptors of cl-structs.
	* emacs-lisp/cl-preloaded.el (cl--struct-get-class): New function.
	(cl--make-slot-desc): New constructor.
	(cl--plist-remove, cl--struct-register-child): New functions.
	(cl-struct-define): Rewrite.
	(cl-structure-class, cl-structure-object, cl-slot-descriptor)
	(cl--class): New structs.
	(cl--struct-default-parent): Initialize it here.
	* emacs-lisp/cl-macs.el (cl--find-class): New macro.
	(cl-defsubst, cl--defsubst-expand, cl--sublis): Move before first use.
	(cl--struct-default-parent): New var.
	(cl-defstruct): Adjust to new representation of classes; add
	default parent.  In accessors, signal `wrong-type-argument' rather than
	a generic error.
	(cl-struct-sequence-type, cl-struct-slot-info)
	(cl-struct-slot-offset): Rewrite.
	* emacs-lisp/cl-generic.el (cl--generic-struct-specializers)
	(cl-generic-generalizers): Rewrite.

	* emacs-lisp/macroexp.el (macroexp--debug-eager): New var.
	(internal-macroexpand-for-load): Use it.

	* emacs-lisp/debug.el (debug--implement-debug-on-entry):
	Bind inhibit-debug-on-entry here...
	(debug): Instead of here.

2015-03-18  Dima Kogan  <dima@secretsauce.net>

	Have gud-display-line not display source buffer in gud window.
	* progmodes/gud.el (gud-display-line): Make display-buffer
	not reuse selected window.  (Bug#17675, Bug#19901, Bug#20034)

2015-03-17  Tassilo Horn  <tsdh@gnu.org>

	* emacs-lisp/byte-run.el (macro-declarations-alist):
	New declaration no-font-lock-keyword.
	(defmacro): Flush font-lock in existing elisp buffers.

	* emacs-lisp/lisp-mode.el (lisp--el-update-after-load)
	(lisp--el-update-macro-regexp, lisp--el-macro-regexp):
	Delete functions and defconst.
	(lisp--el-match-keyword): Rename from lisp--el-match-macro.
	(lisp--el-font-lock-flush-elisp-buffers): New function.
	(lisp-mode-variables): Remove code for updating
	lisp--el-macro-regexp, and add
	lisp--el-font-lock-flush-elisp-buffers to after-load-functions.

2015-03-17  Simen Heggestøyl  <simenheg@gmail.com>

	* textmodes/css-mode.el (css--font-lock-keywords):
	Discriminate between pseudo-classes and pseudo-elements.
	(css-pseudo-ids): Remove.
	(css-pseudo-class-ids, css-pseudo-element-ids): New variables.
	(css--complete-property): New function for completing CSS properties.
	(css--complete-pseudo-element-or-class): New function
	completing CSS pseudo-elements and pseudo-classes.
	(css--complete-at-rule): New function for completing CSS at-rules.
	(css-completion-at-point): New function.
	(css-mode): Add support for completion.
	(css-extract-keyword-list, css-extract-parse-val-grammar)
	(css-extract-props-and-vals): Remove function in favor of manual
	extraction.
	(css-at-ids): Update list of CSS at-rule ids.
	(css-property-ids): Update list of CSS properties.

2015-03-17  Bozhidar Batsov  <bozhidar@batsov.com>

	* progmodes/ruby-mode.el (ruby-font-lock-keywords): Font-lock
	more Kernel methods.

2015-03-17  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp-sh.el (tramp-maybe-send-script): Avoid leading tabs in
	shell scripts.  (Bug#20118)

2015-03-17  Eli Zaretskii  <eliz@gnu.org>

	* mouse.el (mouse-appearance-menu): If w32-use-w32-font-dialog is
	nil, construct a menu of fixed fonts.  This resurrects a feature
	lost in Emacs 23.

	* w32-vars.el (w32-use-w32-font-dialog): Add a ':set' function to
	reset mouse-appearance-menu-map, so the font dialog is recomputed
	the next time the menu is requested.
	(w32-fixed-font-alist): Fix to use correct names of Courier fonts.

2015-03-17  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/cl-macs.el (cl--transform-lambda): Refine last change
	(bug#20125).

2015-03-17  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp-sh.el (tramp-ssh-controlmaster-options): Change test
	for ControlPath in order to avoid DNS timeouts.  (Bug#20015)

2015-03-16  Alan Mackenzie  <acm@muc.de>

	Edebug: Allow "S" to work during trace mode.  Fixes Bug#20074.
	Also display the overlay arrow in go and go-nonstop modes.

	* emacs-lisp/edebug.el (edebug--display-1): Move the
	`input-pending' test to after trace mode's `sit-for'.
	(edebug--recursive-edit): Insert "(sit-for 0)" after
	"(edebug-overlay-arrow)".

2015-03-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/cl-macs.el (cl--transform-lambda): Rework to avoid
	cl--do-arglist in more cases; add comments to explain what's going on.
	(cl--do-&aux): New function extracted from cl--do-arglist.
	(cl--do-arglist): Use it.

	* emacs-lisp/cl-generic.el: Add Version: header, for ELPA purposes.

	* obsolete/iswitchb.el (iswitchb-read-buffer): Add `predicate' arg.
	* isearchb.el (isearchb-iswitchb): Adjust accordingly.
	* ido.el (ido-read-buffer): Add `predicate' argument.
	* misearch.el (unload-function-defs-list): Declare before use.

2015-03-16  Vibhav Pant  <vibhavp@gmail.com>

	* net/browse-url.el (browse-url-browser-function): Add "Conkeror".
	(browse-url-conkeror-program, browse-url-conkeror-arguments)
	(browse-url-conkeror-new-window-is-buffer): New defcustoms.
	(browse-url-default-browser): Check for `browse-url-conkeror'
	and call `browse-url-conkeror-program'.
	(browse-url-conkeror): New command.
	(bug#19863)

2015-03-16  Vibhav Pant  <vibhavp@gmail.com>

	* eshell/esh-mode.el (eshell/clear): New function.

2015-03-16  Alan Mackenzie  <acm@muc.de>

	Make Edebug work with Follow Mode.

	* emacs-lisp/edebug.el (edebug--display-1): Remove call to
	edebug-adjust-window.
	(edebug--recursive-edit): Don't bind pre/post-command-hooks to nil
	over the recursive edit.
	(edebug-adjust-window): Remove.

2015-03-15  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp-adb.el:
	* net/tramp-gvfs.el:
	* net/tramp-sh.el:
	* net/tramp-smb.el: Set tramp-autoload cookie for all defcustoms.

	* net/tramp.el (tramp-ssh-controlmaster-options)
	(tramp-use-ssh-controlmaster-options): Move them to tramp-sh.el.
	(tramp-default-method): Do not check for
	`tramp-ssh-controlmaster-options'.

	* net/tramp-sh.el (tramp-use-ssh-controlmaster-options):
	New defcustom, moved from tramp.el.
	(tramp-ssh-controlmaster-options): New defvar, moved from tramp.el
	but with a nil initial value.
	(tramp-ssh-controlmaster-options): New defun.
	(tramp-do-copy-or-rename-file-out-of-band)
	(tramp-maybe-open-connection): Use it.  (Bug#20015)

2015-03-15  Tassilo Horn  <tsdh@gnu.org>

	* emacs-lisp/lisp-mode.el (lisp--el-macro-regexp): New defconst.
	(lisp--el-update-macro-regexp, lisp--el-update-after-load)
	(lisp--el-match-macro): New functions.
	(lisp-mode-variables): Update lisp--el-macro-regexp and add
	lisp--el-update-after-load to after-load-functions.

2015-03-15  Daniel Colascione  <dancol@dancol.org>

	* emacs-lisp/cl-indent.el
	(lisp-indent-backquote-substitution-mode): New user option.
	(common-lisp-indent-function-1, common-lisp-loop-part-indentation)
	(common-lisp-indent-function): Support normally indenting
	backquote substitutions.
	(extended-loop-p): Rename to `lisp-extended-loop-p'.

2015-03-14  Michael R. Mauger  <michael@mauger.com>

	* progmodes/sql.el: Version 3.5
	(sql-starts-with-prompt-re, sql-ends-with-prompt-re): Match password prompts.
	(sql-interactive-remove-continuation-prompt): Fix regression. (Bug#6686)

2015-03-14  Daniel Colascione  <dancol@dancol.org>

	* widget.el (define-widget): Check that documentation is a string
	or nil; prevent wailing and gnashing of teeth when users forget to
	pass a docstring and wonder why their properties don't work.

	* startup.el (command-line): Process "--no-x-resources".

2015-03-13  Kevin Ryde  <user42_kevin@yahoo.com.au>

	info-look fixes for Texinfo 5
	* info-look.el (c-mode, bison-mode, makefile-mode)
	(makefile-automake-mode, texinfo-mode, autoconf-mode, awk-mode)
	(latex-mode, emacs-lisp-mode, sh-mode, cfengine-mode):
	Match `foo' and 'foo' and ‘foo’ for @item and similar.
	(latex-mode): Match multi-arg \frac{num}{den} or \sqrt[root]{n} in
	suffix regexp.

2015-03-12  Juri Linkov  <juri@linkov.net>

	* simple.el (next-line-or-history-element)
	(previous-line-or-history-element): Remember the goal column of
	possibly multi-line input, and restore it afterwards.  (Bug#19824)

2015-03-12  Rasmus Pank Roulund  <emacs@pank.eu>

	* ido.el (ido-add-virtual-buffers-to-list): Include bookmark-alist
	files (bug#19335).

2015-03-12  Eli Zaretskii  <eliz@gnu.org>

	* international/fontset.el (script-representative-chars): Add a
	representative character for 'vai'.

2015-03-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* international/quail.el (quail-input-method):
	Use with-silent-modifications.

	* simple.el (goto-history-element): Don't burp on t history.

2015-03-10  Paul Eggert  <eggert@cs.ucla.edu>

	Prefer "initialize"
	* progmodes/js.el (js-indent-first-init):
	Rename from js-indent-first-initialiser, to avoid worrying about
	American vs British spelling.  All uses changed.

2015-03-10  Glenn Morris  <rgm@gnu.org>

	* progmodes/js.el (js-indent-first-initialiser):
	Fix doc, type, version.

2015-03-10  Jackson Ray Hamilton  <jackson@jacksonrayhamilton.com>

	* progmodes/js.el (js-indent-first-initialiser): New option.
	(js--maybe-goto-declaration-keyword-end): New function.
	(js--proper-indentation): Use js--maybe-goto-declaration-keyword-end.

2015-03-10  Thomas Fitzsimmons  <fitzsim@fitzsim.org>

	* net/ldap.el (ldap-attribute-syntaxes-alist): Add LDAP attributes
	from RFC2798 Section 9.1.1.  (Bug#8983)

2015-03-09  Nicolas Petton <nicolas@petton.fr>

	* emacs-lisp/seq.el (seq-into): New function.
	Bump seq.el version to 1.3.

2015-03-09  Dmitry Gutov  <dgutov@yandex.ru>

	* progmodes/ruby-mode.el (ruby-font-lock-keywords): Don't consider
	`=' a part of symbol when followed by `>'.  (Bug#18644)
	(ruby-syntax-before-regexp-re): Detect regexps after `!'.
	(Bug#19285)

2015-03-09  Eli Zaretskii  <eliz@gnu.org>

	* dired.el (dired-delete-file): Doc fix.  (Bug#20021)

2015-03-06  Sergio Durigan Junior  <sergiodj@sergiodj.net>
	    Thomas Fitzsimmons  <fitzsim@fitzsim.org>

	* net/eudcb-bbdb.el (eudc-bbdb-field): New function.
	(eudc-bbdb-filter-non-matching-record): Call eudc-bbdb-field.
	(eudc-bbdb-format-record-as-result): Likewise.

2015-03-08  Dmitry Gutov  <dgutov@yandex.ru>

	* progmodes/ruby-mode.el (ruby-font-lock-keywords):
	Use `font-lock-constant-face' for nil, true and false.
	Highlight `self' as a keyword.  (Bug#17733)

2015-03-08  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* progmodes/ruby-mode.el (ruby-syntax-before-regexp-re):
	Expect beginning of regexp also after open brace or vertical bar.
	(Bug#20026)

2015-03-07  Stefan Monnier  <monnier@iro.umontreal.ca>

	* battery.el (battery-echo-area-format): Simplify default.
	(battery-linux-sysfs): Standardize on energy&power.  Accept ADP1
	for AC adapter.

	* emacs-lisp/byte-opt.el (byte-optimize-form-code-walker): Don't try to
	unfold `closure's since byte-compile-unfold-lambda doesn't know how to
	do it.

2015-03-06  Oscar Fuentes  <ofv@wanadoo.es>

	* net/browse-url.el (browse-url-firefox): Remove outdated
	MS-Windows limitations.

2015-03-06  Thomas Fitzsimmons  <fitzsim@fitzsim.org>

	* net/eudcb-ldap.el (eudc-ldap-cleanup-record-simple): Mark as
	obsolete.
	(eudc-ldap-cleanup-record-filtering-addresses): Add docstring.
	Don't clean up postal addresses if ldap-ignore-attribute-codings
	is set.  Combine mail addresses into one field. (Bug#17720)
	(eudc-ldap-simple-query-internal):
	Call eudc-ldap-cleanup-record-filtering-addresses instead of
	eudc-ldap-cleanup-record-simple.
	(eudc-ldap-get-field-list): Likewise.

2015-03-05  Ivan Shmakov  <ivan@siamics.net>

	* net/eww.el (eww-html-p): New function (bug#20009).
	(eww-render): Use it.

2015-03-05  Artur Malabarba  <bruce.connor.am@gmail.com>

	* desktop.el (desktop-buffer-info): Write docstring.
	(desktop-buffer-info): Use `pushnew' instead of `add-to-list' and
	unquote lamda.

	* emacs-lisp/package.el (package-refresh-contents): Update doc.

2015-03-05  Dmitry Gutov  <dgutov@yandex.ru>

	* progmodes/js.el (js-mode-syntax-table): Add an entry for `.

2015-03-05  Stefan Monnier  <monnier@iro.umontreal.ca>

	Replace *-function vars with generic functions in cl-generic.
	* emacs-lisp/cl-generic.el (cl--generic-generalizer): New struct.
	(cl-generic-tagcode-function, cl-generic-tag-types-function): Remove.
	(cl--generic-t-generalizer): New const.
	(cl--generic-make-method): Rename from `cl--generic-method-make'.
	(cl--generic-make): Change calling convention.
	(cl--generic): Add `options' field.
	(cl-generic-function-options): New function.
	(cl-defgeneric): Rewrite handling of options.  Add support for :method
	options and allow the use of a default body.
	(cl-generic-define): Save options in the corresponding new field.
	(cl-defmethod): Fix ordering of qualifiers.
	(cl-generic-define-method): Use cl-generic-generalizers.
	(cl--generic-get-dispatcher): Change calling convention, and change
	calling convention of the returned function as well so as to take the
	list of methods separately from the generic function object, so that it
	can receive the original generic function object.
	(cl--generic-make-next-function): New function, extracted from
	cl--generic-make-function.
	(cl--generic-make-function): Use it.
	(cl-generic-method-combination-function): Remove.
	(cl--generic-cyclic-definition): New error.
	(cl-generic-call-method): Take a generic function object rather than
	its name.
	(cl-method-qualifiers): New alias.
	(cl--generic-build-combined-method): Use cl-generic-combine-methods,
	don't segregate by qualifiers here any more.
	(cl--generic-standard-method-combination): Segregate by qualifiers
	here instead.  Add support for the `:extra' qualifier.
	(cl--generic-cache-miss): Move earlier, adjust to new calling convention.
	(cl-generic-generalizers, cl-generic-combine-methods):
	New generic functions.
	(cl-no-next-method, cl-no-applicable-method, cl-no-primary-method):
	Use the new "default method in defgeneric" functionality, change
	calling convention to receive a generic function object.
	(cl--generic-head-used): New var.
	(cl--generic-head-generalizer, cl--generic-eql-generalizer)
	(cl--generic-struct-generalizer, cl--generic-typeof-generalizer):
	New consts.
	* emacs-lisp/eieio-core.el (eieio--generic-generalizer)
	(eieio--generic-subclass-generalizer): New consts.
	(cl-generic-generalizers): New methods.
	* emacs-lisp/eieio-compat.el (eieio--generic-static-symbol-generalizer)
	(eieio--generic-static-object-generalizer): New consts.
	(cl-generic-generalizers) <(head eieio--static)>: New method.
	* emacs-lisp/byte-opt.el (byte-optimize-form-code-walker):
	Unfold closures like lambdas.

2015-03-04  Filipp Gunbin  <fgunbin@fastmail.fm>

	* autorevert.el (auto-revert-notify-add-watch):
	Fix handler installation.  (Bug#20000)

2015-03-04  Rüdiger Sonderfeld  <ruediger@c-plusplus.net>

	* net/eww.el (eww-search-prefix, eww-open-file, eww-search-words)
	(eww-same-page-p,eww-set-character-encoding): Fix docstring.
	(eww): Do not end error messages with a period.

2015-03-04  Zhongwei Yao  <ashi08104@gmail.com>

	* net/tramp-adb.el (tramp-adb-connect-if-not-connected):
	New user option.
	(tramp-adb-ls-toolbox-regexp): Fix regexp in order to support file
	names starting with a space.
	(tramp-methods): Add `tramp-default-port' for "adb".
	(tramp-adb-parse-device-names): Add traces.  Return device names
	with port, if present.
	(tramp-adb-handle-directory-files-and-attributes): Quote all
	remote file names.
	(tramp-adb-get-device): New defun.
	(tramp-adb-execute-adb-command, tramp-adb-maybe-open-connection):
	Use it.
	(tramp-adb-maybe-open-connection): Set `tramp-current-*'
	variables.  Remove checks for listed devices.

2015-03-04  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp.el (tramp): Add :link property.
	(tramp-login-prompt-regexp): Allow also "user", as required by
	Fritz!Box telnet.
	(tramp-autoload-file-name-handler): Use "/".
	(tramp-handle-unhandled-file-name-directory): Return nil when
	required by the spec.

	* net/tramp-cache.el (tramp-dump-connection-properties):
	Use `with-temp-file'.

	* net/tramp-sh.el (tramp-perl-file-attributes)
	(tramp-perl-directory-files-and-attributes): Escape apostrophes in
	file names.
	(tramp-do-file-attributes-with-stat): Quote file name.
	(tramp-sh-handle-directory-files-and-attributes): Fall back to
	`tramp-handle-directory-files-and-attributes' in case of problems.
	(tramp-do-directory-files-and-attributes-with-stat)
	(tramp-sh-handle-file-name-all-completions)
	(tramp-sh-handle-delete-directory)
	(tramp-sh-handle-expand-file-name, tramp-sh-handle-process-file):
	Normalize use of "cd".
	(tramp-do-directory-files-and-attributes-with-stat): Use the
	`quoting-style' arg of `ls' if possible.  Make it also working for
	file names with apostrophes.
	(tramp-sh-handle-file-name-all-completions): Use arguments of `ls'
	in proper order.
	(tramp-do-copy-or-rename-file-via-buffer)
	(tramp-sh-handle-file-local-copy): Use `with-temp-file'.
	(tramp-get-remote-locale): Accept also \r in output.
	(tramp-get-ls-command-with-quoting-style): New defun.
	(tramp-get-inline-coding): Set `default-directory' to a local
	directory.  Sporadically, `call-process-region' does not handle a
	remote default directory properly.

	* net/trampver.el: Update release number.

2015-03-03  Agustín Martín Domingo  <agustin6martin@gmail.com>

	* textmodes/ispell.el (ispell-aspell-find-dictionary): Make sure
	.dat files for aspell dicts are also searched for in location
	described by `ispell-aspell-dict-dir', matching aspell's dict-dir
	variable.

2015-03-03  Agustín Martín Domingo  <agustin6martin@gmail.com>

	* textmodes/ispell.el (ispell-dicts-name2locale-equivs-alist)
	(ispell-hunspell-fill-dictionary-entry)
	(ispell-find-hunspell-dictionaries)
	(ispell-set-spellchecker-params): New generic name for
	`ispell-hunspell-dictionary-equivs-alist'.
	(ispell-aspell-add-aliases): Also use
	`ispell-dicts-name2locale-equivs-alist' to get aspell aliases for
	standard dict names.

2015-03-03  Glenn Morris  <rgm@gnu.org>

	* net/browse-url.el (browse-url-firefox-startup-arguments):
	Make obsolete.
	(browse-url-firefox): Doc fix.  Remove -remote, which no longer
	exists in Firefox 36.  (Bug#19921)
	(browse-url-firefox-sentinel): Remove function.

2015-03-03  Eli Zaretskii  <eliz@gnu.org>

	* frame.el (blink-cursor-timer-function): Don't increment
	blink-cursor-blinks-done counter when a menu is active on a w32
	frame.  (Bug#19925)

2015-03-03  Juri Linkov  <juri@linkov.net>

	* comint.el (comint-line-beginning-position): Revert searching for
	the prompt when comint-use-prompt-regexp is non-nil because it
	doesn't distinguish input from output.  Check the field property
	`output' for the case when comint-use-prompt-regexp is nil.
	(Bug#19710)

2015-03-03  Jérémy Compostella  <jeremy.compostella@gmail.com>

	* net/tramp-sh.el (tramp-remote-process-environment): Disable paging
	with PAGER=cat.  (Bug#19870)

2015-03-03  Glenn Morris  <rgm@gnu.org>

	* textmodes/flyspell.el (flyspell-duplicate-distance):
	Bump :version.

2015-03-03  Eli Zaretskii  <eliz@gnu.org>

	* textmodes/text-mode.el (text-mode-syntax-table): Make some
	punctuation character behave as word-constituent, for more
	compatibility with Unicode.

	* simple.el (transient-mark-mode): Doc fix.  (Bug#19841)

2015-03-03  Agustín Martín Domingo  <agustin6martin@gmail.com>

	Improve string search in `flyspell-word-search-*`. (Bug#16800)
	* textmodes/flyspell.el (flyspell-duplicate-distance):
	Limit default search distance for duplicated words to 40000.
	(flyspell-word-search-backward, flyspell-word-search-forward):
	Search as full word with defined casechars, not as substring.

2015-03-03  Juri Linkov  <juri@linkov.net>

	Better support for the case of typing RET on the prompt in comint.
	* comint.el (comint-get-old-input-default): Go to the field end
	when comint-use-prompt-regexp is nil.
	(comint-line-beginning-position): Check if point is already
	on the prompt before searching for the prompt when
	comint-use-prompt-regexp is non-nil.  (Bug#19710)

2015-03-03  Eli Zaretskii  <eliz@gnu.org>

	* frame.el (frame-notice-user-settings): Refresh the value of
	frame parameters after calling tty-handle-reverse-video.
	Call face-set-after-frame-default with the actual parameters, to avoid
	resetting colors back to unspecified.
	(set-background-color, set-foreground-color): Pass the foreground
	and background colors to face-set-after-frame-default.  (Bug#19802)

2015-03-03  Wolfgang Jenkner  <wjenkner@inode.at>

	* net/network-stream.el (network-stream-open-tls): Respect the
	:end-of-capability setting.

2015-03-03  Juri Linkov  <juri@linkov.net>

	Revert the previous change of comint-line-beginning-position callers,
	and modify comint-line-beginning-position instead.

	* comint.el (comint-history-isearch-search)
	(comint-history-isearch-message, comint-history-isearch-wrap):
	Use comint-line-beginning-position instead of field-beginning.
	(comint-send-input): Use either end-of-line or field-end
	depending on comint-use-prompt-regexp.
	(comint-line-beginning-position): Search backward
	for comint-prompt-regexp if comint-use-prompt-regexp is non-nil.
	Use field-beginning instead of line-beginning-position
	if comint-use-prompt-regexp is nil.  (Bug#19710)

2015-03-03  Robert Pluim  <rpluim@gmail.com>  (tiny change)

	* calendar/todo-mode.el (todo-item-done): When done items are
	hidden, restore point to its location prior to invoking this
	command.  (Bug#19727)

2015-03-03  Eli Zaretskii  <eliz@gnu.org>

	* textmodes/artist.el (artist-ellipse-compute-fill-info):
	Use mapcar, not mapc, to create the other half of fill-info.
	(Bug#19763)

2015-03-03  Nicolas Petton  <nicolas@petton.fr>

	* emacs-lisp/authors.el (authors-ignored-files)
	(authors-renamed-files-alist): Additions.

2015-03-03  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp.el (tramp-ssh-controlmaster-options): Don't use a
	tempfile for ControlPath.  (Bug#19702)

2015-03-03  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp.el (tramp-ssh-controlmaster-options): Use "%C" for
	ControlPath if possible.  (Bug#19702)

2015-03-03  Glenn Morris  <rgm@gnu.org>

	* emacs-lisp/authors.el (authors-obsolete-files-regexps)
	(authors-valid-file-names, authors-renamed-files-alist): Additions.

2015-03-03  Alan Mackenzie  <acm@muc.de>

	CC Mode: Stop Font Lock forcing fontification from BOL.  (Bug#19669)
	* progmodes/cc-mode.el (c-font-lock-init):
	Set font-lock-extend-region-functions to nil.

2015-03-03  Daniel Colascione  <dancol@dancol.org>

	* emacs-lisp/generator.el: Make globals conform to elisp
	style throughout.  Use more efficient font-lock patterns.
	(cps-inhibit-atomic-optimization): Rename from
	`cps-disable-atomic-optimization'.
	(cps--gensym): New macro; replaces `cl-gensym' throughout.
	(cps-generate-evaluator): Move the `iter-yield' local macro
	definition here
	(iter-defun, iter-lambda): from here.

	(iter-defun): Use `macroexp-parse-body'.

2015-03-03  Daniel Colascione  <dancol@dancol.org>

2015-03-03  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/gud.el: Use lexical-binding (bug#19966).

	* emacs-lisp/gv.el (gv-ref): Warn about likely problematic cases.

2015-03-03  Daniel Colascione  <dancol@dancol.org>

	* emacs-lisp/generator.el: Make globals conform to elisp
	style throughout.  Use more efficient font-lock patterns.
	(cps-inhibit-atomic-optimization): Rename from
	`cps-disable-atomic-optimization'.
	(cps--gensym): New macro; replaces `cl-gensym' throughout.
	(cps-generate-evaluator): Move the `iter-yield' local macro
	definition here...
	(iter-defun, iter-lambda): ...from here.

2015-03-03  Artur Malabarba  <bruce.connor.am@gmail.com>

	* emacs-lisp/package.el (package-autoremove): Fix if logic.

2015-03-03  Martin Rudalics  <rudalics@gmx.at>

	* window.el (window--dump-frame): For pixel height return total
	number of frame's lines.

2015-03-03  Daniel Colascione  <dancol@dancol.org>

	* emacs-lisp/cl-macs.el (cl-iter-defun): Add cl-iter-defun.

	* emacs-lisp/generator.el (iter-defun): Correctly propagate
	docstrings and declarations to underlying function.

2015-03-02  Daniel Colascione  <dancol@dancol.org>

	* emacs-lisp/generator.el: New file.

	* vc/vc.el (vc-responsible-backend): Add autoload cookie for
	`vc-responsible-backend'.

2015-03-01  Michael Albinus  <michael.albinus@gmx.de>

	* vc/vc-hooks.el (vc-state, vc-working-revision):
	Use `vc-responsible-backend' in order to support unregistered files.

	* vc/vc-rcs.el (vc-rcs-unregister): Support unregistered files.

	* vc/vc-rcs.el (vc-rcs-fetch-master-state):
	* vc/vc-sccs.el (vc-sccs-working-revision): Handle undefined
	master name.

	* vc/vc-src.el (vc-src-working-revision): Do not return an empty string.

2015-03-01  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/shr.el (shr-insert): Remove soft hyphens.
	(shr-insert): Also remove soft hyphens from non-folded text.

2015-02-28  Eli Zaretskii  <eliz@gnu.org>

	* mail/rmailmm.el (rmail-mime-insert-html): Decode HTML payload
	when the charset is only given by the HTML <head>, and allow to
	specify the encoding with "C-x RET c".

2015-02-27  Mark Laws  <mdl@60hz.org>

	Support daemon mode on MS-Windows (bug#19688)
	* server.el (server-process-filter): Force GUI frames on
	MS-Windows in daemon mode, even if a TTY frame was requested.

	* frameset.el (frameset-keep-original-display-p): Don't assume
	windows-nt cannot be in daemon mode.

	* frame.el (window-system-for-display): Don't assume windows-nt
	cannot be in daemon mode.

2015-02-26  Ivan Shmakov  <ivan@siamics.net>

	* faces.el (face-list-p): Split from face-at-point.
	(face-at-point): Use it.
	* facemenu.el (facemenu-add-face): Likewise.  (Bug#19912)

2015-02-26  Oscar Fuentes  <ofv@wanadoo.es>

	* vc/vc.el (vc-annotate-switches): New defcustom.
	* vc/vc-bzr.el (vc-bzr-annotate-switches): New defcustom.
	(vc-bzr-annotate-command): Use vc-switches.
	* vc/vc-cvs.el (vc-cvs-annotate-switches): New defcustom.
	(vc-cvs-annotate-command): Use vc-switches.
	* vc/vc-git.el (vc-git-annotate-switches): New defcustom.
	(vc-git-annotate-command): Use vc-switches.
	* vc/vc-hg.el (vc-hg-annotate-switches): New defcustom.
	(vc-hg-annotate-command): Use vc-switches.
	* vc/vc-mtn.el (vc-mtn-annotate-switches): New defcustom.
	(vc-mtn-annotate-command): Use vc-switches.
	* vc/vc-svn.el (vc-svn-annotate-switches): New defcustom.
	(vc-svn-annotate-command): Use vc-switches.

2015-02-26  Alan Mackenzie  <acm@muc.de>

	Handle "#" operator properly inside macro.  Fix coding bug.

	* progmodes/cc-mode.el (c-neutralize-syntax-in-and-mark-CPP):
	On finding a "#" which looks like the start of a macro, check it
	isn't already inside a macro.

	* progmodes/cc-engine.el (c-state-safe-place): Don't record a new
	"safe" position into the list of them when this is beyond our
	current position.

2015-02-26  Martin Rudalics  <rudalics@gmx.at>

	* menu-bar.el (menu-bar-non-minibuffer-window-p): Return nil when
	the menu frame is dead.  (Bug#19728)

2015-02-26  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	python.el: Handle tabs in python-indent-dedent-line.
	* progmodes/python.el (python-indent-dedent-line): Fixes for
	indentation with tabs.  Thanks to <dale@codefu.org> (Bug#19730).

2015-02-26  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	* progmodes/python.el (python-indent-context): Respect user
	indentation after comment.

2015-02-26  Tassilo Horn  <tsdh@gnu.org>

	* textmodes/reftex-vars.el (featurep): Conditionalize value of
	reftex-label-regexps in order to stay compatible with XEmacs 21.5
	which has no explicitly numbered groups in regexps (bug#19714).

2015-02-26  Daiki Ueno  <ueno@gnu.org>

	* net/dbus.el (dbus-register-signal): Convert "N" of ":argN" to
	integer before comparison.

2015-02-25  Nicolas Richard  <theonewiththeevillook@yahoo.fr>

	* progmodes/elisp-mode.el (elisp--eval-last-sexp): Document argument.

2015-02-25  Oleh Krehel  <ohwoeowho@gmail.com>

	* emacs-lisp/check-declare.el (check-declare-warn):
	Use compilation-style warnings.
	(check-declare-files): Make sure that
	`check-declare-warning-buffer' is in `compilation-mode'.

2015-02-25  Oleh Krehel  <ohwoeowho@gmail.com>

	* emacs-lisp/check-declare.el (check-declare-ext-errors):
	New defcustom.
	(check-declare): New defgroup.
	(check-declare-verify): When `check-declare-ext-errors' is
	non-nil, warn about an unfound function, instead of saying
	"skipping external file".

2015-02-25  Tassilo Horn  <tsdh@gnu.org>

	* textmodes/reftex-vars.el (reftex-include-file-commands):
	Call reftex-set-dirty on changes.

2015-02-25  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/edebug.el (edebug--display): Save-excursion (bug#19611).
	* emacs-lisp/debug.el (debugger-env-macro): Remove redundant
	save-excursion.

2015-02-24  Glenn Morris  <rgm@gnu.org>

	* mail/rmailsum.el (rmail-summary-previous-all)
	(rmail-summary-previous-msg): Simplify.

2015-02-25  Artur Malabarba  <bruce.connor.am@gmail.com>

	* simple.el (region-active-p): Fix doc to say non-nil.

2015-02-24  Samer Masterson  <nosefrog@gmail.com>

	* eshell/em-hist.el (eshell-hist-parse-word-designator):
	Return args joined with " ".
	* eshell/em-pred.el (eshell-parse-modifiers): Correct docstring.
	(eshell-hist-parse-modifier): Pass mod a list instead of a string
	(bug#18960).

2015-02-24  Karl Fogel  <kfogel@red-bean.com>  (tiny change)

	* comint.el (comint-mode-map): Fix obvious typo.

2015-02-24  Johan Claesson  <johanclaesson@bredband.net>  (tiny change)

	* filecache.el (file-cache-filter-regexps):
	Add lock files.  (Bug#19516)

2015-02-24  Glenn Morris  <rgm@gnu.org>

	* mail/rmailsum.el (rmail-summary-next-all)
	(rmail-summary-previous-all, rmail-summary-next-msg):
	Fix handling of optional argument.  (Bug#19916)

	* progmodes/f90.el (f90-beginning-of-subprogram)
	(f90-end-of-subprogram, f90-match-end):
	Handle continued strings where the continuation does not start
	with "&" and happens to match our regexp.  (Bug#19809)

2015-02-24  Bozhidar Batsov  <bozhidar@batsov.com>

	* comint.el (comint-clear-buffer): New command.
	(comint-mode-map): Bind `comint-clear-buffer' to 'C-c M-o'.

2015-02-23  Pete Williamson  <petewil0@googlemail.com>  (tiny change)

	Use ${EXEEXT} more uniformly in makefiles
	* Makefile.in (EMACS): Append ${EXEEXT}.

2015-02-23  Sam Steingold  <sds@gnu.org>

	* files.el (recover-session): Handle `auto-save-list-file-prefix'
	being a directory (empty non-directory part).

2015-02-23  Magnus Henoch  <magnus.henoch@gmail.com>

	* net/sasl.el (sasl-mechanism-alist): Refer to sasl-scram-rfc
	instead of sasl-scram-sha-1, as the former is the name that can be
	required.

	* net/sasl-scram-rfc.el (sasl-scram-sha-1-steps)
	(sasl-scram-sha-1-client-final-message)
	(sasl-scram-sha-1-authenticate-server): Move to end of file.

2015-02-23  Paul Eggert  <eggert@cs.ucla.edu>

	* bindings.el (ctl-x-map): Use [?\C-\;] to get the desired binding.
	(Bug#19826)

2015-02-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/macroexp.el (macroexp-parse-body): Handle cl-declare
	and :documentation.  Change return value format accordingly.
	* emacs-lisp/cl-generic.el (cl--generic-lambda):
	* emacs-lisp/pcase.el (pcase-lambda): Adjust accordingly.
	* emacs-lisp/cl-macs.el (cl--transform-lambda): Use macroexp-parse-body.

2015-02-23  Dmitry Gutov  <dgutov@yandex.ru>

	Introduce `xref-etags-mode'.
	* progmodes/xref.el (xref-etags-mode--saved): New variable.
	(xref-etags-mode): New minor mode.  (Bug#19466)

2015-02-22  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* dom.el (dom-previous-sibling): New function.

2015-02-21  Paul Eggert  <eggert@cs.ucla.edu>

	* bindings.el (ctl-x-map): There is no 'C-;'.
	For now, make do with 'M-;'; this allows 'make bootstrap' to work.
	Perhaps some other binding should be chosen.  (Bug#19826)

2015-02-21  Artur Malabarba  <bruce.connor.am@gmail.com>

	* bindings.el (ctl-x-map): Fix `comment-line' binding.  (Bug#19826)

2015-02-21  Michael Albinus  <michael.albinus@gmx.de>

	* autorevert.el (auto-revert-notify-add-watch)
	(auto-revert-notify-handler, auto-revert-buffers): Handle also
	buffers without an associated file, like dired buffers.  (Bug#16112)

2015-02-21  Dima Kogan  <dima@secretsauce.net>

	* autorevert.el (auto-revert-mode, auto-revert-tail-mode)
	(global-auto-revert-mode): Remove (let (auto-revert-use-notify) ... )
	wrappers.  Call (auto-revert-buffers) consequently in order to
	install handlers.

2015-02-21  Wilson Snyder  <wsnyder@wsnyder.org>

	Sync with upstream verilog-mode revision 0d6420b.
	* progmodes/verilog-mode.el (verilog-mode-version): Update.
	(vector-skip-list): Remove.
	(verilog-auto-inst-port, verilog-auto-inst-port-list)
	(verilog-auto-inst, verilog-auto-inst-param):
	Use arguments rather than vector-skip.
	(verilog-auto-inst-port): Fix AUTOINST interfaces to not show
	modport if signal attachment is itself a modport.
	Reported by Matthew Lovell.

2015-02-21  Reto Zimmermann  <reto@gnu.org>

	Sync with upstream vhdl mode v3.37.1.  Add VHDL'08 support.
	* progmodes/vhdl-mode.el (vhdl-version, vhdl-time-stamp)
	(vhdl-doc-release-notes): Update.
	(vhdl-standard): Add VHDL'08 option.
	(vhdl-sensitivity-list-all): New option.
	(vhdl-directive-keywords): Add psl.
	(vhdl-offsets-alist-default, vhdl-mode-abbrev-table-init)
	(vhdl-template-construct-alist-init, vhdl-create-mode-menu):
	(vhdl-imenu-generic-expression): Add context, directive.
	(vhdl-offsets-alist, vhdl-mode, vhdl-doc-keywords): Doc fixes.
	(vhdl-template-map-init): Add vhdl-template-context.
	(vhdl-mode-syntax-table): Support VHDL'08 block comments.
	(vhdl-create-mode-menu): Add some entries.
	(vhdl-08-keywords, vhdl-08-types, vhdl-08-attributes)
	(vhdl-08-functions, vhdl-08-packages, vhdl-08-directives):
	New constants.
	(vhdl-directives): New variable.
	(vhdl-words-init, vhdl-template-process)
	(vhdl-template-replace-header-keywords): Support VHDL'08.
	(vhdl-abbrev-list-init): Add vhdl-directives.
	(vhdl-in-comment-p, vhdl-in-literal, vhdl-win-il)
	(vhdl-forward-syntactic-ws, vhdl-get-syntactic-context)
	(vhdl-lineup-comment): Handle block comments and directives.
	(vhdl-beginning-of-directive, vhdl-template-context)
	(vhdl-template-context-hook): New functions.
	(vhdl-libunit-re, vhdl-defun-re, vhdl-begin-p)
	(vhdl-corresponding-begin, vhdl-get-library-unit, vhdl-regress-line)
	(vhdl-align-declarations, vhdl-beginning-of-block, vhdl-end-of-block)
	(vhdl-font-lock-keywords-2, vhdl-get-end-of-unit)
	(vhdl-scan-context-clause): Add context.

2015-02-20  Glenn Morris  <rgm@gnu.org>

	* calendar/solar.el (solar-sunrise-sunset-string):
	Shorten message a little.
	(sunrise-sunset): Use message rather than a window.  (Bug#19859)

	* progmodes/f90.el (f90-keywords-re, f90-procedures-re)
	(f90-font-lock-keywords-2): Some F2008 additions.

2015-02-19  Dima Kogan  <dima@secretsauce.net>

	* autorevert.el (auto-revert-buffers-counter)
	(auto-revert-buffers-counter-lockedout): New variables.
	(auto-revert-buffers): Increase `auto-revert-buffers-counter'.
	(auto-revert-notify-handler): Apply `auto-revert-handler' if not
	suppressed by lockout.  (Bug#18958)

2015-02-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/eieio-opt.el (eieio-help-class): `eieio-class-parents'
	returns classes, not class names (bug#19891).

	* emacs-lisp/cl-macs.el (cl-struct-slot-value): Handle a nil type.

	* emacs-lisp/smie.el (smie-prec2->grammar): Fix corner case problem.

2015-02-18  Kelly Dean  <kelly@prtime.org>

	* register.el (jump-to-register):
	* emacs-lisp/lisp.el (check-parens):
	Push mark before goto-char so user doesn't lose his previous place.

2015-02-18  Kelly Dean  <kelly@prtime.org>

	* rect.el (rectangle-mark-mode):
	Suppress superfluous "Mark set" message from push-mark.

2015-02-18  Kelly Dean  <kelly@prtime.org>

	* help-mode.el (help-go-back, help-go-forward, help-follow):
	* simple.el (yank-pop, pop-to-mark-command, exchange-point-and-mark):
	* winner.el (winner-redo):
	* windmove.el (windmove-do-window-select):
	* register.el (jump-to-register, increment-register, insert-register)
	(append-to-register, prepend-to-register):
	* files.el (find-alternate-file, abort-if-file-too-large, write-file)
	(set-visited-file-name):
	* emacs-lisp/lisp.el (kill-backward-up-list):
	Use user-error instead of error.  (Bug#14480)

2015-02-18  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/checkdoc.el (checkdoc-show-diagnostics): Don't make bogus
	assumptions about window ordering.

2015-02-16  Kelly Dean  <kelly@prtime.org>

	* files.el (insert-file-contents-literally): Fix docstring typo.

2015-02-16  Kelly Dean  <kelly@prtime.org>

	* emacs-lisp/easy-mmode.el (define-minor-mode): Process macro
	arguments correctly. (Bug#19685)
	(define-minor-mode): Clarify docstring.
	Clarify mode switch messages for minor modes.  (Bug#19690)

2015-02-16  Kelly Dean  <kelly@prtime.org>

	* emacs-lisp/package-x.el (package-upload-buffer-internal):
	Create valid tar files.  (Bug#19536)

2015-02-16  Kelly Dean  <kelly@prtime.org>

	* desktop.el (desktop-read): Conditionally re-enable desktop autosave.
	(Bug#19059)

2015-02-16  Kelly Dean  <kelly@prtime.org>

	* help-mode.el (help-do-xref): Prevent duplicated display of Info
	buffer, and prevent interference with existing buffer.  (Bug#13190)

2015-02-16  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	python.el: Do not deactivate mark on shell fontification.  (Bug#19871)

	* progmodes/python.el (python-shell-font-lock-post-command-hook):
	Do not deactivate mark on fontification.

2015-02-16  Ivan Shmakov  <ivan@siamics.net>

	* net/eww.el: Fix desktop support.  (Bug#19226)
	(eww-mode): Add autoload cookie.
	(eww-restore-desktop): Use inhibit-read-only.

	* net/eww.el (eww-suggest-uris): Add autoload cookie, so that
	add-hook works correctly even if the file is not yet loaded.

2015-02-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/eieio.el (defclass): Use make-instance rather than
	eieio-constructor.
	(set-slot-value): Mark as obsolete.
	(eieio-object-class-name): Improve call to eieio-class-name.
	(eieio-slot-descriptor-name, eieio-class-slots): New functions.
	(object-slots): Use it.  Declare obsolete.
	(eieio-constructor): Merge it with `make-instance'.
	(initialize-instance): Use `dolist'.
	(eieio-override-prin1, eieio-edebug-prin1-to-string):
	Use eieio--class-print-name.

	* emacs-lisp/eieio-core.el (eieio--class-print-name): New function.
	(eieio-class-name): Make it do what the docstring claims.
	(eieio-defclass-internal): Simplify since `prots' isn't used any more.
	(eieio--slot-name-index): Simplify accordingly.
	(eieio-barf-if-slot-unbound): Pass the class object rather than its
	name to `slot-unbound'.

	* emacs-lisp/eieio-base.el (make-instance): Add a method here rather
	than on eieio-constructor.

2015-02-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/cl-macs.el (cl-defstruct): Keep type=nil by default.
	* emacs-lisp/cl-preloaded.el (cl-struct-define): Add sanity checks
	about relationship between `type', `named', and `slots'.
	* emacs-lisp/cl-generic.el (cl--generic-struct-tagcode): Adjust to new
	value of `cl-struct-type' property.

2015-02-15  Jérémy Compostella  <jeremy.compostella@gmail.com>

	* net/tramp-sh.el (tramp-remote-process-environment): Disable paging
	with PAGER=cat.  (Bug#19870)

2015-02-14  Artur Malabarba  <bruce.connor.am@gmail.com>

	* emacs-lisp/package.el (package-read-all-archive-contents):
	Don't build the compatibility table.
	(package-refresh-contents, package-initialize): Do build the
	compatibility table.
	(package--build-compatibility-table): New function.
	(describe-package-1): Describe why a package is incompatible.

2015-02-14  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/cl-preloaded.el (cl-struct-define): Register as children
	of the parent.
	(cl--assertion-failed): New function.
	(cl-assertion-failed): Move in from cl-lib.el.

	* emacs-lisp/cl-macs.el (cl-defstruct): Don't generate code to register
	as children of its parents.
	(cl--make-type-test, cl--compiler-macro-typep): Remove functions.
	(cl-typep): Reimplement using define-inline.
	(cl-assert): Use cl--assertion-failed.
	(cl-struct-slot-value): Use define-inline.

	* emacs-lisp/cl-lib.el: Move autoloaded code to cl-preload.

	* textmodes/flyspell.el (flyspell-word): Defvar (bug#19844).
	(flyspell-generic-check-word-p): Mark as obsolete.

2015-02-13  Artur Malabarba  <bruce.connor.am@gmail.com>

	* emacs-lisp/package.el (package--compatibility-table): New var.
	(package--add-to-compatibility-table): New function.
	(package-read-all-archive-contents): Populate compatibility table.
	(package--incompatible-p): Also look in dependencies.
	(describe-package-1): Fix "incompat" handling.

2015-02-13  Lars Ingebrigtsen  <larsi@gnus.org>

	* net/rfc2104.el: Moved here from lisp/gnus.

2015-02-13  Magnus Henoch  <magnus.henoch@gmail.com>

	* net/sasl-scram-rfc.el: New file.

	* net/sasl.el (sasl-mechanisms): Remove SCRAM-MD5.
	Add SCRAM-SHA-1 first.
	(sasl-mechanism-alist): Remove SCRAM-MD5 entry.  Add SCRAM-SHA-1
	entry (bug#17636).

2015-02-13  Lars Ingebrigtsen  <larsi@gnus.org>

	* net/shr.el (shr-tag-li): Speed up rendering pages with lots of
	<ul>.

2015-02-12  Oleh Krehel  <ohwoeowho@gmail.com>

	* progmodes/gdb-mi.el (gdb-display-io-nopopup): New defcustom.
	(gdb-inferior-filter): Don't pop up the buried output buffer when
	`gdb-display-io-nopopup' is non-nil.

2015-02-12  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	python.el: Allow killing shell buffer if process is dead.  (Bug#19823)

	* progmodes/python.el (python-shell-font-lock-kill-buffer):
	Don't require a running process.
	(python-shell-font-lock-post-command-hook): Fontify only if the
	shell process is running.

2015-02-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* hi-lock.el (hi-lock-unface-buffer): Don't call
	font-lock-remove-keywords if not needed (bug#19796).

2015-02-11  Artur Malabarba  <bruce.connor.am@gmail.com>

	* emacs-lisp/package.el (package-install): Invert the second
	argument, for better backwards compatibility.
	(package-install-button-action, package-reinstall)
	(package-menu-execute): Account for the change.

2015-02-11  Nicolas Petton  <nicolas@petton.fr>

	* emacs-lisp/seq.el (seq-reverse): Add a backward-compatible
	version of seq-reverse that works on sequences in Emacs 24.
	Bump seq.el version to 1.2.

2015-02-11  Artur Malabarba  <bruce.connor.am@gmail.com>

	* emacs-lisp/package.el (package--incompatible-p): New function.
	Return non-nil if PKG has no chance of being installable.
	(package--emacs-version-list): New variable.
	(describe-package-1, package-desc-status)
	(package-menu--print-info, package-menu--status-predicate):
	Account for the "incompat" status.

2015-02-11  Martin Rudalics  <rudalics@gmx.at>

	* frame.el (toggle-frame-maximized, toggle-frame-fullscreen):
	Rename frame parameter `maximized' to `fullscreen-restore'.
	Restore fullwidth/-height after fullboth state.  Update doc-strings.

2015-02-11  Lars Ingebrigtsen  <larsi@gnus.org>

	* net/shr.el (shr-insert): Make sure the space inserted has the
	right font (for width).
	(shr-fill-line): Preserve background colors when indenting/folding.
	(shr-ensure-paragraph): Don't insert a new paragraph as the first
	item in a <li>.

2015-02-10  Lars Ingebrigtsen  <larsi@gnus.org>

	* net/shr.el (shr-use-fonts): New variable.
	(shr-fill-text): Rename from "fold".
	(shr-pixel-column, shr-pixel-region, shr-string-pixel-width):
	New functions.
	(shr-insert): Just insert, don't fill the text.  Filling is now
	done afterwards per display unit.
	(shr-fill-lines, shr-fill-line): New functions to fill text on a
	per-unit base.
	(shr-find-fill-point): Take a "beginning" parameter.
	(shr-indent): Indent using the :width display parameter when using
	fonts.
	(shr-parse-style): Ignore "inherit" values, since we already do that.
	(shr-tag-img): Remove the insertion states.
	(shr-tag-blockquote): New-style filling.
	(shr-tag-dd): Ditto.
	(shr-tag-li): Ditto.
	(shr-mark-fill): New function to mark lines that need filling.
	(shr-tag-h1): Use a larger font.
	(shr-tag-table-1): Get the natural and suggested widths in one
	rendering.
	(shr-tag-table): Create the "fixed" version of the table only once
	so that we can cache data in the table.
	(shr-insert-table): Get colspan calculations right by having
	zero-width columns after colspan ones.
	(shr-expand-alignments): New function to make :align-to specs work
	right when rendered in one buffer and displayed in another one.
	(shr-insert-table-ruler): Use :align-to to get the widths right.
	(shr-make-table): Cache more.
	(shr-make-table-1): Use the new <td> data layout.
	(shr-pixel-buffer-width): New function.
	(shr-render-td): Add a caching layer.
	(shr-dom-max-natural-width): New function.
	(shr-tag-h1): Don't use variable-pitch fonts on fontless rendering.
	(shr-tag-tt): New function.
	(shr-tag-hr): Compute the right length when using fonts.
	(shr-table-widths): Off-by-one error in width computation.
	(shr-expand-newlines): Remove dead code.
	(shr-insert-table): Extend background colors to the end of the column.
	(shr-insert-table): Only copy the background, not underline and
	the like.
	(shr-face-background): New function.

2015-02-10  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	python.el: Improved shell font lock respecting markers.  (Bug#19650)

	* progmodes/python.el
	(python-shell-font-lock-get-or-create-buffer): Use special buffer name.
	(python-shell-font-lock-with-font-lock-buffer): Enable font lock.
	(python-shell-font-lock-post-command-hook): Fontify by copying text
	properties from fontified buffer to shell, keeping markers unchanged.
	(python-shell-font-lock-turn-off): Fix typo.
	(python-util-text-properties-replace-name): Delete function.

2015-02-09  Nicolas Petton  <nicolas@petton.fr>

	* emacs-lisp/seq.el (seq-group-by): Improves seq-group-by to
	return sequence elements in correct order.

2015-02-09  Simen Heggestøyl  <simenheg@gmail.com>  (tiny change)

	* textmodes/css-mode.el (css-smie-rules): Fix paren indent (bug#19815).

2015-02-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/cl-generic.el (cl--generic-lambda): Use macroexp-parse-body.

	* emacs-lisp/eieio-core.el (eieio-oset-default): Catch the unexpected
	case where the default value would be re-interpreted as a form!

2015-02-09  Christopher Genovese  <genovese@cmu.edu>  (tiny change)

	* help-fns.el (help-fns--signature): Keep doc for keymap.

2015-02-09  Kelly Dean  <kelly@prtime.org>

	* desktop.el: Save mark-ring less verbosely.
	(desktop-var-serdes-funs): New var.
	(desktop-buffer-info, desktop-create-buffer): Use it.
	(desktop-file-version): Update to 208.

2015-02-09  Leo Liu  <sdl.web@gmail.com>

	* emacs-lisp/pcase.el (pcase-lambda): New Macro.  (Bug#19814)

	* emacs-lisp/lisp-mode.el (el-kws-re): Include `pcase-lambda'.

	* emacs-lisp/macroexp.el (macroexp-parse-body): New function.

2015-02-08  Paul Eggert  <eggert@cs.ucla.edu>

	Port to platforms lacking test -a and -o
	* Makefile.in (compile-clean):
	* net/tramp-sh.el (tramp-find-executable):
	Prefer '&&' and '||' to 'test -a' and 'test -o'.

2015-02-08  Artur Malabarba  <bruce.connor.am@gmail.com>

	* newcomment.el (comment-line): Fix missing paren.

2015-02-08  Ulrich Müller  <ulm@gentoo.org>

	* play/gamegrid.el: Update comment to reflect that the
	'update-game-score' helper program is now setgid by default.

2015-02-08  David Kastrup  <dak@gnu.org>

	* subr.el (apply-partially): Use lexical binding here.

2015-02-08  Artur Malabarba  <bruce.connor.am@gmail.com>

	* newcomment.el (comment-line): New command.

	* bindings.el (ctl-x-map): Bind to `C-x C-;'.

2015-02-08  Oleh Krehel  <ohwoeowho@gmail.com>

	* outline.el (outline-show-entry): Fix one invisible char for the
	file's last outline.  (Bug#19493)

2015-02-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* subr.el (indirect-function): Change advertised calling convention.

2015-02-08  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	python.el: Fix completion-at-point.  (Bug#19667)

	* progmodes/python.el
	(python-shell-completion-native-get-completions): Force process buffer.
	(python-shell-completion-at-point): Handle case where call is not
	in a shell buffer.

2015-02-08  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	python.el: Fix shell font-lock multiline input.  (Bug#19744)

	* progmodes/python.el
	(python-shell-font-lock-post-command-hook): Handle multiline input.

2015-02-08  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	python.el: Make shell font-lock respect markers.  (Bug#19650)

	* progmodes/python.el (python-shell-font-lock-cleanup-buffer):
	Use `erase-buffer`.
	(python-shell-font-lock-comint-output-filter-function):
	Handle newlines.
	(python-shell-font-lock-post-command-hook): Respect markers on
	text fontification.

2015-02-07  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	python.el: Keep eldoc visible while typing args.  (Bug#19637)
	* progmodes/python.el (python-eldoc--get-symbol-at-point):
	New function based on Carlos Pita <carlosjosepita@gmail.com> patch.
	(python-eldoc--get-doc-at-point, python-eldoc-at-point): Use it.

2015-02-07  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	Fix hideshow integration.  (Bug#19761)
	* progmodes/python.el
	(python-hideshow-forward-sexp-function): New function based on
	Carlos Pita <carlosjosepita@gmail.com> patch.
	(python-mode): Make `hs-special-modes-alist` use it and initialize
	the end regexp with the empty string to avoid skipping parens.

2015-02-07  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	* progmodes/python.el (python-check-custom-command): Do not use
	defvar-local for compat with Emacs<24.3.

2015-02-07  Martin Rudalics  <rudalics@gmx.at>

	* frame.el (frame-notice-user-settings):
	Update `frame-size-history'.
	(make-frame): Update `frame-size-history'.
	Call `frame-after-make-frame'.
	* faces.el (face-set-after-frame-default): Remove call to
	frame-can-run-window-configuration-change-hook.

2015-02-06  Dmitry Gutov  <dgutov@yandex.ru>

	* vc/vc-cvs.el (vc-cvs-dir-status-files): Don't pass DIR to
	`vc-cvs-command' (bug#19732).

2015-02-06  Nicolas Petton  <nicolas@petton.fr>

	* emacs-lisp/seq.el (seq-mapcat, seq-partition, seq-group-by):
	New functions.
	* emacs-lisp/seq.el (seq-drop-while, seq-take-while, seq-count)
	(seq--drop-list, seq--take-list, seq--take-while-list):
	Better docstring.

2015-02-06  Artur Malabarba  <bruce.connor.am@gmail.com>

	* doc-view.el (doc-view-kill-proc-and-buffer): Obsolete. Use
	`image-kill-buffer' instead.

2015-02-06  Thomas Fitzsimmons  <fitzsim@fitzsim.org>

	* net/ldap.el (ldap-search-internal): Fix docstring.

2015-02-06  Lars Ingebrigtsen  <larsi@gnus.org>

	* subr.el (define-error): The error conditions may be constant
	lists, so use `append' to concatenate them.

2015-02-06  Wolfgang Jenkner  <wjenkner@inode.at>

	* net/network-stream.el (network-stream-open-tls): Respect the
	:end-of-capability setting.

2015-02-05  Artur Malabarba  <bruce.connor.am@gmail.com>

	* emacs-lisp/package.el (package--sort-by-dependence):
	New function.  Return PACKAGE-LIST sorted by dependencies.
	(package-menu-execute): Use it to delete packages in order.
	(package--sort-deps-in-alist): New function.
	(package-menu-mark-install): Can mark dependencies.
	(package--newest-p): New function.
	(package-delete): Don't deselect when deleting an older version of
	an upgraded package.

	* emacs-lisp/package.el: Add missing (require 'subr-x)

2015-02-05  Stefan Monnier  <monnier@iro.umontreal.ca>

	* textmodes/css-mode.el (scss-smie--not-interpolation-p): Vars can be
	hyphenated (bug#19263).

	* textmodes/css-mode.el (css-fill-paragraph): Fix filling in presence
	of variable interpolation (bug#19751).

2015-02-05  Era Eriksson  <era+emacs@iki.fi>

	* json.el (json-end-of-file): New error (bug#19768).
	(json-pop, json-read): Use it.

2015-02-05  Kelly Dean  <kelly@prtime.org>

	* help-mode.el (help-xref-interned): Pass BUFFER and FRAME to
	`describe-variable'.

	* help-fns.el (describe-function-or-variable): New function.

	* help.el (help-map): Bind `describe-function-or-variable' to o.
	(help-for-help-internal): Document o key.

2015-02-05  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/eieio-compat.el (eieio--defmethod): Use new
	special (:documentation ...) feature.
	* emacs-lisp/eieio-core.el (eieio-make-class-predicate)
	(eieio-make-child-predicate): Same.
	(eieio-copy-parents-into-subclass): Remove unused arg.
	(eieio-defclass-internal): Adjust call accordingly and remove redundant
	`pname' var.
	(eieio--slot-name-index): Remove unused arg `obj' and adjust all
	callers accordingly.

	* emacs-lisp/cconv.el (cconv--convert-function):
	Add `docstring' argument.
	(cconv-convert): Use it to handle the new (:documentation ...) form.
	(cconv-analyze-form): Handle the new (:documentation ...) form.

	* emacs-lisp/bytecomp.el:
	(byte-compile-initial-macro-environment): Use macroexp-progn.
	(byte-compile-cl-warn): Don't silence use of cl-macroexpand-all.
	(byte-compile-file-form-defvar-function): Rename from
	byte-compile-file-form-define-abbrev-table.
	(defvaralias, byte-compile-file-form-custom-declare-variable): Use it.
	(byte-compile): Use byte-compile-top-level rather than
	byte-compile-lambda so we can compile non-values.
	(byte-compile-form): Add warnings for failed uses of lexical vars via
	quoted symbols.
	(byte-compile-unfold-bcf): Improve message for failed inlining.
	(byte-compile-make-closure): Handle new format of internal-make-closure
	for dynamically-generated docstrings.

	* delsel.el: Deprecate the `kill' option.  Use lexical-binding.
	(open-line): Delete like all other commands, instead of killing.
	(delete-active-region): Don't define any return any value.

	* progmodes/python.el: Try to preserve compatibility with Emacs-24.
	(python-mode): Don't assume eldoc-documentation-function has a non-nil
	default.

2015-02-04  Sam Steingold  <sds@gnu.org>

	* progmodes/python.el (python-indent-calculate-indentation):
	Avoid the error when computing top-level indentation.

2015-02-04  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/cl-generic.el (cl--generic-member-method): Fix paren typo.

	* textmodes/flyspell.el: Use lexical-binding and cl-lib.
	(mail-mode-flyspell-verify): Fix last change.
	(flyspell-external-point-words, flyspell-large-region):
	Avoid add-to-list on local vars.

2015-02-04  Tassilo Horn  <tsdh@gnu.org>

	* emacs-lisp/package.el (package-installed-p): Fix typo causing
	void-variable error.

2015-02-04  Artur Malabarba  <bruce.connor.am@gmail.com>

	* image-mode.el (image-kill-buffer): New command.
	(image-mode-map): Bind it to k.

	* emacs-lisp/package.el (package-delete): Remove package from
	`package-selected-packages' even if it can't be deleted.
	(package-installed-p): Accept package-desc objects.
	(package-install): Can be used to mark dependencies as
	selected. When given a package-desc object which is already
	installed, the package is not downloaded again, but it is marked
	as selected (if it wasn't already).
	(package-reinstall): Accept package-desc objects.

2015-02-03  Artur Malabarba  <bruce.connor.am@gmail.com>

	* emacs-lisp/package.el (package-delete): Document NOSAVE.
	(package--get-deps): delete-dups when ONLY is nil.
	(package-autoremove): Warn the user if `package-selected-packages'
	is empty.

	(package--user-selected-p): New function.
	(package-delete, package-install, package-install-from-buffer):
	Use it
	(package-selected-packages): Mention it.

	(package-initialize): Don't populate `package-selected-packages'.
	(package-install-user-selected-packages, package-autoremove):
	Special handling for empty `package-selected-packages'.
	(package-install): Fix when PKG is a package-desc.

	(package-desc-status): Add "dependency" status to the Package
	Menu.
	(package-menu--status-predicate, package-menu--print-info)
	(package-menu-mark-delete, package-menu--find-upgrades)
	(package-menu--status-predicate, describe-package-1): Use it

	(package--removable-packages): New function.
	(package-autoremove): Use it.
	(package-menu-execute): Offer to remove unneeded packages.

	(package--read-pkg-desc, package-tar-file-info): Fix reference to
	tar-desc.

2015-02-03  Thierry Volpiatto  <thierry.volpiatto@gmail.com>

	* emacs-lisp/package.el (package-reinstall): Don't change package's selected status.
	(package-delete): New NOSAVE argument.

2015-02-03  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp-sh.el (tramp-histfile-override): Fix docstring.
	(tramp-open-shell, tramp-maybe-open-connection): Set also
	HISTFILESIZE and HISTSIZE when needed.  (Bug#19731)

2015-02-02  Artur Malabarba  <bruce.connor.am@gmail.com>

	* emacs-lisp/package.el (package--find-non-dependencies):
	New function.
	(package-initialize): Use it to populate `package-selected-packages'.
	(package-menu-execute): Clean unnecessary `and'.
	(package--get-deps): Fix returning duplicates.

2015-02-02  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp-sh.el (tramp-histfile-override): Add another choice t.
	Use it as default.
	(tramp-open-shell, tramp-maybe-open-connection): Support it.
	(Bug#19731)

2015-02-02  Thierry Volpiatto  <thierry.volpiatto@gmail.com>

	* emacs-lisp/package.el (package-delete): Remove package from
	package-selected-packages.
	(package-autoremove): Remove unneeded variable.

2015-02-01  Artur Malabarba  <bruce.connor.am@gmail.com>

	* emacs-lisp/package.el (package-selected-packages): Fix :type
	(package-install): Rename ARG to MARK-SELECTED.
	(package--get-deps): Fix for indirect dependencies.
	(package-used-elsewhere-p): Rename to
	(package--used-elsewhere-p): New function.
	(package-reinstall, package-user-selected-packages-install)
	(package-autoremove): Use sharp-quote.
	(package-user-selected-packages-install): Reindent and rename to
	(package-install-user-selected-packages): New function.

2015-02-01  Thierry Volpiatto  <thierry.volpiatto@gmail.com>

	* emacs-lisp/package.el: Don't allow deleting dependencies.

	(package-used-elsewhere-p): New function.
	(package-delete): Use it, return now an error when trying to
	delete a package used as dependency by another package.

	Add a reinstall package command.
	(package-reinstall): New function.

	Add a package-autoremove command.
	(package-selected-packages): New user var.
	(package-install): Add an optional arg to notify interactive use.
	Fix docstring. Save installed package to
	packages-installed-directly.
	(package-install-from-buffer): Same.
	(package-user-selected-packages-install): Allow installing all
	packages in packages-installed-directly at once.
	(package--get-deps): New function.
	(package-autoremove): New function.
	(package-install-button-action): Call package-install with
	interactive arg.
	(package-menu-execute): Same but only for only for not installed
	packages.

2015-01-31  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/eieio.el (defclass): Use new eieio-make-class-predicate
	and eieio-make-child-predicate.
	(eieio-class-parents): Use eieio--class-object.
	(slot-boundp, find-class, eieio-override-prin1): Avoid class-p.
	(slot-exists-p): Use find-class.

	* emacs-lisp/eieio-opt.el (eieio-help-class, eieio-help-constructor):
	Use find-lisp-object-file-name, help-fns-short-filename and new calling
	convention for eieio-class-def.
	(eieio-build-class-list): Remove function, unused.
	(eieio-method-def): Remove button type, unused.
	(eieio-class-def): Inherit from help-function-def.
	(eieio--defclass-regexp): New constant.
	(find-function-regexp-alist): Use it.
	(eieio--specializers-apply-to-class-p): Handle eieio--static as well.
	(eieio-help-find-method-definition, eieio-help-find-class-definition):
	Remove functions.

	* emacs-lisp/eieio-core.el (eieio--check-type): Remove.
	Use cl-check-type everywhere instead.
	(eieio-class-object): Remove, use find-class instead when needed.
	(class-p): Don't inline.
	(eieio-object-p): Check more thoroughly, so we don't treat cl-structs,
	such as eieio classes, as objects.  Don't inline.
	(object-p): Mark as obsolete.
	(eieio-defclass-autoload, eieio-defclass-internal, eieio-oref)
	(eieio--generic-tagcode): Avoid `class-p'.
	(eieio-make-class-predicate, eieio-make-child-predicate): New functions.
	(eieio-defclass-internal): Use current-load-list rather than
	`class-location'.

	* emacs-lisp/cl-generic.el (cl--generic-search-method): Fix regexp.

2015-01-30  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/backquote.el (backquote-delay-process): Don't reuse `s'
	since it may be "equivalent" in some sense, yet different (bug#19734).

2015-01-30  Oleh Krehel  <ohwoeowho@gmail.com>

	* outline.el (outline-font-lock-face): Add docstring.
	(outline-invisible-p): Improve docstring.
	(outline-invent-heading): Add docstring.
	(outline-promote): Improve docstring.
	(outline-demote): Improve docstring.
	(outline-head-from-level): Improve docstring.
	(outline-end-of-heading): Add docstring.
	(outline-next-visible-heading): Improve docstring.
	(outline-previous-visible-heading): Improve docstring.
	(outline-hide-region-body): Improve docstring.
	(outline-flag-subtree): Add docstring.
	(outline-end-of-subtree): Add docstring.
	(outline-headers-as-kill): Improve docstring.

2015-01-30  Oleh Krehel  <ohwoeowho@gmail.com>

	* outline.el (outline-hide-entry): Rename from `hide-entry'.
	(hide-entry): Declare as obsolete.
	(outline-show-entry): Rename from `show-entry'.
	(show-entry): Declare as obsolete.
	(outline-hide-body): Rename from `hide-body'.
	(hide-body): Declare as obsolete.
	(outline-hide-region-body): Rename from `hide-region-body'.
	(hide-region-body): Declare as obsolete.
	(outline-show-all): Rename from `show-all'.
	(show-all): Declare as obsolete.
	(outline-hide-subtree): Rename from `hide-subtree'.
	(hide-subtree): Declare as obsolete.
	(outline-hide-leaves): Rename from `hide-leaves'.
	(hide-leaves): Declare as obsolete.
	(outline-show-subtree): Rename from `show-subtree'.
	(show-subtree): Declare as obsolete.
	(outline-hide-sublevels): Rename from `hide-sublevels'.
	(hide-sublevels): Declare as obsolete.
	(outline-hide-other): Rename from `hide-other'.
	(hide-other): Declare as obsolete.
	(outline-show-children): Rename from `show-children'.
	(show-children): Declare as obsolete.
	(outline-show-branches): Rename from `show-branches'.
	(show-branches): Declare as obsolete.

2015-01-30  Oleh Krehel  <ohwoeowho@gmail.com>

	* outline.el (outline-mode): Clean up docstring.
	(font-lock-warning-face): Remove obsolete declaration.
	(outline-font-lock-face): Remove obsolete comment.

2015-01-30  Oleh Krehel  <ohwoeowho@gmail.com>

	* custom.el (defface): Set `indent' to 1.

2015-01-30  Oleh Krehel  <ohwoeowho@gmail.com>

	* emacs-lisp/easy-mmode.el (define-minor-mode): Set `indent' to 1.

2015-01-30  Michal Nazarewicz  <mina86@mina86.com>

	* files.el (save-buffers-kill-emacs): If `confirm-kill-emacs'
	is set, but user has just been asked whether they really want to
	kill Emacs (for example with a ‘Modified buffers exist; exit
	anyway?’ prompt), do not ask them for another confirmation.

2015-01-29  Jay Belanger  <jay.p.belanger@gmail.com>

	* calc/calc-units.el (calc-convert-exact-units): New function.
	(calc-convert-units): Check for missing units.
	(math-consistent-units-p): Strengthen the test for consistent units.

	* calc/calc-ext.el (calc-init-extensions):  Autoload
	`calc-convert-exact-units' and assign it a keybinding.

	* calc/calc-help.el (calc-u-prefix-help): Add help for the
	"un" keybinding.

2015-01-28  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/cl.el (cl--function-convert): Simplify.

2015-01-28  Tassilo Horn  <tsdh@gnu.org>

	* textmodes/reftex.el (reftex-syntax-table-for-bib): Give ( and )
	punctuation syntax since to allow bibtex fields with values such
	as {Test 1) and 2)} (bug#19205, bug#19707).
	(reftex--prepare-syntax-tables): New function.
	(reftex-mode): Use it.

2015-01-28  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	python.el: New non-global state dependent indentation engine.
	(Bug#18319, Bug#19595)
	* progmodes/python.el (python-syntax-comment-or-string-p):
	Accept PPSS as argument.
	(python-syntax-closing-paren-p): New function.
	(python-indent-current-level)
	(python-indent-levels): Mark obsolete.
	(python-indent-context): Return more context cases.
	(python-indent--calculate-indentation)
	(python-indent--calculate-levels): New functions.
	(python-indent-calculate-levels): Use them.
	(python-indent-calculate-indentation, python-indent-line):
	(python-indent-line-function): Rewritten to use new API.
	(python-indent-dedent-line): Simplify logic.
	(python-indent-dedent-line-backspace): Use `unless`.
	(python-indent-toggle-levels): Delete function.

2015-01-28  Daniel Koning  <dk@danielkoning.com>  (tiny change)

	* subr.el (posnp): Correct docstring of `posnp'.
	(posn-col-row): Make it work with all mouse position objects.
	* textmodes/artist.el (artist-mouse-draw-continously):
	Cancel timers if an error occurs during continuous drawing.  (Bug#6130)

2015-01-28  Eli Zaretskii  <eliz@gnu.org>

	* button.el (button-activate, push-button): Doc fix.  (Bug#19628)

2015-01-28  Michael Albinus  <michael.albinus@gmx.de>

	* filenotify.el (file-notify-descriptors, file-notify-handle-event):
	Adapt docstring.
	(file-notify--descriptor): New defun.
	(file-notify-callback, file-notify-add-watch, file-notify-rm-watch):
	Adapt docstring.  Handle multiple values for
	`file-notify-descriptors' entries.  (Bug#18880)

	* net/tramp.el (tramp-handle-file-notify-rm-watch): Do not check
	`file-notify-descriptors', the implementation has been changed.

2015-01-28  Eli Zaretskii  <eliz@gnu.org>

	* net/net-utils.el (net-utils-run-program, net-utils-run-simple):
	On MS-Windows, bind coding-system-for-read to the console output
	codepage.  (Bug#19458)

2015-01-28  Dmitry Gutov  <dgutov@yandex.ru>

	Unbreak `mouse-action' property in text buttons.
	* button.el (push-button): Fix regression from 2012-12-06.

2015-01-28  Glenn Morris  <rgm@gnu.org>

	* progmodes/sh-script.el (sh-mode): Doc fix.
	(sh-basic-indent-line): Handle electric newline.  (Bug#18756)

2015-01-28  Paul Eggert  <eggert@cs.ucla.edu>

	Fix dired quoting bug with "Hit`N`Hide".
	* files.el (shell-quote-wildcard-pattern): Also quote "`".  (Bug#19498)

2015-01-28  Stefan Monnier  <monnier@iro.umontreal.ca>

	Tighten up the tagcode used for eieio and cl-struct objects.
	* loadup.el: Load cl-preloaded.
	* emacs-lisp/eieio-core.el (eieio-defclass-internal): Set the function
	slot of the tag symbol to :quick-object-witness-check.
	(eieio-object-p): Use :quick-object-witness-check.
	(eieio--generic-tagcode): Use cl--generic-struct-tag.
	* emacs-lisp/cl-preloaded.el: New file.
	* emacs-lisp/cl-macs.el (cl--bind-inits): Remove, unused.
	(cl--transform-lambda, cl-destructuring-bind): Remove cl--bind-inits.
	(cl--make-usage-args): Strip away &aux args.
	(cl-case, cl-typecase, cl--parse-loop-clause): Use macroexp-let2.
	(cl-the, cl-check-type): Use macroexp-let2 and cl-typep.
	(cl-defstruct): Use `declare' and cl-struct-define.
	* emacs-lisp/cl-generic.el (cl--generic-struct-tag): New function.
	(cl--generic-struct-tagcode): Use it to tighten the tagcode.

2015-01-27  Katsumi Yamaoka  <yamaoka@jpl.org>

	* emacs-lisp/cl.el (cl--function-convert):
	Merge cache that cl--labels-convert adds (bug#19699).

2015-01-27  Ivan Shmakov  <ivan@siamics.net>

	* tar-mode.el: Allow for adding new archive members.  (Bug#19274)
	(tar-new-regular-file-header, tar--pad-to, tar--put-at)
	(tar-header-serialize): New functions.
	(tar-current-position): Split from tar-current-descriptor.
	(tar-current-descriptor): Use it.
	(tar-new-entry): New command.
	(tar-mode-map): Bind it.

2015-01-27  Sam Steingold  <sds@gnu.org>

	* progmodes/python.el (python-check-custom-command): Buffer local
	because it usually includes the buffer name.
	(python-check-command): Set to epylint when pyflakes is not available.

2015-01-27  Artur Malabarba  <bruce.connor.am@gmail.com>

	* isearch.el (isearch-process-search-char): Add docstring.

2015-01-27  Oleh Krehel  <ohwoeowho@gmail.com>

	* emacs-lisp/derived.el (define-derived-mode): Declare indent 3.

2015-01-27  Katsumi Yamaoka  <yamaoka@jpl.org>

	* emacs-lisp/cl.el (cl--function-convert): Run cl--labels-convert
	for the case cl-flet or cl-labels form is wrapped with lexical-let
	(bug#19613).

2015-01-26  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/cl-generic.el (cl--generic-method): New struct.
	(cl--generic): The method-table is now a (list-of cl--generic-method).
	(cl--generic-member-method): New function.
	(cl-generic-define-method): Use it.
	(cl--generic-build-combined-method, cl--generic-cache-miss):
	Adapt to new method-table.
	(cl--generic-no-next-method-function): Add `method' argument.
	(cl-generic-call-method): Adapt to new method representation.
	(cl--generic-cnm-sample, cl--generic-nnm-sample): Adjust.
	(cl-find-method, cl-method-qualifiers): New functions.
	(cl--generic-method-info): Adapt to new method representation.
	Return a string for the qualifiers.
	(cl--generic-describe):
	* emacs-lisp/eieio-opt.el (eieio-help-class): Adjust accordingly.
	(eieio-all-generic-functions, eieio-method-documentation):
	Adjust to new method representation.

	* emacs-lisp/eieio-compat.el (eieio--defmethod): Use cl-find-method.

2015-01-26  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/cl-generic.el: Add a method-combination hook.
	(cl-generic-method-combination-function): New var.
	(cl--generic-lambda): Remove `with-cnm' arg.
	(cl-defmethod): Change accordingly.
	(cl-generic-define-method): Don't check qualifiers validity.
	Preserve all qualifiers in `method-table'.
	(cl-generic-call-method): New function.
	(cl--generic-nest): Remove (morph into cl-generic-call-method).
	(cl--generic-build-combined-method): Adjust to new format of method-table
	and use cl-generic-method-combination-function.
	(cl--generic-standard-method-combination): New function, extracted from
	cl--generic-build-combined-method.
	(cl--generic-cnm-sample): Adjust to new format of method-table.

	* emacs-lisp/eieio-compat.el (eieio--defmethod): Use () qualifiers
	instead of :primary.

	* emacs-lisp/eieio-datadebug.el (eieio-debug-methodinvoke):
	Remove obsolete function.

2015-01-26  Lars Ingebrigtsen  <larsi@gnus.org>

	* net/shr.el (shr-make-table-1): Fix colspan typo.
	(shr-make-table-1): Add comments.
	(shr-make-table-1): Make colspan display more sensibly.

	* net/eww.el (eww-add-bookmark): Fix prompt and clean up the code
	slightly.

2015-01-25  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/cl-generic.el (cl--generic-no-next-method-function): New fun.
	(cl--generic-build-combined-method, cl--generic-nnm-sample): Use it
	(bug#19672).
	(cl--generic-typeof-types): Add support for `sequence'.
	(cl-defmethod): Add non-keywords in the qualifiers.

2015-01-25  Dmitry Gutov  <dgutov@yandex.ru>

	* emacs-lisp/find-func.el (find-function-regexp): Don't match
	`defgroup' (regression from the previous change here).

2015-01-23  Thomas Fitzsimmons  <fitzsim@fitzsim.org>

	* net/ldap.el (ldap-search-internal): Mention binddn in invalid
	credentials error message.

2015-01-23  Thomas Fitzsimmons  <fitzsim@fitzsim.org>

	* net/ldap.el (ldap-password-read): Validate password before
	caching it.
	(ldap-search-internal): Handle ldapsearch error conditions.

2015-01-23  Thomas Fitzsimmons  <fitzsim@fitzsim.org>

	* net/ldap.el (ldap-password-read): Handle password-cache being nil.

2015-01-23  Thomas Fitzsimmons  <fitzsim@fitzsim.org>

	* net/eudc.el (eudc-expand-inline): Always restore former server
	and protocol.

2015-01-23  Thomas Fitzsimmons  <fitzsim@fitzsim.org>

	* net/eudcb-ldap.el: Don't nag the user in case a default base is
	provided by the LDAP system configuration file.

2015-01-23  Thomas Fitzsimmons  <fitzsim@fitzsim.org>

	* net/eudc.el (eudc-format-query): Preserve the
	eudc-inline-query-format ordering of attributes in the returned list.
	* net/eudcb-ldap.el (eudc-ldap-format-query-as-rfc1558):
	Append the LDAP wildcard character to the last attribute value.

2015-01-23  Thomas Fitzsimmons  <fitzsim@fitzsim.org>

	* net/eudcb-ldap.el (eudc-ldap-cleanup-record-simple):
	Downcase field names of LDAP results.
	(eudc-ldap-cleanup-record-filtering-addresses): Likewise.

2015-01-23  Thomas Fitzsimmons  <fitzsim@fitzsim.org>

	* net/ldap.el (ldap-ldapsearch-password-prompt): New defcustom.
	(ldap-search-internal): Send password to ldapsearch through a pipe
	instead of via the command line.

2015-01-23  Thomas Fitzsimmons  <fitzsim@fitzsim.org>

	* net/ldap.el: Require password-cache.
	(ldap-password-read): New function.
	(ldap-search-internal): Call ldap-password-read when it is
	configured to be called.

2015-01-23  Thomas Fitzsimmons  <fitzsim@fitzsim.org>

	* net/eudc-vars.el (eudc-expansion-overwrites-query):
	Change default to nil.

2015-01-23  Thomas Fitzsimmons  <fitzsim@fitzsim.org>

	* net/eudc.el (eudc-expand-inline): Ignore text properties of
	string-to-expand.

2015-01-23  Thomas Fitzsimmons  <fitzsim@fitzsim.org>

	* net/eudc-vars.el (eudc-inline-expansion-format): Default to a
	format that includes first name and surname.

2015-01-23  Thomas Fitzsimmons  <fitzsim@fitzsim.org>

	* net/eudc-vars.el (eudc-inline-query-format): Change default to
	query email and first name instead of surname.

2015-01-23  Thomas Fitzsimmons  <fitzsim@fitzsim.org>

	* net/ldap.el (ldap-search-internal): Support new-style LDAP URIs.

2015-01-23  Thomas Fitzsimmons  <fitzsim@fitzsim.org>

	* net/eudc-vars.el (eudc-server): Adjust docstring to mention
	eudc-server-hotlist.
	(eudc-server-hotlist): Move from eudc.el and make defcustom.
	* net/eudc.el (eudc-server-hotlist): Move to eudc-vars.el.
	(eudc-set-server): Allow setting protocol to nil.
	(eudc-expand-inline): Support hotlist-only expansions when server
	is not set.

2015-01-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/cl-generic.el (cl-no-primary-method): New fun and error.
	(cl--generic-build-combined-method): Use it.

2015-01-22  Paul Eggert  <eggert@cs.ucla.edu>

	Don't downcase system diagnostics' first letters
	* emacs-lisp/bytecomp.el (byte-compile-file):
	* ffap.el (find-file-at-point):
	* files.el (insert-file-1):
	* net/ange-ftp.el (ange-ftp-barf-if-not-directory)
	(ange-ftp-copy-file-internal):
	* progmodes/etags.el (visit-tags-table):
	Keep diagnostics consistent with system's.
	* ffap.el (ffap-machine-p):
	Ignore case while comparing diagnostics.

2015-01-22  Stefan Monnier  <monnier@iro.umontreal.ca>

	* help.el (help-make-usage): Don't turn a "_" arg into an empty-string
	arg (bug#19645).
	* emacs-lisp/cl-generic.el (cl--generic-lambda): Don't confuse a string
	body with a docstring.

2015-01-22  Dmitry Gutov  <dgutov@yandex.ru>

	* progmodes/xref.el (xref-location-marker, xref-location-group):
	Use `cl-defgeneric' and `cl-defmethod' instead of the EIEIO
	counterparts.

	* progmodes/etags.el (xref-location-marker): Same.

	* progmodes/xref.el (xref--current): Rename from `xref--selected'.
	(xref--inhibit-mark-current): Rename from
	`xref--inhibit-mark-selected'.  Update the usages.
	(xref-quit): Reword the docstring.  Kill buffers after quitting
	windows instead of before.
	(xref--insert-xrefs): Tweak help-echo.
	(xref--read-identifier-history, xref--read-pattern-history):
	New variables.
	(xref--read-identifier, xref-find-apropos): Use them.

2015-01-21  Ulrich Müller  <ulm@gentoo.org>

	* play/gamegrid.el (gamegrid-add-score-with-update-game-score):
	Allow the 'update-game-score' helper program to run suid or sgid.

2015-01-21  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/eieio.el: Use cl-defmethod.
	(defclass): Generate cl-defmethod calls; use setf methods for :accessor.
	(eieio-object-name-string): Declare as obsolete.

	* emacs-lisp/eieio-opt.el: Adapt to cl-generic.
	(eieio--specializers-apply-to-class-p):	New function.
	(eieio-all-generic-functions): Use it.
	(eieio-method-documentation): Use it as well as cl--generic-method-info.
	Change format of return value.
	(eieio-help-class): Adapt accordingly.

	* emacs-lisp/eieio-compat.el (eieio--defmethod): Avoid no-next-method
	errors when there's a `before' but no `primary' (bug#19645).
	(next-method-p): Return nil rather than signal an error.
	(eieio-defgeneric): Remove bogus (fboundp 'method).

	* emacs-lisp/eieio-speedbar.el:
	* emacs-lisp/eieio-datadebug.el:
	* emacs-lisp/eieio-custom.el:
	* emacs-lisp/eieio-base.el: Use cl-defmethod.

	* emacs-lisp/cl-generic.el (cl-defgeneric): Add support for `declare'.
	(cl--generic-setf-rewrite): Setup the setf expander right away.
	(cl-defmethod): Make sure the setf expander is setup before we expand
	the body.
	(cl-defmethod): Silence byte-compiler warnings.
	(cl-generic-define-method): Shuffle code to change return value.
	(cl--generic-method-info): New function, extracted from
	cl--generic-describe.
	(cl--generic-describe): Use it.

2015-01-21  Dmitry Gutov  <dgutov@yandex.ru>

	* progmodes/xref.el (xref--xref-buffer-mode-map): Define before
	the major mode.  Remap `quit-window' to `xref-quit'.
	(xref--xref-buffer-mode): Inherit from special-mode.

	xref: Keep track of temporary buffers  (bug#19466).
	* progmodes/xref.el (xref--temporary-buffers, xref--selected)
	(xref--inhibit-mark-selected): New variables.
	(xref--mark-selected): New function.
	(xref--show-location): Maybe add the buffer to
	`xref--temporary-buffers', add `xref--mark-selected' to
	`buffer-list-update-hook' there.
	(xref--window): Add docstring.
	(xref-quit): Rename from `xref--quit'.  Update both references.
	Add KILL argument.  When it's non-nil, kill the temporary buffers
	that haven't been selected by the user.
	(xref--show-xref-buffer): Change the second argument to alist,
	extract the values for `xref--window' and
	`xref--temporary-buffers' from it.  Add `xref--mark-selected' to
	`buffer-list-update-hook' to each buffer in the list.
	(xref--show-xrefs): Move the logic of calling `xref-find-function'
	here.  Save the difference between buffer lists before and after
	it's called as "temporary buffers", and `pass it to
	`xref-show-xrefs-function'.
	(xref--find-definitions, xref-find-references)
	(xref-find-apropos): Update accordingly.

2015-01-20  Artur Malabarba  <bruce.connor.am@gmail.com>

	* emacs-lisp/package.el (package-dir-info): Fix `while' logic.

2015-01-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/eieio-generic.el: Remove.
	(defgeneric, defmethod): Move to eieio-compat.el.  Mark obsolete.
	* emacs-lisp/eieio-compat.el: New file.
	* emacs-lisp/eieio.el: Don't require eieio-generic any more.
	* emacs-lisp/eieio-core.el (eieio--slot-originating-class-p):
	Remove unused function.
	(eieio-defclass): Move to eieio-compat.el.
	* emacs-lisp/macroexp.el (macroexp-macroexpand): New function.
	(macroexp--expand-all): Use it.
	* emacs-lisp/bytecomp.el (byte-compile-recurse-toplevel): Here too.

2015-01-20  Michal Nazarewicz  <mina86@mina86.com>

	* emacs-lisp/eldoc.el (eldoc-documentation-function): Describe how
	major modes should use `add-function' to alter value of the variable.
	* hexl.el (hexl-mode):
	* ielm.el (inferior-emacs-lisp-mode):
	* progmodes/cfengine.el (cfengine3-mode):
	* progmodes/elisp-mode.el (emacs-lisp-mode):
	* progmodes/octave.el (octave-mode):
	* progmodes/python.el (python-mode):
	* simple.el (read--expression): Set `eldoc-documentation-function'
	using `add-function' so the default value is always used.

	* descr-text.el (describe-char-eldoc): New function returning
	basic Unicode codepoint information (e.g. name) about character
	at point.  It is meant to be used as a default value of the
	`eldoc-documentation-function' variable.
	(describe-char-eldoc--format, describe-char-eldoc--truncate):
	New helper functions for `describe-char-eldoc' function.

2015-01-20  Michal Nazarewicz  <mina86@mina86.com>

	* textmodes/paragraphs.el (sentence-end-base): Include an
	ellipsis (…) and interrobang (‽) characters as end of a sentence,
	and a closing single quote (’) as an end of a quote.

2015-01-20  Michal Nazarewicz  <mina86@mina86.com>

	* textmodes/tildify.el (tildify-double-space-undos): A new
	variable specifying whether pressing space in `tildify-mode' after
	a space has been replaced with hard space undos the substitution.
	(tildify-space): Add code branch for handling `tildify-doule-space'.

	* textmodes/tildify.el (tildify-space): A new function
	which can be used as a `post-self-insert-hook' to automatically
	convert spaces into hard spaces.
	(tildify-space-pattern): A new variable specifying pattern where
	`tildify-space' should take effect.
	(tildify-space-predicates): A new variable specifying list of
	predicate functions that all must return non-nil for
	`tildify-space' to take effect.
	(tildify-space-region-predicate): A new functions meant to be
	used as a predicate in `tildify-space-predicates' list.
	(tildify-mode): A new minor mode enabling `tildify-space' as a
	`post-self-insert-hook'

2015-01-20  Daniel Colascione  <dancol@dancol.org>

	* vc/vc-dir.el (vc-dir): Default to repository root, not
	default-directory.

2015-01-20  Dmitry Gutov  <dgutov@yandex.ru>

	* progmodes/etags.el (xref-etags-location): New class.
	(xref-make-etags-location): New function.
	(etags--xref-find-definitions): Use it.
	(xref-location-marker): New method implementation.

	* progmodes/xref.el: Mention that xref-location is an EIEIO class.
	(xref--insert-xrefs): Expand help-echo string.

2015-01-19  Dmitry Gutov  <dgutov@yandex.ru>

	* ido.el: Update Customization instructions.

2015-01-19  Jonas Bernoulli  <jonas@bernoul.li>

	Define Ido keymaps once (bug#17000).
	* ido.el (ido-common-completion-map)
	(ido-file-dir-completion-map)
	(ido-file-completion-map, ido-buffer-completion-map): Set up key
	bindings when each variable is defined.
	(ido-completion-map): Move definition.
	(ido-init-completion-maps): Noop.
	(ido-common-initialization): Don't call it.
	(ido-setup-completion-map): Improve doc-string, cleanup.

2015-01-19  Ivan Shmakov  <ivan@siamics.net>

	* cus-dep.el (custom-make-dependencies): Ensure that
	default-directory is interpreted as a directory (see bug#19140.)

2015-01-19  Dmitry Gutov  <dgutov@yandex.ru>

	* progmodes/xref.el (xref--display-position):
	Set `other-window-scroll-buffer'.
	(xref-goto-xref): Use `user-error'.

2015-01-19  Dmitry Gutov  <dgutov@yandex.ru>

	* progmodes/xref.el (xref--display-history): New variable.
	(xref--window-configuration): Remove.
	(xref--save-to-history): New function.
	(xref--display-position): Use it.  Add new argument.
	(xref--restore-window-configuration): Remove.
	(xref--show-location, xref-show-location-at-point):
	Update accordingly.
	(xref--xref-buffer-mode): Don't use `pre-command-hook'.
	(xref--quit): New command.
	(xref-goto-xref): Use it.
	(xref--xref-buffer-mode-map): Bind `q' to it.

2015-01-18  Dmitry Gutov  <dgutov@yandex.ru>

	* progmodes/xref.el (xref-goto-xref): Perform the jump even inside
	indentation or at eol.

2015-01-18  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/eieio-core.el: Add `subclass' specializer for cl-generic.
	(eieio--generic-subclass-tagcode, eieio--generic-subclass-tag-types):
	New functions.
	(cl-generic-tagcode-function, cl-generic-tag-types-function): Use them.

	* emacs-lisp/eieio.el (defclass): Add obsolescence warning for the
	`newname' argument.

	* emacs-lisp/cl-generic.el (cl-generic-define-method): Correctly handle
	introduction of a new dispatch argument.
	(cl--generic-cache-miss): Handle dispatch on an argument which was not
	considered as dispatchable for this method.
	(cl-defmethod): Warn when adding a method to an obsolete generic function.
	(cl--generic-lambda): Make sure it works if cl-lib is not yet loaded.

	* emacs-lisp/eieio-generic.el (eieio--defgeneric-init-form): Use autoloadp.

2015-01-18  Artur Malabarba  <bruce.connor.am@gmail.com>

	* emacs-lisp/package.el (package--append-to-alist): Rename from
	`package--add-to-alist'
	Updated docstring due to new name.

2015-01-18  Leo Liu  <sdl.web@gmail.com>

	* emacs-lisp/cl-extra.el (cl-subseq): Use seq-subseq and fix
	multiple evaluation.  (Bug#19519)

	* emacs-lisp/seq.el (seq-subseq): Throw bad bounding indices
	error.  (Bug#19434)

2015-01-18  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/eieio-core.el: Add `subclass' specializer for cl-generic.
	(eieio--generic-subclass-tagcode, eieio--generic-subclass-tag-types):
	New functions.
	(cl-generic-tagcode-function, cl-generic-tag-types-function): Use them.

	* emacs-lisp/cl-macs.el (cl-defstruct): Minor optimization when include
	or print is nil.
	(cl-struct-type-p): New function.

	* emacs-lisp/cl-generic.el: Add support for cl-next-method-p.
	(cl-defmethod): Add edebug spec.
	(cl--generic-build-combined-method): Fix call to
	cl-no-applicable-method.
	(cl--generic-nnm-sample, cl--generic-cnm-sample): New constant.
	(cl--generic-isnot-nnm-p): New function.
	(cl--generic-lambda): Use it to add support for cl-next-method-p.
	(cl-no-next-method, cl-no-applicable-method): Simplify arg list.
	(cl-next-method-p): New function.

2015-01-17  Ulrich Müller  <ulm@gentoo.org>

	* version.el (emacs-repository-get-version): Update docstring.

2015-01-17  Ivan Shmakov  <ivan@siamics.net>

	* files.el (find-file-other-window, find-file-other-frame):
	Use mapc instead of mapcar.  (Bug#18175)

	* files.el (dir-locals-collect-variables): Use default-directory
	in place of the file name while working on non-file buffers, just
	like hack-dir-local-variables already does.  (Bug#19140)

	* textmodes/enriched.el (enriched-encode):
	Use inhibit-point-motion-hooks in addition to inhibit-read-only.
	(Bug#18246)

	* desktop.el (desktop-read): Do not call desktop-clear when no
	desktop file is found.  (Bug#18371)

	* misearch.el (multi-isearch-unload-function): New function.
	(misearch-unload-function): New alias.  (Bug#19566)

2015-01-17  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/eieio-core.el (eieio--class-constructor): Rename from
	class-constructor, and make it an alias for `identity'.
	Update all callers.

	* emacs-lisp/eieio.el (eieio-constructor): Handle obsolete object name
	argument here (bug#19620)...
	(defclass): ...instead of in the constructor here.

2015-01-16  Jorgen Schaefer  <contact@jorgenschaefer.de>

	* emacs-lisp/package.el (package-archive-priorities):
	Specify correct type.

2015-01-17  Ulrich Müller  <ulm@gentoo.org>

	* version.el (emacs-bzr-version-dirstate, emacs-bzr-version-bzr):
	Remove.
	(emacs-repository-get-version): Discard the Bazaar case.
	* vc/vc-bzr.el (vc-bzr-version-dirstate): Rename from
	emacs-bzr-version-dirstate and move from version.el to here.
	(vc-bzr-working-revision): Use it.

2015-01-17  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/eieio-generic.el (call-next-method): Don't bother checking
	eieio--scoped-class any more.

	* emacs-lisp/eieio-core.el (eieio--scoped-class-stack): Remove var.
	(eieio--scoped-class): Remove function.
	(eieio--with-scoped-class): Remove macro.  Replace uses with `progn'.
	(eieio--slot-name-index): Don't check the :protection anymore.
	(eieio-initializing-object): Remove var.
	(eieio-set-defaults): Don't let-bind eieio-initializing-object.

2015-01-17  Stefan Monnier  <monnier@iro.umontreal.ca>

	Improve handling of doc-strings and describe-function for cl-generic.

	* help-mode.el (help-function-def): Add optional arg `type'.

	* help-fns.el (find-lisp-object-file-name): Accept any `type' as long
	as it's a symbol.
	(help-fns-short-filename): New function.
	(describe-function-1): Use it.  Use autoload-do-load.

	* emacs-lisp/find-func.el: Use lexical-binding.
	(find-function-regexp): Don't rule out `defgeneric'.
	(find-function-regexp-alist): Document new possibility of including
	a function instead of a regexp.
	(find-function-search-for-symbol): Implement that new possibility.
	(find-function-library): Don't assume that `function' is a symbol.
	(find-function-do-it): Remove unused var `orig-buf'.

	* emacs-lisp/eieio-generic.el (eieio--defalias): Move from eieio-core.
	(eieio--defgeneric-init-form): Don't throw away a previous docstring.
	(eieio--method-optimize-primary): Don't mess with the docstring.
	(defgeneric): Keep the `args' in the docstring.
	(defmethod): Don't use the method's docstring for the generic
	function's docstring.

	* emacs-lisp/eieio-core.el (eieio--defalias): Move to eieio-generic.el.
	(eieio-defclass-autoload): Don't record the superclasses any more.
	(eieio-defclass-internal): Reuse the old class object if it was just an
	autoload stub.
	(eieio--class-precedence-list): Load the class if it's autoloaded.

	* emacs-lisp/cl-generic.el (cl-generic-ensure-function): It's OK to
	override an autoload.
	(cl-generic-current-method-specializers): Replace dyn-bind variable
	with a lexically-scoped macro.
	(cl--generic-lambda): Update accordingly.
	(cl-generic-define-method): Record manually in the load-history with
	type `cl-defmethod'.
	(cl--generic-get-dispatcher): Minor optimization.
	(cl--generic-search-method): New function.
	(find-function-regexp-alist): Add entry for `cl-defmethod' type.
	(cl--generic-search-method): Add hyperlinks for methods.  Merge the
	specializers and the function's arguments.

2015-01-16  Artur Malabarba  <bruce.connor.am@gmail.com>

	* emacs-lisp/package.el (package--read-pkg-desc):
	New function. Read a `define-package' form in current buffer.
	Return the pkg-desc, with desc-kind set to KIND.
	(package-dir-info): New function. Find package information for a
	directory. The return result is a `package-desc'.
	(package-install-from-buffer): Install packages from dired buffer.
	(package-install-file): Install packages from directory.
	(package-desc-suffix)
	(package-install-from-archive)
	* emacs-lisp/package-x.el (package-upload-buffer-internal):
	Ensure all remaining instances of `package-desc-kind' handle the 'dir
	value.

2015-01-16  Jorgen Schaefer  <contact@jorgenschaefer.de>

	* emacs-lisp/package.el: Provide repository priorities.
	(package-archive-priorities): New variable.
	(package--add-to-alist): New function.
	(package--add-to-archive-contents): Use it.
	(package-menu--find-upgrades): Use it as well. Small clean up to
	make the use of the package name here explicit.
	(package-archive-priority): New function.
	(package-desc-priority-version): New function.

2015-01-16  Daniel Colascione  <dancol@dancol.org>

	* cus-start.el (all): Make `ring-bell-function' customizable.

2015-01-16  Dmitry Gutov  <dgutov@yandex.ru>

	* vc/vc-svn.el (vc-svn-dir-status-files): Pass t as
	vc-svn-after-dir-status's second argument.  (Bug#19429)

2015-01-16  Samer Masterson  <samer@samertm.com>

	* pcomplete.el (pcomplete-parse-arguments): Parse arguments
	regardless of pcomplete-cycle-completions's value.  (Bug#18950)

2015-01-16  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* dom.el (dom-strings): New function.

	* files.el (directory-files-recursively): Don't use the word
	"path" for a file name.

2015-01-15  Wolfgang Jenkner  <wjenkner@inode.at>

	* calc/calc-units.el (math-units-in-expr-p)
	(math-single-units-in-expr-p, math-find-compatible-unit-rec)
	(math-extract-units): Handle the `neg' operator.  (Bug#19582)

2015-01-15  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/cl-macs.el (cl--labels-magic): New constant.
	(cl--labels-convert): Use it to ask the macro what is its replacement
	in the #'f case.

	* emacs-lisp/cl-generic.el (cl--generic-build-combined-method):
	Return the value of the primary rather than the after method.

	* emacs-lisp/eieio-core.el: Provide support for cl-generic.
	(eieio--generic-tagcode): New function.
	(cl-generic-tagcode-function): Use it.
	(eieio--generic-tag-types): New function.
	(cl-generic-tag-types-function): Use it.
	(eieio-object-p): Tighten up the test.

	* emacs-lisp/cl-generic.el (cl-generic-define-method): Fix paren typo.

2015-01-14  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/cl-generic.el: New file.

	* emacs-lisp/cl-macs.el (cl-flet): Allow (FUN EXP) forms.
	(cl-load-time-value, cl-labels): Use closures rather than
	backquoted lambdas.
	(cl-macrolet): Use `eval' to create the function value, and support CL
	style arguments in for the defined macros.

2015-01-14  Stefan Monnier  <monnier@iro.umontreal.ca>

	* net/eww.el: Use lexical-binding.
	(eww-links-at-point): Remove unused arg.
	(eww-mode-map): Inherit from special-mode-map.
	(eww-mode): Derive from special-mode.  Don't use `setq' on a hook.

2015-01-13  Alan Mackenzie  <acm@muc.de>

	Allow compilation during loading of CC Mode-derived modes (bug#19206).
	* progmodes/cc-bytecomp.el (cc-bytecomp-compiling-or-loading):
	New function which walks the stack to discover whether we're compiling
	or loading.
	(cc-bytecomp-is-compiling): Reformulate, and move towards beginning.
	(cc-bytecomp-is-loading): New defsubst.
	(cc-bytecomp-setup-environment, cc-bytecomp-restore-environment):
	Use the above defsubsts.
	(cc-require-when-compile, cc-bytecomp-defvar)
	(cc-bytecomp-defun): Simplify conditionals.
	* progmodes/cc-defs.el (cc-bytecomp-compiling-or-loading):
	"Borrow" this function from cc-bytecomp.el.
	(c-get-current-file): Reformulate using the above.
	(c-lang-defconst): Prevent duplicate entries of file names in a
	symbol's 'source property.
	(c-lang-const): Use cc-bytecomp-is-compiling.
	* progmodes/cc-langs.el (c-make-init-lang-vars-fun):
	Use cc-bytecomp-is-compiling.

2015-01-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/eieio-core.el (eieio-defclass): Fix call to `defclass'
	(bug#19552).

2015-01-13  Dmitry Gutov  <dgutov@yandex.ru>

	* menu-bar.el (menu-bar-goto-menu): Before calling
	`xref-marker-stack-empty-p', first check that `xref' is loaded.
	(Bug#19554)

2015-01-12  Martin Rudalics  <rudalics@gmx.at>

	* progmodes/xref.el (xref-marker-stack-empty-p): Add autoload
	cookie (Bug#19554).

	* frame.el (frame-notice-user-settings): Remove code dealing with
	frame-initial-frame-tool-bar-height.  Turn off `tool-bar-mode'
	only if `window-system-frame-alist' or `default-frame-alist' ask
	for it.
	(make-frame): Update frame-adjust-size-history if needed.

2015-01-12  Paul Eggert  <eggert@cs.ucla.edu>

	Have 'make' output better GEN names
	* Makefile.in (PHONY_EXTRAS): New macro.
	(.PHONY): Depend on it, and on $(lisp)/loaddefs.el, so that the
	relevant files' time stamps are ignored.
	(custom-deps, $(lisp)/cus-load.el, finder-data)
	($(lisp)/finder-inf.el): Use PHONY_EXTRAS.
	(custom-deps, $(lisp)/cus-load.el, finder-data)
	($(lisp)/finder-inf.el, autoloads, $(lisp)/loaddefs.el)
	($(lisp)/subdirs.el, update-subdirs):
	Output more-accurate destination names with GEN.

	Say "ELC foo.elc" instead of "GEN foo.elc"
	* Makefile.in (AM_V_ELC, am__v_ELC_, am__v_ELC_0, am__v_ELC_1):
	New macros.
	($(THEFILE)c, .el.elc): Use them.

2015-01-11  Michael Albinus  <michael.albinus@gmx.de>

	* files.el (directory-files-recursively): Do not include
	superfluous remote file names.

2015-01-11  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el (eww): Interpret anything that looks like a protocol
	designator as a full URL.

2015-01-10  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/shr.el (shr-urlify): Don't bother the user about
	invalidly-encoded display strings.

2015-01-10  Ivan Shmakov  <ivan@siamics.net>

	* net/shr.el (shr-urlify): Decode URLs before using them as titles
	(bug#19555).

2015-01-10  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el (eww): Always interpret URLs that start with https?:
	as plain URLs, even if they have spaces in them (bug#19556).
	(eww): Also interpret things like "en.wikipedia.org/wiki/Free
	software" as an URL.
	(eww): Don't interpret "org/foo" as an URL.
	(eww): Clear the title when loading so that we don't display
	misleading information.

2015-01-10  Daniel Colascione  <dancol@dancol.org>

	* vc/vc-hooks.el (vc-prefix-map): Bind vc-delete-file to C-x v x,
	by analogy with dired.

2015-01-09  Daniel Colascione  <dancol@dancol.org>

	* progmodes/js.el (js--function-heading-1-re)
	(js--function-prologue-beginning): Parse ES6 generator function
	declarations.  (That is, "function* name()").

2015-01-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/eieio.el (defclass): Move from eieio-defclass all the code
	that creates functions, and most of the sanity checks.
	Mark as obsolete the <class>-child-p function.
	* emacs-lisp/eieio-core.el (eieio--define-field-accessors): Remove.
	(eieio--class, eieio--object): Use cl-defstruct.
	(eieio--object-num-slots): Define manually.
	(eieio-defclass-autoload): Use eieio--class-make.
	(eieio-defclass-internal): Rename from eieio-defclass.  Move all the
	`(lambda...) definitions and most of the sanity checks to `defclass'.
	Mark as obsolete the <class>-list-p function, the <class> variable and
	the <initarg> variables.  Use pcase-dolist.
	(eieio-defclass): New compatibility function.
	* emacs-lisp/eieio-opt.el (eieio-build-class-alist)
	(eieio-class-speedbar): Don't use eieio-default-superclass var.

2015-01-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/eieio-generic.el: New file.
	* emacs-lisp/eieio-core.el: Move all generic function code to
	eieio-generic.el.
	(eieio--defmethod): Declare.

	* emacs-lisp/eieio.el: Require eieio-generic.  Move all generic
	function code to eieio-generic.el.
	* emacs-lisp/eieio-opt.el (eieio-help-generic): Move to
	eieio-generic.el.
	* emacs-lisp/eieio-datadebug.el (eieio-debug-methodinvoke): Update call
	to eieio--generic-call.
	* emacs-lisp/eieio-base.el (eieio-instance-inheritor): Don't use
	<class>-child type.

2015-01-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/chart.el (chart-add-sequence, chart-bar-quickie):
	Don't use <class> as a variable.

	* emacs-lisp/eieio.el (same-class-p): Accept class object as well.
	(call-next-method): Simplify.
	(clone): Obey eieio-backward-compatibility.

	* emacs-lisp/eieio-opt.el (eieio-read-generic-p): Remove.
	(eieio-read-generic): Use `generic-p' instead.

	* emacs-lisp/eieio-core.el (eieio-backward-compatibility): New var.
	(eieio-defclass-autoload): Obey it.
	(eieio--class-object): Improve error behavior.
	(eieio-class-children-fast, same-class-fast-p): Remove.  Inline at
	every use site.
	(eieio--defgeneric-form-primary-only): Rename from
	eieio-defgeneric-form-primary-only; update all callers.
	(eieio--defgeneric-form-primary-only-one): Rename from
	eieio-defgeneric-form-primary-only-one; update all callers.
	(eieio-defgeneric-reset-generic-form)
	(eieio-defgeneric-reset-generic-form-primary-only)
	(eieio-defgeneric-reset-generic-form-primary-only-one): Remove.
	(eieio--method-optimize-primary): New function to replace them.
	(eieio--defmethod, eieio-defmethod): Use it.
	(eieio--perform-slot-validation): Rename from
	eieio-perform-slot-validation; update all callers.
	(eieio--validate-slot-value): Rename from eieio-validate-slot-value.
	Change `class' to be a class object.  Update all callers.
	(eieio--validate-class-slot-value): Rename from
	eieio-validate-class-slot-value.  Change `class' to be a class object.
	Update all callers.
	(eieio-oset-default): Accept class object as well.
	(eieio--generic-call-primary-only): Rename from
	eieio-generic-call-primary-only.  Update all callers.

	* emacs-lisp/eieio-base.el (eieio-persistent-validate/fix-slot-value):
	Improve error messages.
	(eieio-persistent-slot-type-is-class-p): Handle `list-of' types, as
	well as user-defined types.  Emit errors for legacy types like
	<class>-child and <class>-list, if not eieio-backward-compatibility.

2015-01-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/eieio.el (eieio-class-parents): Accept class objects.
	(eieio--class-slot-initarg): Rename from class-slot-initarg.
	Change `class' arg to be a class object.  Update all callers.
	(call-next-method): Adjust to new return value of `eieio-generic-form'.
	(eieio-default-superclass): Set var to the class object.
	(eieio-edebug-prin1-to-string): Fix recursive call for lists.
	Change print behavior to affect class objects rather than
	class symbols.

	* emacs-lisp/eieio-core.el (eieio-class-object): New function.
	(eieio-class-parents-fast): Remove macro.
	(eieio--class-option-assoc): Rename from class-option-assoc.
	Update all callers.
	(eieio--class-option): Rename from class-option.  Change `class' arg to
	be a class object.  Update all callers.
	(eieio--class-method-invocation-order): Rename from
	class-method-invocation-order.  Change `class' arg to be a class
	object.  Update all callers.
	(eieio-defclass-autoload, eieio-defclass): Set the `parent' field to
	a list of class objects rather than names.
	(eieio-defclass): Remove redundant quotes.  Use `eieio-oref-default'
	for accessors to class allocated slots.
	(eieio--perform-slot-validation-for-default): Rename from
	eieio-perform-slot-validation-for-default.  Update all callers.
	(eieio--add-new-slot): Rename from eieio-add-new-slot.
	Update all callers.  Use push.
	(eieio-copy-parents-into-subclass): Adjust to new content of
	`parent' field.  Use dolist.
	(eieio-oref): Remove support for providing a class rather than
	an object.
	(eieio-oref-default): Prefer class objects over class names.
	(eieio--slot-originating-class-p): Rename from
	eieio-slot-originating-class-p.  Update all callers.  Use `or'.
	(eieio--slot-name-index): Turn check into assertion.
	(eieio--class-slot-name-index): Rename from
	eieio-class-slot-name-index.  Change `class' arg to be a class object.
	Update all callers.
	(eieio-attribute-to-initarg): Move to eieio-test-persist.el.
	(eieio--c3-candidate): Rename from eieio-c3-candidate.
	Update all callers.
	(eieio--c3-merge-lists): Rename from eieio-c3-merge-lists.
	Update all callers.
	(eieio--class-precedence-c3): Rename from eieio-class-precedence-c3.
	Update all callers.
	(eieio--class-precedence-dfs): Rename from eieio-class-precedence-dfs.
	Update all callers.
	(eieio--class-precedence-bfs): Rename from eieio-class-precedence-bfs.
	Update all callers.  Adjust to new `parent' content.
	(eieio--class-precedence-list): Rename from -class-precedence-list.
	Update all callers.
	(eieio-generic-call): Use autoloadp and autoload-do-load.
	Slight simplification.
	(eieio-generic-call, eieio-generic-call-primary-only): Adjust to new
	return value of `eieio-generic-form'.
	(eieiomt-add): Index the hashtable with class objects rather than
	class names.
	(eieio-generic-form): Accept class objects as well.

	* emacs-lisp/eieio-base.el (eieio-persistent-convert-list-to-object):
	Adjust to new convention for eieio-persistent-validate/fix-slot-value.
	(eieio-persistent-validate/fix-slot-value):
	Change `class' arg to be a class object.  Update all callers.

2015-01-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/eieio.el (child-of-class-p): Make it accept class objects
	additionally to class names.

	* emacs-lisp/eieio-core.el (eieio--with-scoped-class): Use let-binding.
	(object): Remove first (constant) slot; rename second to `class-tag'.
	(eieio--object-class-object, eieio--object-class-name): New funs
	to replace eieio--object-class.
	(eieio--class-object, eieio--class-p): New functions.
	(same-class-fast-p): Make it a defsubst, change its implementation
	to check the class objects rather than their names.
	(eieio-object-p): Rewrite.
	(eieio-defclass): Adjust the object initialization according to the new
	object layout.
	(eieio--scoped-class): Declare it returns a class object (not a class
	name any more).  Adjust calls accordingly (along with calls to
	eieio--with-scoped-class).
	(eieio--slot-name-index): Rename from eieio-slot-name-index and change
	its class arg to be a class object.  Adjust callers accordingly.
	(eieio-slot-originating-class-p): Make its start-class arg a class
	object.  Adjust all callers.
	(eieio--initarg-to-attribute): Rename from eieio-initarg-to-attribute.
	Make its `class' arg a class object.  Adjust all callers.

	* emacs-lisp/eieio-base.el (eieio-persistent-validate/fix-slot-value):
	Use eieio--slot-name-index rather than eieio-slot-name-index.

2015-01-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/eieio.el (make-instance): Simplify by not adding an object
	name argument.
	(eieio-object-name): Use eieio-object-name-string.
	(eieio--object-names): New const.
	(eieio-object-name-string, eieio-object-set-name-string): Re-implement
	using a hashtable rather than a built-in slot.
	(eieio-constructor): Rename from `constructor'.  Remove `newname' arg.
	(clone): Don't mess with the object's "name".

	* emacs-lisp/eieio-custom.el (eieio-widget-test): Remove dummy arg.
	(eieio-object-value-get): Use eieio-object-set-name-string.

	* emacs-lisp/eieio-core.el (eieio--defalias): Follow aliases.
	(eieio--object): Remove `name' field.
	(eieio-defclass): Adjust to new convention where constructors don't
	take an "object name" any more.
	(eieio--defgeneric-init-form, eieio--defmethod): Follow aliases.
	(eieio-validate-slot-value, eieio-oset-default)
	(eieio-slot-name-index): Don't hardcode eieio--object-num-slots.
	(eieio-generic-call-primary-only): Simplify.

	* emacs-lisp/eieio-base.el (clone) <eieio-instance-inheritor>:
	Use call-next-method.
	(eieio-constructor): Rename from `constructor'.
	(eieio-persistent-convert-list-to-object): Drop objname.
	(eieio-persistent-validate/fix-slot-value): Don't hardcode
	eieio--object-num-slots.
	(eieio-named): Use a normal slot.
	(slot-missing) <eieio-named>: Remove.
	(eieio-object-name-string, eieio-object-set-name-string, clone)
	<eieio-named>: New methods.

2015-01-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/eieio-core.el (eieio--class-v): Rename from class-v.
	(method-*): Add a "eieio--" prefix to those constants.

	* emacs-lisp/eieio.el: Move edebug specs to the corresponding macro.

	* emacs-lisp/eieio-speedbar.el: Use lexical-binding.

2015-01-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/eieio.el (child-of-class-p): Fix case where `class' is
	`eieio-default-superclass'.

	* emacs-lisp/eieio-datadebug.el: Use lexical-binding.

	* emacs-lisp/eieio-custom.el: Use lexical-binding.
	(eieio-object-value-to-abstract): Simplify.

	* emacs-lisp/eieio-opt.el (eieio-build-class-list): Use cl-mapcan.
	(eieio-build-class-alist): Use dolist.
	(eieio-all-generic-functions): Adjust to use of hashtables.

	* emacs-lisp/eieio-core.el (class): Rename field symbol-obarray to
	symbol-hashtable.  It contains a hashtable instead of an obarray.
	(generic-p): Use symbol property `eieio-method-hashtable' instead of
	`eieio-method-obarray'.
	(generic-primary-only-p, generic-primary-only-one-p):
	Slight optimization.
	(eieio-defclass-autoload-map): Use a hashtable instead of an obarray.
	(eieio-defclass-autoload, eieio-defclass): Adjust/simplify accordingly.
	(eieio-class-un-autoload): Use autoload-do-load.
	(eieio-defclass): Use dolist, cl-pushnew, cl-callf.
	Use new cl-deftype-satisfies.  Adjust to use of hashtables.
	Don't hardcode the value of eieio--object-num-slots.
	(eieio-defgeneric-form-primary-only-one): Remove `doc-string' arg.
	Use a closure rather than a backquoted lambda.
	(eieio--defmethod): Adjust call accordingly.  Set doc-string via the
	function-documentation property.
	(eieio-slot-originating-class-p, eieio-slot-name-index)
	(eieiomt--optimizing-hashtable, eieiomt-install, eieiomt-add)
	(eieio-generic-form): Adjust to use of hashtables.
	(eieiomt--sym-optimize): Rename from eieiomt-sym-optimize; take
	additional class argument.
	(eieio-generic-call-methodname): Remove, unused.

	* emacs-lisp/eieio-base.el (eieio-persistent-slot-type-is-class-p):
	Prefer \' to $.

2015-01-08  Eli Zaretskii  <eliz@gnu.org>

	* simple.el (line-move-visual): When converting X pixel coordinate
	to temporary-goal-column, adjust the value for right-to-left
	screen lines.  This fixes vertical-motion, next/prev-line, etc.

2015-01-08  Glenn Morris  <rgm@gnu.org>

	* files.el (file-tree-walk): Remove; of unknown authorship.  (Bug#19325)

2015-01-07  K. Handa  <handa@gnu.org>

	* international/ccl.el (define-ccl-program): Improve the docstring.

2015-01-06  Sam Steingold  <sds@gnu.org>

	* shell.el (shell-display-buffer-actions): Remove,
	use `display-buffer-alist' instead.

2015-01-05  Dmitry Gutov  <dgutov@yandex.ru>

	* progmodes/xref.el (xref--insert-xrefs): Add `help-echo' property
	to the references.

2015-01-05  Stefan Monnier  <monnier@iro.umontreal.ca>

	* minibuffer.el (completion-category-defaults): New var.
	Set unicode-name to use substring completion.
	(completion-category-defaults): Set it to nil.

2015-01-04  Dmitry Gutov  <dgutov@yandex.ru>

	Add mouse interaction to xref.
	* progmodes/xref.el (xref--button-map): New variable.
	(xref--mouse-2): New command.
	(xref--insert-xrefs): Add `mouse-face' and `keymap' properties to
	the inserted references.

2015-01-04  Paul Eggert  <eggert@cs.ucla.edu>

	Less 'make' chatter for lisp dir
	* Makefile.in (THEFILE): Define to be 'no-such-file' by default,
	to make it clearer that the caller must specify it.
	(compile-onefile): Remove, replacing by ...
	($(THEFILE)c): ... new rule.  This lets us use AM_V_GEN here.
	($(THEFILE)c, .el.elc, $(MH_E_DIR)/mh-loaddefs.el)
	($(TRAMP_DIR)/tramp-loaddefs.el, $(CAL_DIR)/cal-loaddefs.el)
	($(CAL_DIR)/diary-loaddefs.el, $(CAL_DIR)/hol-loaddefs.el):
	Use AM_V_GEN to lessen 'make' chatter.
	(.el.elc): Omit duplicate comment.

	Less 'make' chatter in batch mode
	* emacs-lisp/autoload.el (autoload-generate-file-autoloads):
	* emacs-lisp/bytecomp.el (byte-compile-file):
	* files.el (save-buffer, basic-save-buffer):
	* international/quail.el (quail-update-leim-list-file):
	Don't output messages like "Generating ..." in batch mode.

2015-01-04  Dmitry Gutov  <dgutov@yandex.ru>

	Unbreak `mouse-action' property in text buttons.
	* button.el (push-button): Fix regression from 2012-12-06.

2015-01-03  Dmitry Gutov  <dgutov@yandex.ru>

	* progmodes/xref.el (xref-marker-stack-empty-p): New function.

	* menu-bar.el (menu-bar-goto-menu): Use it.

2015-01-03  Dmitry Gutov  <dgutov@yandex.ru>

	* progmodes/xref.el (xref--window-configuration): New variable.
	(xref-show-location-at-point): New command.
	(xref--restore-window-configuration): New function.
	(xref-next-line, xref-prev-line): Delegate to
	`xref-show-location-at-point'.
	(xref--location-at-point): Don't signal the error.
	(xref-goto-xref): Do that here instead.
	(xref--xref-buffer-mode): Add `xref--restore-window-configuration'
	to `pre-command-hook'.
	(xref--xref-buffer-mode-map): Don't remap `next-line' and
	`previous-line'.  Additionally bind `xref-next-line' and
	`xref-prev-line' to `n' and `p' respectively.
	Bind `xref-show-location-at-point' to `C-o'.

2015-01-01  Eli Zaretskii  <eliz@gnu.org>

	* tool-bar.el (tool-bar-local-item)
	(tool-bar-local-item-from-menu): Call force-mode-line-update to
	make sure the tool-bar changes show on display.

2015-01-01  Michael Albinus  <michael.albinus@gmx.de>

	Sync with Tramp 2.2.11.

	* net/tramp-compat.el (top): Require cl-macs for Emacs 22.
	Make an alias for `default-toplevel-value' if it doesn't exist.

	* net/tramp-smb.el (tramp-smb-handle-copy-directory):
	Use `tramp-compat-delete-directory'.

	* net/trampver.el: Update release number.

2015-01-01  Filipp Gunbin  <fgunbin@fastmail.fm>

	* autorevert.el (auto-revert-handler): Fix auto-revert-tail-mode
	for remote files.  (Bug#19449)

2015-01-01  Simen Heggestøyl  <simenheg@gmail.com>  (tiny change)

	* textmodes/css-mode.el (scss-mode): Fix typo (bug#19446).

2014-12-31  Paul Eggert  <eggert@cs.ucla.edu>

	Less 'make' chatter in lisp directory
	* Makefile.in (AM_DEFAULT_VERBOSITY, AM_V_GEN, am__v_GEN_)
	(am__v_GEN_0, am__v_GEN_1): New macros, from ../src/Makefile.in.
	(custom-deps, finder-data, autoloads, update-subdirs): Use them.

2014-12-31  Filipp Gunbin  <fgunbin@fastmail.fm>

	* info.el (info-display-manual): Limit the completion alternatives
	to currently visited manuals if prefix argument is non-nil.

2014-12-30  Paul Eggert  <eggert@cs.ucla.edu>

	* Makefile.in (semantic): Simplify.

2014-12-30  Juri Linkov  <juri@linkov.net>

	* net/eww.el (eww-isearch-next-buffer): New function.
	(eww-mode): Set multi-isearch-next-buffer-function to it.

2014-12-30  Dmitry Gutov  <dgutov@yandex.ru>

	* progmodes/xref.el (xref-find-definitions): Mention "no
	identifier at point" case in the docstring.

	* menu-bar.el (menu-bar-goto-uses-etags-p): New function.
	(menu-bar-goto-menu): Use it to show or hide the `set-tags-name'
	and `separator-tag-file' items.

2014-12-29  Paul Eggert  <eggert@cs.ucla.edu>

	* obsolete/pc-select.el (pc-selection-mode): Use system-type.
	This is instead of system-name, which is both wrong here and obsolete.
	* desktop.el (desktop-save-frameset):
	* dnd.el (dnd-get-local-file-uri):
	* nxml/rng-uri.el (rng-uri-file-name-1):
	Prefer (system-name) to system-name, and avoid naming
	locals 'system-name'.
	* startup.el (system-name): Now an obsolete variable.  (Bug#19438)

2014-12-29  Dmitry Gutov  <dgutov@yandex.ru>

	* menu-bar.el (menu-bar-next-tag-other-window)
	(menu-bar-next-tag): Remove.

2014-12-29  K. Handa  <handa@gnu.org>

	* international/mule.el (make-translation-table-from-alist):
	Accept nil or zero-length vector for FROM and TO.

2014-12-29  Lars Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el (eww-mode): Truncate overlong lines for prettier
	display when resizing.

	* net/shr.el (shr-width): Default to using the window width when
	rendering.

2014-12-29  Dmitry Gutov  <dgutov@yandex.ru>

	Unbreak jumping to an alias's definition.
	* emacs-lisp/find-func.el (find-function-library): Return a pair
	(ORIG-FUNCTION . LIBRARY) instead of just its second element.
	(find-function-noselect): Use it.
	* progmodes/elisp-mode.el (elisp--xref-identifier-file): Rename to
	`elisp--xref-identifier-location', incorporate logic from
	`elisp--xref-find-definitions', use the changed
	`find-function-library' return value.

2014-12-29  Juri Linkov  <juri@linkov.net>

	* comint.el (comint-history-isearch-message): Use field-beginning
	instead of comint-line-beginning-position - that's more fixes for
	https://lists.gnu.org/r/emacs-devel/2014-12/msg00305.html
	(comint-history-isearch-message): Fix args of isearch-message-prefix.

2014-12-29  Juri Linkov  <juri@linkov.net>

	* vc/vc-dir.el (vc-dir-display-file): New command (bug#19450).
	(vc-dir-mode-map): Bind it to "\C-o".
	(vc-dir-menu-map): Add it to menu.

2014-12-29  Dmitry Gutov  <dgutov@yandex.ru>

	* progmodes/etags.el (find-tag-other-window)
	(find-tag-other-frame, find-tag-regexp, tags-loop-continue)
	(tags-apropos): Declare obsolete.

	* menu-bar.el (menu-bar-goto-menu): Replace all but one etags item
	with xref ones.

2014-12-28  Eli Zaretskii  <eliz@gnu.org>

	* international/mule.el (define-coding-system): Fix typos in the
	doc string.

2014-12-28  Kenichi Handa  <handa@gnu.org>

	* international/mule.el (define-coding-system): Improve the doc
	string.

2014-12-28  Ivan Shmakov  <ivan@siamics.net>

	* net/shr.el (shr-tag-table): Fix handling of tbody/header/footer
	elements in tables (bug#19444).

	* net/eww.el (eww-handle-link): Fix typo in "up" rel handling
	(bug#19445).

2014-12-28  Juri Linkov  <juri@linkov.net>

	* vc/compare-w.el: Require diff-mode for diff faces.
	(compare-windows-removed, compare-windows-added): New faces
	inheriting from diff faces.
	(compare-windows): Define obsolete face alias.
	(compare-windows-highlight): Replace face `compare-windows' with
	new faces `compare-windows-added' and `compare-windows-removed'
	(bug#19451).
	(compare-windows-get-recent-window): Signal an error when
	no other window is found (bug#19170).

2014-12-27  Dmitry Gutov  <dgutov@yandex.ru>

	* progmodes/elisp-mode.el (elisp--xref-identifier-file):
	Skip features that have no sources.

	* simple.el (execute-extended-command):
	When `suggest-key-bindings' is nil, don't.

2014-12-27  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	python.el: Native readline completion.
	* progmodes/python.el (python-shell-completion-native-disabled-interpreters)
	(python-shell-completion-native-enable)
	(python-shell-completion-native-output-timeout): New defcustoms.
	(python-shell-completion-native-interpreter-disabled-p)
	(python-shell-completion-native-try)
	(python-shell-completion-native-setup)
	(python-shell-completion-native-turn-off)
	(python-shell-completion-native-turn-on)
	(python-shell-completion-native-turn-on-maybe)
	(python-shell-completion-native-turn-on-maybe-with-msg)
	(python-shell-completion-native-toggle): New functions.
	(python-shell-completion-native-get-completions): New function.
	(python-shell-completion-at-point): Use it.

2014-12-27  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	python.el: Enhance shell user interaction and deprecate
	python-shell-get-or-create-process.
	* progmodes/python.el (python-shell-get-process-or-error):
	New function.
	(python-shell-with-shell-buffer): Use it.
	(python-shell-send-string, python-shell-send-region)
	(python-shell-send-buffer, python-shell-send-defun)
	(python-shell-send-file, python-shell-switch-to-shell): Use it.
	Add argument MSG to display user-friendly message when no process
	is running.
	(python-shell-switch-to-shell): Call pop-to-buffer with NORECORD.
	(python-shell-make-comint): Rename argument SHOW from POP.
	Use display-buffer instead of pop-to-buffer.
	(run-python): Doc fix.  Return process.
	(python-shell-get-or-create-process): Make obsolete.

2014-12-27  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	* progmodes/python.el (python-shell-buffer-substring):
	Handle cornercase when region sent starts at point-min.

2014-12-27  Eli Zaretskii  <eliz@gnu.org>

	* language/misc-lang.el (composition-function-table): Add Syriac
	characters and also ZWJ/ZWNJ.
	See https://lists.gnu.org/r/help-gnu-emacs/2014-12/msg00248.html
	for the details.

2014-12-27  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	python.el: Fix message when sending region.
	* progmodes/python.el (python-shell-send-region): Rename argument
	send-main from nomain.  Fix message.
	(python-shell-send-buffer): Rename argument send-main from arg.

	python.el: Cleanup temp files even with eval errors.
	* progmodes/python.el (python-shell-send-file): Make file-name
	mandatory.  Fix temp file removal in the majority of cases.

	python.el: Handle file encoding for shell.
	* progmodes/python.el (python-rx-constituents): Add coding-cookie.
	(python-shell--save-temp-file): Write file with proper encoding.
	(python-shell-buffer-substring): Add coding cookie for detected
	encoding to generated content.  Fix blank lines when removing
	if-name-main block.
	(python-shell-send-file): Handle file encoding.
	(python-info-encoding-from-cookie)
	(python-info-encoding): New functions.

2014-12-27  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp-sh.el (tramp-do-copy-or-rename-file-out-of-band):
	Use `tramp-rsh-end-of-line', it ought to be more robust.

2014-12-27  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/js.el (js-syntax-propertize): "return" can't be divided
	(bug#19397).

2014-12-27  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp.el (tramp-read-passwd): Ignore errors from `auth-source-*'.

	* net/tramp-sh.el (tramp-do-copy-or-rename-file-out-of-band): Use "\n"
	as end-of-line delimiter for passwords, when running on MS Windows.

2014-12-27  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/sh-script.el (sh-set-shell): Don't change the global value
	of indent-line-function (bug#19433).

2014-12-27  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	Fix line numbers on Python shell.
	* progmodes/python.el (python-shell--save-temp-file): Do not
	append coding cookie.
	(python-shell-send-string): Generalize for
	python-shell-send-region.
	(python--use-fake-loc): Delete var.
	(python-shell-buffer-substring): Cleanup fake-loc logic.
	(python-shell-send-region): Remove fake-loc logic, simplify.

2014-12-27  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	* progmodes/python.el (python-indent-post-self-insert-function):
	Make colon to re-indent only for dedenters, handling
	multiline-statements gracefully.

2014-12-27  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp.el (tramp-handle-insert-file-contents):
	Set `find-file-not-found-functions' in case of errors.  (Bug#18623)

2014-12-27  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp-sh.el (tramp-send-command-and-read): New optional
	arg MARKER.
	(tramp-get-remote-path): Use it.

2014-12-27  Stefan Monnier  <monnier@iro.umontreal.ca>

	* subr.el (redisplay-dont-pause): Mark as obsolete.

2014-12-27  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp.el (tramp-error-with-buffer): Call `message' properly.
	(tramp-accept-process-output): Use nil as argument for
	`accept-process-output', when there is a gateway prepended.

	* net/tramp-gw.el (tramp-gw-open-connection): Suppress traces in
	wrong debug buffer.
	(tramp-gw-open-connection): Set process coding system 'binary.
	(tramp-gw-open-network-stream): Handle HTTP error 403.

	* net/tramp-sh.el (tramp-compute-multi-hops): Suppress traces in
	wrong debug buffer.
	(tramp-maybe-open-connection): Set connection property "gateway".

2014-12-27  Stefan Monnier  <monnier@iro.umontreal.ca>

	* subr.el (sit-for): Tweak docstring (bug#19381).

2014-12-27  Dmitry Gutov  <dgutov@yandex.ru>

	* vc/vc-git.el (vc-git-after-dir-status-stage): Move `up-to-date'
	stage to after `diff-index' (bug#19386).

2014-12-27  João Távora  <joaotavora@gmail.com>

	* textmodes/tex-mode.el (tex-insert-quote): Consider and respect
	`electric-pair-mode' (bug#19356).

2014-12-27  Dmitry Gutov  <dgutov@yandex.ru>

	elisp-xref-find: Don't create buffers eagerly.

	* progmodes/elisp-mode.el (elisp--identifier-location): Fold back
	into `elisp--company-location'.
	(elisp--identifier-completion-table): Rename to
	`elisp--identifier-completion-table', and do not include just any
	symbols with a property list.
	(elisp-completion-at-point): Revert the 2014-12-25 change.
	(elisp--xref-identifier-file): New function.
	(elisp--xref-find-definitions): Use it.

	* emacs-lisp/find-func.el (find-function-library): New function,
	extracted from `find-function-noselect'.

	* progmodes/xref.el (xref-elisp-location): New class.
	(xref-make-elisp-location): New function.
	(xref-location-marker): New implementation.

2014-12-27  Juri Linkov  <juri@linkov.net>

	* minibuffer.el (minibuffer-completion-help):
	Use shrink-window-if-larger-than-buffer in window-height
	when temp-buffer-resize-mode is nil.

	* window.el (with-displayed-buffer-window): Remove window-height
	from the action alist in the temp-buffer-window-show call
	when window-height is handled explicitly afterwards (bug#19355).

2014-12-27  Juri Linkov  <juri@linkov.net>

	Support subdirectories when saving places in dired.
	* saveplace.el (toggle-save-place, save-place-to-alist)
	(save-places-to-alist, save-place-dired-hook):
	Use dired-current-directory instead of dired-directory (bug#19436).
	(save-place-dired-hook): Add check for alist to make the new
	format future-proof to allow other possible formats.

2014-12-26  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	python.el: Generate clearer shell buffer names.
	* progmodes/python.el (python-shell-get-process-name)
	(python-shell-internal-get-process-name): Use `buffer-name`.
	(python-shell-internal-get-or-create-process): Simplify.

2014-12-26  Dmitry Gutov  <dgutov@yandex.ru>

	Add basic xref apropos implementation to elisp-mode.

	* progmodes/elisp-mode.el (elisp--xref-find-definitions):
	Filter out nil results.
	(elisp--xref-find-apropos): New function.
	(elisp-xref-find): Use it.

	* progmodes/xref.el (xref--show-xrefs): Use `user-error'.

2014-12-25  Filipp Gunbin  <fgunbin@fastmail.fm>

	* dired-aux.el (dired-maybe-insert-subdir):
	Make dired-maybe-insert-subdir always skip trivial files.

2014-12-25  Helmut Eller  <eller.helmut@gmail.com>
            Dmitry Gutov  <dgutov@yandex.ru>

	Consolidate cross-referencing commands.

	Move autoloaded bindings for `M-.', `M-,', `C-x 4 .' and
	`C-x 5 .' from etags.el to xref.el.

	* progmodes/xref.el: New file.

	* progmodes/elisp-mode.el (elisp--identifier-types): New variable.
	(elisp--identifier-location): New function, extracted from
	`elisp--company-location'.
	(elisp--company-location): Use it.
	(elisp--identifier-completion-table): New variable.
	(elisp-completion-at-point): Use it.
	(emacs-lisp-mode): Set the local values of `xref-find-function'
	and `xref-identifier-completion-table-function'.
	(elisp-xref-find, elisp--xref-find-definitions)
	(elisp--xref-identifier-completion-table): New functions.

	* progmodes/etags.el (find-tag-marker-ring): Mark obsolete in
	favor of `xref--marker-ring'.
	(tags-lazy-completion-table): Autoload.
	(tags-reset-tags-tables): Use `xref-clear-marker-stack'.
	(find-tag-noselect): Use `xref-push-marker-stack'.
	(pop-tag-mark): Make an alias for `xref-pop-marker-stack'.
	(etags--xref-limit): New constant.
	(etags-xref-find, etags--xref-find-definitions): New functions.

2014-12-25  Martin Rudalics  <rudalics@gmx.at>

	* cus-start.el (resize-mini-windows): Make it customizable.

2014-12-24  Stephen Leake  <stephen_leake@stephe-leake.org>

	* startup.el (fancy-about-text): Change buttons for etc/CONTRIBUTE
	to (info "(emacs)Contributing").  (Bug#19299)

2014-12-24  Martin Rudalics  <rudalics@gmx.at>

	* window.el (mouse-autoselect-window-position-1): New variable.
	(mouse-autoselect-window-cancel)
	(mouse-autoselect-window-select, handle-select-window):
	With delayed autoselection select window only if mouse moves after
	selecting its frame.

2014-12-24  Michael Albinus  <michael.albinus@gmx.de>

	* eshell/esh-ext.el (eshell-find-interpreter): Expand relative
	remote file names.  (Bug#18782)

2014-12-23  Sam Steingold  <sds@gnu.org>

	* shell.el (shell-display-buffer-actions): New user option.
	(shell): Pass it to `pop-to-buffer' instead of hard-coding
	`pop-to-buffer-same-window'.

2014-12-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/js.el (js--syntax-propertize-regexp-syntax-table): New var.
	(js-syntax-propertize-regexp): Use it to recognize "slash in
	a character class" (bug#19397).

2014-12-22  Stefan Monnier  <monnier@iro.umontreal.ca>

	* completion.el: Use post-self-insert-hook (bug#19400).
	(completion-separator-self-insert-command)
	(completion-separator-self-insert-autofilling): Remove.
	(completion-separator-chars): New var.
	(completion-c-mode-hook, completion-setup-fortran-mode): Use it instead
	of changing the keymap.
	(completion--post-self-insert): New function.
	(dynamic-completion-mode): Use it instead of rebinding keys.
	(cmpl--completion-string): Rename from completion-string.
	(add-completion-to-head, delete-completion): Let-bind it explicitly.

2014-12-22  Bozhidar Batsov  <bozhidar@batsov.com>

	* progmodes/ruby-mode.el (ruby--string-region): Simplify code
	by leveraging `syntax-ppss'.

2014-12-22  Artur Malabarba  <bruce.connor.am@gmail.com>

	* emacs-lisp/let-alist.el (let-alist): Use `make-symbol'
	instead of `gensym'.

2014-12-20  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp-sh.el (tramp-histfile-override): Add :version.

2014-12-20  Teodor Zlatanov  <tzz@lifelogs.com>

	* net/tramp-sh.el (tramp-histfile-override): Clarify docstring.

2014-12-19  Artur Malabarba  <bruce.connor.am@gmail.com>

	* emacs-lisp/let-alist.el (let-alist): Enable access to deeper alists by
	using dots inside the dotted symbols.

2014-12-19  Alan Mackenzie  <acm@muc.de>

	Make C++11 uniform init syntax work.
	New keywords "final" and "override".
	* progmodes/cc-engine.el (c-back-over-member-initializer-braces):
	New function.
	(c-guess-basic-syntax): Set `containing-sex' and `lim' using the
	new function.
	* progmodes/cc-fonts.el (c-font-lock-declarations): Check more
	carefully for "are we at a declarator?" using
	c-back-over-member-initializers.
	* progmodes/cc-langs.el (c-type-modifier-kwds): Include "final"
	and "override" in the C++ value.

2014-12-19  Martin Rudalics  <rudalics@gmx.at>

	* textmodes/ispell.el (ispell-command-loop): Don't use `next-window'.

2014-12-21  Lars Ingebrigtsen  <larsi@gnus.org>

	* net/nsm.el (nsm-save-host): Don't save the host name twice
	(bug#19269).

2014-12-18  Sam Steingold  <sds@gnu.org>

	Keyboard interface (C-f10) to `mouse-buffer-menu' (C-down-mouse-1).
	* mouse.el (mouse-buffer-menu-map): Extract from `mouse-buffer-menu'.
	(mouse-buffer-menu): Use `mouse-buffer-menu-map'.
	* menu-bar.el (menu-bar-buffer-vector): Extract from
	`menu-bar-update-buffers'.
	(menu-bar-update-buffers): Use `menu-bar-buffer-vector'.
	(buffer-menu-open): New user command, bound globally to C-f10,
	provides a keyboard interface to `mouse-buffer-menu' (C-down-mouse-1).
	(mouse-buffer-menu-keymap): Use `menu-bar-buffer-vector' to
	convert the value returned by `mouse-buffer-menu-map' to a list
	acceptable to `popup-menu' for `buffer-menu-open'.

2014-12-18  Artur Malabarba  <bruce.connor.am@gmail.com>

	* emacs-lisp/let-alist.el (let-alist): Evaluate the `alist' argument only once.

2014-12-18  Sam Steingold  <sds@gnu.org>

	* emacs-lisp/package.el: Avoid compilation warning by declaring
	the `find-library-name' function.
	(package-activate-1): Fix the `with-demoted-errors' calls:
	the first argument must be a string literal.

2014-12-18  Martin Rudalics  <rudalics@gmx.at>

	Add code for "preserving" window sizes.
	* dired.el (dired-pop-to-buffer): Call fit-window-to-buffer with
	`preserve-size' t.
	(dired-mark-pop-up): Preserve size of window showing marked files.
	* electric.el (Electric-pop-up-window):
	* help.el (resize-temp-buffer-window): Call fit-window-to-buffer
	with `preserve-size' t.
	* minibuffer.el (minibuffer-completion-help):
	Use `resize-temp-buffer-window' instead of `fit-window-to-buffer'
	(Bug#19355).  Preserve size of completions window.
	* register.el (register-preview): Preserve size of register
	preview window.
	* tmm.el (tmm-add-prompt): Call fit-window-to-buffer
	with `preserve-size' t (Bug#1291).
	* window.el (with-displayed-buffer-window): Add calls to
	`window-preserve-size'.
	(window-min-pixel-size, window--preservable-size)
	(window-preserve-size, window-preserved-size)
	(window--preserve-size, window--min-size-ignore-p): New functions.
	(window-min-size, window-min-delta, window--resizable)
	(window--resize-this-window, split-window-below)
	(split-window-right): Amend doc-string.
	(window--min-size-1, window-sizable, window--size-fixed-1)
	(window-size-fixed-p, window--min-delta-1)
	(frame-windows-min-size, window--max-delta-1, window-resize)
	(window--resize-child-windows, window--resize-siblings)
	(enlarge-window, shrink-window, split-window): Handle preserving
	window sizes.
	(adjust-window-trailing-edge): Handle preserving window
	sizes.  Signal user-error instead of an error when there's no
	window above or below.
	(window--state-put-2): Handle horizontal scroll bars.
	(window--display-buffer): Call `preserve-size' if asked for.
	(display-buffer): Mention `preserve-size' alist member in doc-string.
	(fit-window-to-buffer): New argument PRESERVE-SIZE.
	* textmodes/ispell.el (ispell-command-loop): Suppress horizontal
	scroll bar on ispell's windows.  Don't count window lines and
	don't deal with dedicated windows.
	(ispell-show-choices, ispell-help): Let `ispell-display-buffer'
	do the window handling.
	(ispell-adjusted-window-height, ispell-overlay-window): Remove.
	(ispell-display-buffer): New function to reuse, create and fit
	window to ispell's buffers.  (Bug#3413)

2014-12-18  Dmitry Gutov  <dgutov@yandex.ru>

	* emacs-lisp/package.el (package-activate): Do not re-activate or
	reload the dependencies (bug#19390).

2014-12-18  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/cc-cmds.el (c-subword-mode): Alias to subword-mode.
	(c-update-modeline):
	* progmodes/cc-langs.el (c-mode-menu): Use c-subword-mode.
	* progmodes/cc-mode.el (subword-mode): Move autoload to cc-cmds.el.
	(c-mode-base-map): Use c-subword-mode.

2014-12-18  Eli Zaretskii  <eliz@gnu.org>

	* international/mule-diag.el (describe-font-internal):
	Display additional info returned by font-info.

	* linum.el (linum--face-width): Rename from linum--face-height,
	and use the new functionality of font-info.
	(linum-update-window): Use linum--face-width and frame-char-width,
	instead of approximating with height.

2014-12-18  Dmitry Gutov  <dgutov@yandex.ru>

	* vc/vc-svn.el (vc-svn-dir-status-files): Revert the 2014-12-02
	change (bug#19387).  Use `apply' on `vc-dir-command'  (bug#19405).

	* emacs-lisp/package.el (package-activate-1): Add RELOAD argument
	and a docstring.
	(package-activate): Call itself on dependencies on PACKAGE with
	the same FORCE argument.  Pass FORCE as RELOAD into
	`package-activate-1'  (bug#19390).

2014-12-17  Sam Steingold  <sds@gnu.org>

	* emacs-lisp/package.el (package--list-loaded-files):
	Handle `(nil ...)' elements in `load-history'.

2014-12-17  Teodor Zlatanov  <tzz@lifelogs.com>

	* net/tramp-sh.el (tramp-histfile-override): New variable.
	(tramp-open-shell, tramp-maybe-open-connection): Use it.

2014-12-17  Dmitry Gutov  <dgutov@yandex.ru>

	* vc/vc.el: Improve `dir-status-files' description.

	* emacs-lisp/package.el (package--list-loaded-files): Don't call
	file-truename on load-history elements (bug#19390).

2014-12-16  Nicolas Petton  <petton.nicolas@gmail.com>

	* emacs-lisp/seq.el: New file.

2014-12-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	* jit-lock.el (jit-lock-function): Don't defer if jit-lock-defer-time
	is 0 and there is no input pending.

2014-12-15  Juri Linkov  <juri@linkov.net>

	* replace.el (query-replace-read-from): Use query-replace-compile-replacement
	only on the return value (bug#19383).

2014-12-15  Juri Linkov  <juri@linkov.net>

	* isearch.el (isearch-lazy-highlight-search): Extend the bound of
	the wrapped search by the length of the search string to be able
	to lazy-highlight the whole search string at point (bug#19353).

2014-12-15  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/shr.el (shr-fold-text): Don't bug out on zero-length text.

2014-12-14  Alan Mackenzie  <acm@muc.de>

	* cus-start.el (all): Add fast-but-imprecise-scrolling.

2014-12-14  Artur Malabarba  <bruce.connor.am@gmail.com>

	* emacs-lisp/let-alist.el: Add lexical binding.

2014-12-14  Steve Purcell  <steve@sanityinc.com>  (tiny change)

	* emacs-lisp/package.el (package-menu-mode): Use an extra column
	for the "Version" column, to accommodate date-and-time-based versions.

2014-12-14  Cameron Desautels  <camdez@gmail.com>

	* cus-edit.el (custom-unsaved-options): New function, extracted
	from `customize-unsaved'.
	(custom-unsaved): Use it.
	(custom-prompt-customize-unsaved-options): New function.
	(Bug#19328)

2014-12-14  Dmitry Gutov  <dgutov@yandex.ru>

	* fringe.el (fringe-bitmap-p): Fix 2014-12-05 breakage.

2014-12-14  Dmitry Gutov  <dgutov@yandex.ru>

	Move ASYNC argument to the `diff' VC command to the fifth
	position, for better compatibility with existing third-party code,
	and document it.

	* vc/vc.el (vc-diff-internal): Pass `async' argument to the
	backend `diff' command in the last position.

	* vc/vc-svn.el (vc-svn-diff):
	* vc/vc-src.el (vc-src-diff):
	* vc/vc-sccs.el (vc-sccs-diff):
	* vc/vc-rcs.el (vc-rcs-diff):
	* vc/vc-mtn.el (vc-mtn-diff):
	* vc/vc-hg.el (vc-hg-diff):
	* vc/vc-git.el (vc-git-diff):
	* vc/vc-dav.el (vc-dav-diff):
	* vc/vc-cvs.el (vc-cvs-diff):
	* vc/vc-bzr.el (vc-bzr-diff):
	* obsolete/vc-arch.el (vc-arch-diff): Move ASYNC argument to the end.

2014-12-14  Paul Eggert  <eggert@cs.ucla.edu>

	* emacs-lisp/cconv.el (cconv--analyze-use):
	Rename from cconv--analyse-use.
	(cconv--analyze-function): Rename from cconv--analyse-function.
	(cconv-analyze-form): Rename from cconv-analyse-form.

2014-12-13  Andreas Schwab  <schwab@linux-m68k.org>

	* net/shr.el (shr-next-link): Don't error out at eob.

2014-12-05  Nicolas Richard  <theonewiththeevillook@yahoo.fr>

	* isearch.el (isearch-open-necessary-overlays): Open overlay
	ending at point (bug#19333).

2014-12-13  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/shr.el (shr-fold-text): New function.
	(shr-show-alt-text, shr-urlify, shr-tag-img): Use it to fold long
	alt/title texts.
	(shr-fold-text): Inhibit state from being altered.

	* files.el (directory-files-recursively): Really check whether
	files are symlinks.
	(directory-name-p): New function.
	(directory-files-recursively): Use it.

2014-12-13  Artur Malabarba  <bruce.connor.am@gmail.com>

	* emacs-lisp/package.el (package--list-loaded-files): New function
	to list files in a given directory which correspond to already
	loaded files.
	(package-activate-1): Reload files given by `package--list-loaded-files'.
	Fix bug#10125, bug#18443, and bug#18448.

2014-12-13  Eric S. Raymond  <esr@snark.thyrsus.com>

	* vc/vc-svn.el (vc-svn-diff): Fix bug #19312.

2014-12-13  Michael Albinus  <michael.albinus@gmx.de>

	* simple.el (password-word-equivalents): Add "passcode", used for
	numeric secrets like PINs or RSA tokens.

2014-12-13  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp-sh.el (tramp-get-remote-path): Use a login shell in
	order to determine `tramp-own-remote-path'.

2014-12-13  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	* progmodes/python.el (python-shell-parse-command):
	Quote `python-shell-interpreter`.  (Bug#19289)

2014-12-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/python.el (python-indent-line): Use `noindent' in strings.
	(python-indent-levels): Document extra value.
	(python-indent-calculate-indentation): Return `noindent' in strings.
	(python-indent-post-self-insert-function)
	(python-indent-calculate-levels): Handle new value.

2014-12-12  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/network-stream.el (network-stream-open-starttls): No need to
	check for the availability of `gnutls-available-p'.

	* files.el (directory-files-recursively): Don't follow symlinks to
	other directories.

2014-12-12  Eric S. Raymond  <esr@snark.thyrsus.com>

	* vc/vc-dav.el, vc/vc-git.el, vc/vc-hg.el, vc/vc-src.el:
	* vc/vc.el: latest-on-branch-p is no longer a public method.

	* vc/vc.el, vc/vc-hg.el, vc/vc-git.el, vc/vc-hooks.el:
	* vc/vc-mtn.el, vc/vc-rcs.el, vc/vc-sccs.el, vc/vc-src.el:
	Remove `rollback' method, to be replaced in the future by uncommit.

2014-12-11  Michael Albinus  <michael.albinus@gmx.de>

	* vc/vc-hg.el (vc-hg-state): Make FILE absolute.  Handle the case
	that there is empty output.

2014-12-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/eldoc.el (eldoc-documentation-function): Change default.
	(eldoc-mode, eldoc-schedule-timer): Adjust to new default.

2014-12-10  Artur Malabarba  <bruce.connor.am@gmail.com>

	* emacs-lisp/let-alist.el: Add new package and macro.

2014-12-10  Eric S. Raymond  <esr@snark.thyrsus.com>

	* vc/vc-dispatcher.el, vc/vc-hooks.el, vc/vc-rcs.el:
	* vc/vc-sccs.el, vc/vc.el: Righteous featurectomy of vc-keep-workfiles,
	it's a shoot-self-in-foot archaism.  Workfiles are always kept.

2014-12-10  Rasmus Pank Roulund  <emacs@pank.eu>

	* net/ange-ftp.el (ange-ftp-switches-ok): Disallow flags causing
	trouble with ls over ftp.  These flags result in ls returning no
	output, causing Tramp-breakage.  (bug#19192)

2014-12-10  Andreas Schwab  <schwab@suse.de>

	* files.el (file-tree-walk): Use file-name-as-directory unconditionally.

2014-12-10  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* files.el (directory-files-recursively):
	Use `file-name-all-completions' instead of `directory-files' for
	greater speed.

	* net/shr.el (shr-tag-object): Don't bug out on text elements in
	<object>.

2014-12-09  Bozhidar Batsov  <bozhidar@batsov.com>

	* progmodes/ruby-mode.el (auto-mode-alist): Add .rabl, Berksfile
	and Puppetfile.
	(ruby-toggle-string-quotes): New command that allows you to quickly
	toggle between single-quoted and double-quoted string literals.

2014-12-09  Eric S. Raymond  <esr@snark.thyrsus.com>

	* vc/vc-src.el (vc-src-do-comand): Prepend -- to file argument
	list, avoids problems witt names containing hyphens.

2014-12-09  Wilson Snyder  <wsnyder@wsnyder.org>

	Sync with upstream verilog-mode revision aa4b777.
	* progmodes/verilog-mode.el (verilog-mode-version): Update.
	(verilog-auto-end-comment-lines-re, verilog-end-block-ordered-re)
	(verilog-set-auto-endcomments): Automatically comment property/
	endproperty blocks to match other similar blocks like sequence/
	endsequence, function/endfunction, etc.  Reported by Alex Reed.
	(verilog-set-auto-endcomments): Fix end comments for functions of
	type void, etc.  Detect the function- or task-name when
	auto-commenting blocks that lack an explicit portlist.
	Reported by Alex Reed.
	(verilog-nameable-item-re): Fix nameable items that can have an
	end-identifier to include endchecker, endgroup, endprogram,
	endproperty, and endsequence.  Reported by Alex Reed.
	(verilog-preprocessor-re, verilog-beg-of-statement):
	Fix indentation of property/endproperty around pre-processor
	directives.  Reported by Alex Reed.
	(verilog-label-be): When auto-commenting a buffer, consider
	auto-comments on all known keywords (not just a subset thereof).
	Reported by Alex Reed.
	(verilog-beg-of-statement): Fix labeling do-while blocks, bug842.
	Reported by Alex Reed.
	(verilog-beg-of-statement-1, verilog-at-constraint-p):
	Fix hanging with many curly-bracket pairs, bug663.
	(verilog-do-indent): Fix electric tab deleting form-feeds.
	Note caused by indent-line-to deleting tabls pre 24.5.
	(verilog-auto-output, verilog-auto-input, verilog-auto-inout)
	(verilog-auto-inout-module, verilog-auto-inout-in): Doc fixes.
	(verilog-read-always-signals, verilog-auto-sense-sigs)
	(verilog-auto-reset): Fix AUTORESET with always_comb and always_latch,
	bug844.  Reported by Greg Hilton.

2014-12-09  Alex Reed  <acreed4@gmail.com>  (tiny change)

	* progmodes/verilog-mode.el (verilog-no-indent-begin-re):
	Fix `verilog-indent-begin-after-if' nil not honoring 'forever',
	'foreach', and 'do' keywords.
	(verilog-endcomment-reason-re, verilog-beg-of-statement):
	Fix labeling do-while blocks, bug842.
	(verilog-backward-token): Fix indenting sensitivity lists with
	named events, bug840.

2014-12-09  Reto Zimmermann  <reto@gnu.org>

	Sync with upstream vhdl mode v3.36.1.
	* progmodes/vhdl-mode.el (vhdl-version, vhdl-time-stamp): Update.
	(vhdl-compiler-alist): Anchor all error regexps.
	(vhdl-compile-use-local-error-regexp): Change default to nil.
	(vhdl-asort, vhdl-anot-head-p): Remove.
	(vhdl-aput, vhdl-adelete, vhdl-aget): Simplify.
	Remove optional argument of vhdl-aget and update all callers.
	(vhdl-import-project): Also set `vhdl-compiler'.

2014-12-09  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* files.el (find-files): New function.

	* net/shr.el (shr-dom-print): Don't print comments.
	(shr-tag-svg): Give inline SVG images the right type.

	* net/eww.el (eww-update-header-line-format): Mark valid/invalid
	certificates in the header line.
	(eww-invalid-certificate, eww-valid-certificate): New faces.

2014-12-09  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	* progmodes/python.el (inferior-python-mode):
	Set `comint-prompt-read-only` to `t` only locally.

2014-12-08  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/nsm.el (nsm-check-protocol): Test for RC4 on `high'.
	(nsm-format-certificate): Include more data about the connection.
	(nsm-query): Fill the text to that it looks nicer.
	(nsm-check-protocol): Also warn if using SSL3 or older.

2014-12-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/gud.el (gud-gdb-completions): Remove unused var `start'.

	* obsolete/gulp.el (gulp-create-m-p-alist): Remove unused var `mnt-tm'.

	* net/tramp.el (tramp-handle-make-symbolic-link): Mark unused arg.

	* info.el (Info-mode-map): Remove left-over binding.

	* emacs-lisp/avl-tree.el: Use lexical-binding and cl-lib.
	(avl-tree--root): Remove redundant defsetf.

2014-12-08  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/nsm.el (network-security-level): Remove the detailed
	description, which was already outdated, and refer the users to
	the manual.
	(nsm-check-protocol): Check for weak Diffie-Hellman prime bits
	(bug#19153).

2014-12-06  Andrey Kotlarski  <m00naticus@gmail.com>

	* net/eww.el (eww-buffers-mode): New major mode.
	(eww-list-buffers, eww-buffer-select, eww-buffer-show-next)
	(eww-buffer-show-previous, eww-buffer-kill, eww-buffer-show):
	New commands/functions (bug#19131).

2014-12-08  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/gnutls.el (gnutls-negotiate): Ignore files found via
	'file-name-handler-alist' since the gnutls library can't use those
	(bug#15866).

2014-12-08  Dmitry Gutov  <dgutov@yandex.ru>

	* vc/vc-hg.el (vc-hg-dir-status-files): Only include ignores files
	when FILES is non-nil (bug#19304).

2014-12-08  Eric S. Raymond  <esr@snark.thyrsus.com>

	* vc/vc-arch.el: Move to obsolete directory so a test framework
	won't trip over bit-rot in it.  There has been no Arch snapshot
	for nine years.

2014-12-07  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el (eww-follow-link): Revert prefix behavior to
	previous behavior.
	(eww-copy-page-url): Add doc string.

2014-12-07  Ivan Shmakov  <ivan@siamics.net>

	* net/eww.el (eww): Move history recording here...
	(eww-browse-url): ... from here (bug#19253).

	* net/eww.el (eww-browse-url): Use generate-new-buffer (was:
	iterating over possible buffer names.)

2014-12-07  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el (eww-reload): Take a prefix to work locally (bug#19086).
	(eww-current-buffer): Compilation fix for bug#18550 patch.

2014-12-07  Ivan Shmakov  <ivan@siamics.net>

	* net/eww.el (eww-list-histories): Restore the history in the
	correct buffer (bug#18550).

2014-12-07  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el (eww-bookmark-prepare): Display URLs in first by
	displaying shortened titles first (bug#16398).

2014-12-07  Tom Willemse  <tom@ryuslash.org>  (tiny change)

	* progmodes/python.el: Recognize docstrings.
	(python-docstring-at-p, python-font-lock-syntactic-face-function):
	New functions.
	(python-mode): Use them.

2014-12-06  Ulf Jasper  <ulf.jasper@web.de>

	* net/newst-treeview.el (newsticker--treeview-list-add-item)
	(newsticker--treeview-propertize-tag): Bind tree menu to mouse-3.
	(newsticker--treeview-create-groups-menu)
	(newsticker--treeview-create-tree-menu): Remove.
	(newsticker--treeview-tree-open-menu): New.
	(newsticker-treeview-tree-click): Pass event to
	`newsticker-treeview-tree-do-click'.
	(newsticker-treeview-tree-do-click): Open treemenu on mouse-3.

2014-12-05  Juri Linkov  <juri@linkov.net>

	* comint.el (comint-history-isearch-search)
	(comint-history-isearch-wrap): Use field-beginning instead of
	comint-line-beginning-position.
	(comint-send-input): Go to the end of the field instead of the end
	of the line to accept whole multi-line input.
	https://lists.gnu.org/r/emacs-devel/2014-12/msg00305.html

2014-12-05  Juri Linkov  <juri@linkov.net>

	* minibuffer.el (minibuffer-completion-help):
	Compare selected-window with minibuffer-window to check whether
	completions should be displayed near the minibuffer.  (Bug#17809)
	https://lists.gnu.org/r/emacs-devel/2014-12/msg00311.html

2014-12-05  Michael Albinus  <michael.albinus@gmx.de>

	* vc/vc-mtn.el (vc-mtn-root):
	* vc/vc-svn.el (vc-svn-registered): Make FILE absolute.

2014-12-05  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/sh-script.el (sh-smie-sh-rules): Go back to the beginning
	of the whole pipe when indenting an opening keyword after a |.
	Generalize this treatment to opening keywords like "while" (bug#18031).

2014-12-05  Stefan Monnier  <monnier@iro.umontreal.ca>

	* simple.el (newline): Place the hook buffer-locally,
	to make sure it's first.

	* progmodes/prog-mode.el (prettify-symbols--compose-symbol):
	Fix handling of symbols with different syntax at beginning/end or with
	symbol rather than word syntax.

2014-12-05  Eli Zaretskii  <eliz@gnu.org>

	* simple.el (line-move): If noninteractive, call line-move-1, not
	forward-line, since the former is compatible with line-move-visual
	both in terms of the column to which it moves and the return
	value.  (Bug#19211)

2014-12-05  Stefan Monnier  <monnier@iro.umontreal.ca>

	* vc/ediff-init.el (ediff-odd-p): Remove.
	(ediff-background-face): Use cl-oddp instead.
	(ediff-buffer-live-p): Make it a defsubst.

	* tooltip.el (tooltip-region-active-p): Remove.

	* net/shr.el (shr-char-breakable-p, shr-char-kinsoku-bol-p)
	(shr-char-kinsoku-eol-p, shr-char-nospace-p): Use define-inline.

	* fringe.el (fringe-bitmap-p): Make it a plain function.

	* emacs-lisp/eieio-core.el: Prefer inlinable functions over macros.
	(class-p, generic-p, eieio-object-p, class-abstract-p):
	Make them defsubst, so as to avoid corner case problems where
	the arg might be evaluated in the condition-case, or it can't be passed
	to higher-order functions like `cl-some'.

2014-12-05  Nicolas Richard  <theonewiththeevillook@yahoo.fr>

	* wid-edit.el (widget-choose): Let numeric keypad work (bug#19268)
	and remove old menu-related code.

2014-12-05  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el (eww-display-pdf): Let mailcap determine how to
	display PDF files (bug#19270).

2014-12-05  Juri Linkov  <juri@linkov.net>

	Compare with the most recent window by default.
	* vc/compare-w.el (compare-windows-get-window-function): New defcustom.
	(compare-windows-get-recent-window)
	(compare-windows-get-next-window): New functions.
	(compare-windows, compare-windows-sync-default-function):
	Use `compare-windows-get-window-function' instead of `next-window'.
	(compare-windows): Add diff/match messages with region boundaries.
	(Bug#19170)

2014-12-04  Stefan Monnier  <monnier@iro.umontreal.ca>

	* subr.el (filter): Remove.  Use `cl-remove-if-not' or `seq-filter'.

2014-12-04  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/shr.el (shr--extract-best-source): Ignore non-text children.

2014-12-04  Eli Zaretskii  <eliz@gnu.org>

	Implement copying of a buffer portion while preserving visual order.
	* simple.el (bidi-directional-controls-chars)
	(bidi-directional-non-controls-chars): New variables.
	(squeeze-bidi-context-1, squeeze-bidi-context)
	(line-substring-with-bidi-context)
	(buffer-substring-with-bidi-context): New functions.

	* files.el (file-tree-walk): Doc fix.

2014-12-04  Rupert Swarbrick  <ruperts@broadcom.com> (tiny change)
	    Rüdiger Sonderfeld  <ruediger@c-plusplus.net>

	* autoinsert.el (auto-insert-alist): Update C/C++ header and
	program support to match more extensions.  Replace non-alnum
	characters when generating include guards (headers) and check for
	more extensions when generating includes (programs)
	(bug#19254).

2014-12-03  Eric S. Raymond  <esr@snark.thyrsus.com>

	* files.el (file-tree-walk): Fix docstring.

2014-12-03  Karl Fogel  <kfogel@red-bean.com>

	Fix bug whereby saving files hung in VC hook.

	Saving a buffer visiting a file under SVN control would hang if
	the remote repository were unreachable, because the VC hooks tried
	to run "svn status -u" on the file, where the "-u" tells svn to
	get update information from the remote repository.
	https://lists.gnu.org/r/emacs-devel/2014-12/msg00174.html

	* vc/vc-svn.el (vc-svn-state): Remove optional `localp'
	argument and always pass "-v" to "svn status", never "-u".

2014-12-03  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/inline.el: Fix up copyright header.
	(inline-quote, inline-const-p, inline-const-val, inline-error):
	Silence compiler warnings.
	(inline-letevals): Fix edebug spec.
	(inline--testconst-p): Consider lambda expressions as const-p.
	(inline--getconst-val): Use inline--testconst-p.

	* minibuffer.el (completion-table-dynamic): Add arg `switch-buffer'
	and change default to stay in the minibuffer when called from
	the minibuffer (bug#19250).
	(lazy-completion-table): Use this new argument to preserve the
	old behavior.

	* progmodes/elisp-mode.el (elisp--local-variables): Don't burp on
	incorrect lexical elements (bug#19250).

2014-12-03  A. N. Other  <none@example.com>

	* files.el (file-tree-walk): Lisp translation of ANSI ftw(3).

2014-12-02  Glenn Morris  <rgm@gnu.org>

	* whitespace.el (whitespace-big-indent-regexp): Add :version.

2014-12-02  Eric S. Raymond  <esr@snark.thyrsus.com>

	* subr.el (filter): New macro.  Because it's just silly for a Lisp
	not to have this in 2014.  And VC needs it.

	* vc.el: All backends: API simplification: Abolish dir-status.
	It's replaced by dir-status-files.

	* vc.el: All backends: API simplification: Remove 4th
	'default-state' argument from vc-dir-status files and its backend
	methods - no backend method ever set it.  It was used only in the
	fallback method to set a default of 'up-to-date, though a
	convoluted call chain obscured this.

	* vc-hooks.el: Bind vc-delete-file to Ctrl-x v delete.

	* vc.el (vc-expand-dirs): Now takes a second BACKEND argument,
	improving behavior on directories using multiple file-oriented VCSes.

	* vc/vc.el: All backends: API simplification; clear-headers
	is no longer a public method.  It is now local to the one place
	it's used, in the RCS steal-lock method.

2014-12-01  Eric S. Raymond  <esr@snark.thyrsus.com>

	* vc/vc.el: In all backends: API simplification; could-register
	is no longer a public method.  (vc-cvs.el still has a private
	implementation.)

	* vc/vc.el: In all backends: API cleanup; the backend diff method
	takes an explicit async flag.  This eliminates a particularly ugly
	global.

	* vc-bzr.el: Restore vc-bzr-state-heuristic as a private method.
	VC randomly/unpredictably fails without it; cause not yet established.

2014-12-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	Merge some of the differences from the standalone CC-mode.
	The main change is to only use the `category' text-property only when
	available.  For that many calls are changed to use c-get-char-property,
	c-next-single-property-change, c-sc-scan-lists,
	c-sc-parse-partial-sexp, c-unmark-<->-as-paren.

	* progmodes/cc-mode.el (c-just-done-before-change): New var.
	(c-basic-common-init): Initialize it.
	(c-common-init): Only use mode-require-final-newline when available.
	(c-before-change): Check and set c-just-done-before-change.
	(c-after-change): Re-set c-just-done-before-change.
	(c-advise-fl-for-region): New macro.
	(lazy-lock-defer-rest-after-change, lazy-lock-defer-line-after-change)
	(font-lock-after-change-function, jit-lock-after-change):
	Advise if needed.

	* progmodes/cc-langs.el (c-modified-constant): New lang var.
	(c-known-type-key): Don't make a list just to throw it away.

	* progmodes/cc-engine.el (c-invalidate-state-cache, c-parse-state):
	Handle the case where categories are not available.
	(c-record-parse-state-state, c-replay-parse-state-state):
	Handle marker values.
	(c-before-change-check-<>-operators): Look for the `syntax-table'
	property rather than for the corresponding `category'.
	(c-looking-at-decl-block): Remove unused var
	`c-disallow-comma-in-<>-arglists'.
	(c-forward-<>-arglist-recur): Remove unused var
	`orig-record-found-types'.

	* progmodes/cc-defs.el (c-version): Bump up to 5.33.
	(c-use-category): New const.
	(c-next-single-property-change): New macro.
	(c-region-is-active-p): Prefer region-active-p when available.
	(c-search-backward-char-property): Fix old min/max typo; probably
	a copy/paste error.
	(c-mark-<-as-paren, c-mark->-as-paren, c-unmark-<->-as-paren):
	Turn them into macros that obey c-use-category.
	(c-sc-scan-lists-no-category+1+1, c-sc-scan-lists-no-category+1-1)
	(c-sc-scan-lists-no-category-1+1, c-sc-scan-lists-no-category-1-1)
	(c-sc-scan-lists, c-sc-parse-partial-sexp)
	(c-looking-at-non-alphnumspace): New macros.
	(c-sc-parse-partial-sexp-no-category): New function.
	(c-emacs-features): Add `category-properties' element.

	* progmodes/cc-cmds.el (c-forward-into-nomenclature)
	(c-backward-into-nomenclature): Use cc-subword if subword-mode is
	not available.
	(c-beginning-of-defun, c-end-of-defun, c-mark-function)
	(c-indent-line-or-region): Use c-region-is-active-p.

	* progmodes/cc-bytecomp.el (cc-bytecomp-unbound-variables)
	(cc-bytecomp-original-functions, cc-bytecomp-original-properties)
	(cc-bytecomp-loaded-files): Re-set each time the file is loaded.
	(cc-bytecomp-obsolete-var, cc-bytecomp-ignore-obsolete)
	(cc-bytecomp-obsolete-fun): Delete unused functions.

	* progmodes/cc-align.el (c-lineup-respect-col-0): New function.

2014-12-01  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/shr.el (shr-dom-print): Fix up `shr-dom-print' after the
	dom.el changes.

2014-12-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	* vc/vc.el (vc-find-conflicted-file): Look for conflicted files in the
	current "project" rather than just the current directory.
	* vc/vc-git.el (vc-git-conflicted-files): Clarify in which directory
	the file names make sense.

	* vc/smerge-mode.el (smerge-swap): New command.

	* vc/diff-mode.el (diff-kill-applied-hunks): New command.

2014-12-01  Ulf Jasper  <ulf.jasper@web.de>

	* net/newst-treeview.el (newsticker--treeview-item-show):
	Check window liveliness before measuring its width.

	* net/newst-backend.el (newsticker--get-news-by-url-callback):
	Pass correct status to `newsticker--sentinel-work'.
	(newsticker--sentinel-work): Use "newsticker--download-error" as
	guid in order to prevent multiple "Could not download..."
	messages.  (Bug#19166)

2014-12-01  Ivan Shmakov  <ivan@siamics.net>

	* net/eww.el (eww-render): Call `eww-after-render-hook' in the
	correct buffer (bug#19225).

2014-12-01  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/nsm.el (network-security-level): Change the default to `medium'.

	* net/eww.el (eww): Leave point in a place that doesn't cause
	scrolling when displaying "Loading...".

2014-12-01  Eric S. Raymond  <esr@snark.thyrsus.com>

	* vc/vc.el, vc/vc-cvs.el, vc/vc-rcs.el, vc/vc-svn.el: The 'merge'
	backend method of RCS/CVS/SVN is now 'merge-file', to contrast with
	'merge-branch'.  Prompting for merge revisions is pushed down to
	the back ends; this fixes a layering violation that caused bad
	behavior with SVN.

	* vc/vc.el, vc-hooks.el: All backends: API simplification;
	vc-stay-local-p and repository-hostname are no longer public
	methods.  Only the CVS and SVN backends used these, and the SVN
	support was conditioned out because svn status -v is too slow.
	The CVS back end retains this machinery and the vc-stay-local
	configuration variable now only affects it.

2014-12-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/inline.el: New file.

2014-12-01  Eric S. Raymond  <esr@snark.thyrsus.com>

	* vc/vc.el, vc-hooks.el: All backends: API simplification;
	vc-state-heuristic is no longer a public method, having been
	removed where it is redundant, unnecessary, or known buggy.
	This eliminated all backends except CVS.  Eliminates bug#7850.

	* vc/vc-cvs.el, vc/vc-hooks.el, vc/vc-rcs.el, vc/vc-sccs.el:
	Eliminate vc-mistrust-permissions.  It was only relevant to the
	RCS and SCCS back ends and defaulted to t.  Code now always
	mistrusts permissions - by actual measurement the effect on
	performance is negligible.  As a side effect bug#11490 is now
	irrelevant.

	* vc/vc.el, vc-hooks.el: All backends: API simplification;
	vc-workfile-unchanged-p is no longer a public method (but the RCS
	and SCCS back ends retain it as a private method used in state
	computation).  This method was redundant with vc-state and usually
	implemented as a trivial call to same.  Fixes the failure mode
	described in bug#694.

	* vc/vc.el: All backends: API simplification; init-revision is
	gone, and vc-registered functions no longer take an
	initial-revision argument.

2014-11-29  Glenn Morris  <rgm@gnu.org>

	* vc/vc-src.el (vc-src, vc-src-diff-switches)
	(vc-src-master-templates): Fix :version tags.

2014-11-29  Paul Rankin  <paul@tilk.co>  (tiny change)

	* outline.el (outline-move-subtree-down): Refactor and improve code.

2014-11-29  Stephen Berman  <stephen.berman@gmx.net>
	    Stefan Monnier  <monnier@iro.umontreal.ca>

	* outline.el (outline-move-subtree-down): Make sure we can move
	forward to find the end of the subtree and the insertion point
	(bug#19102).

2014-11-29  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	* progmodes/python.el (python-shell-completion-setup-code):
	Use __builtin__ module (or builtins in Python 3) and catch all errors
	when importing readline and rlcompleter.

2014-11-29  Stephen Berman  <stephen.berman@gmx.net>

	* calendar/todo-mode.el: Handle calling revert-buffer (bug#19187).
	(todo-revert-buffer): New function.
	(todo-modes-set-1): Use it as the buffer-local value of
	revert-buffer-function.

2014-11-29  Stephen Berman  <stephen.berman@gmx.net>

	* calendar/todo-mode.el (todo-mode): If called interactively, just
	display a message saying to call todo-show to enter Todo mode
	(Bug#19112).

2014-11-29  Dmitry Gutov  <dgutov@yandex.ru>

	* vc/vc-hg.el (vc-hg-dir-status-files): Include ignored files.
	(Bug#18579)

	* vc/vc-bzr.el (vc-bzr-after-dir-status): Don't skip ignored
	files.  (Bug#18579)

2014-11-29  Michael Albinus  <michael.albinus@gmx.de>

	* textmodes/makeinfo.el (makeinfo-buffer): Make it work also for
	remote `buffer-file-name'.

2014-11-29  Leo Liu  <sdl.web@gmail.com>

	* calendar/diary-lib.el (calendar-mark-1): Fix thinko.

2014-11-29  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	Set PYTHONUNBUFFERED on shell startup.

	* progmodes/python.el (python-shell-unbuffered): New var.
	(python-shell-calculate-process-environment): Use it.

2014-11-29  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp.el (tramp-action-password): Clean password on subsequent
	attempts even if there was no wrong password indication.  (Bug#19047)

	* net/tramp-sh.el (tramp-get-remote-locale): Return "LC_ALL=C" as
	fallback.
	(tramp-open-connection-setup-interactive-shell): No need to check
	for nil as `tramp-get-remote-locale' return value.

2014-11-29  Eli Zaretskii  <eliz@gnu.org>

	* vc/vc-git.el (vc-git-command, vc-git--call):
	Bind coding-system-for-read and coding-system-for-write to
	vc-git-commits-coding-system.
	(vc-git-previous-revision): Use "~1" instead of "^", since the
	latter is a special character for MS-Windows system shells.

2014-11-29  Michael Albinus  <michael.albinus@gmx.de>

	Improve XEmacs compatibility.

	* net/tramp.el (tramp-autoload-file-name-handler):
	Wrap `temporary-file-directory' by `symbol-value', it doesn't
	exist in XEmacs.
	(tramp-read-passwd): Don't use `with-timeout-suspend' and
	`with-timeout-unsuspend' if they don't exist, like in XEmacs.
	(tramp-time-less-p, tramp-time-subtract): Remove functions.
	(tramp-handle-file-newer-than-file-p, tramp-time-diff):
	* net/tramp-adb.el (tramp-adb-ls-output-time-less-p):
	* net/tramp-cache.el (tramp-get-file-property):
	* net/tramp-smb.el (tramp-smb-handle-insert-directory):
	Use `time-less-p' and `time-subtract, respectively.

	* net/tramp-adb.el (top): Do not require time-date.el.

	* net/tramp-compat.el (top): Require time-date.el for XEmacs.

	* net/tramp-sh.el (tramp-open-connection-setup-interactive-shell):
	Check, whether `utf-8' is a valid coding system.

2014-11-29  Eli Zaretskii  <eliz@gnu.org>

	* vc/vc.el (vc-retrieve-tag): Doc fix.

2014-11-28  Stefan Monnier  <monnier@iro.umontreal.ca>

	* simple.el (execute-extended-command--shorter): Fix the "M-p" case
	(bug#19152).

2014-11-28  Martin Rudalics  <rudalics@gmx.at>

	Fix two issues around help-window-select.  (Bug#11039) (Bug#19012)
	* help.el (help-window-old-frame): New variable.
	(help-window-select): Default to nil (Bug#11039).
	Rewrite doc-string.
	(help-window-setup): When the help window appears on another
	frame and `help-window-select' is non-nil, give that frame input
	focus too (Bug#19012).
	(with-help-window): Store selected frame in
	help-window-old-frame.

2014-11-28  Ulf Jasper  <ulf.jasper@web.de>

	* net/newst-treeview.el (newsticker--treeview-load): Take care of
	nil value for `newsticker-groups-filename'.

2014-11-28  Daiki Ueno  <ueno@gnu.org>

	* epa.el (epa-sign-file, epa-encrypt-file, epa-decrypt-region)
	(epa-sign-region, epa-encrypt-region):
	Use `epg-context-set-{passphrase,progress}-callback', instead of
	`setf'.  This partially reverts commit 9e48a95c (bug#19150).
	Reported by José A. Romero L.

2014-11-27  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el (eww-restore-history):
	Bind `inhibit-modification-hooks' instead of `after-change-functions'.

2014-11-27  Ulf Jasper  <ulf.jasper@web.de>

	* net/newst-backend.el (newsticker--parse-atom-1.0):
	Handle embedded (x)html in summary node.

2014-11-27  Sam Steingold  <sds@gnu.org>

	* menu-bar.el (menu-bar-open): When everything else fails,
	use (mouse-menu-bar-map).

2014-11-27  Ulf Jasper  <ulf.jasper@web.de>

	* net/newst-treeview.el (newsticker-groups-filename):
	Change default value to nil.  Point out that variable is obsolete in doc
	string.
	(newsticker--treeview-load): Change wording of the questions the
	user is asked when `newsticker-groups-filename' is found to be
	used and we offer to read and remove the groups file.  (Bug#19165)

2014-11-27  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el (eww): Record the new URL immediately, so that if the
	HTTP fetch fails, we have the right URL in the buffer.
	(eww-process-text-input): Don't shorten the input field if
	deleting at the last character (bug#19085).
	(eww-restore-history): Inhibit change functions while restoring
	the history.
	(eww-process-text-input): Fix deletion at the start of the field, too.
	(eww-mode): Revert mistanken removal of `buffer-disable-undo'.
	(eww-process-text-input): Try to keep track of the size more reliably.

	* dom.el (dom-pp): New function.

2014-11-27  Eli Zaretskii  <eliz@gnu.org>

	* vc/vc-bzr.el (vc-bzr-print-log, vc-bzr-expanded-log-entry):
	Don't assume --long is the default for "bzr log", always specify
	it explicitly, in case the user defined an alias for 'log' that
	uses some other format.

2014-11-27  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	* progmodes/python.el (python-eldoc--get-doc-at-point):
	Strip shell output before returning.  (bug#18794)

2014-11-27  Dmitry Gutov  <dgutov@yandex.ru>

	Fix indentation before `!=' and after `+='.  Originally reported
	in https://github.com/mooz/js2-mode/issues/174.
	* progmodes/js.el (js--indent-operator-re): Make assignments and
	(in)equality operator a separate case.
	(js--continued-expression-p): Escape the second `+' in the regexp.

2014-11-27  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.el (handle-select-window): Deactivate shift-region (bug#19003).

2014-11-26  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/nsm.el (nsm-new-fingerprint-ok-p): Display the certificate
	when querying about new certificates.

	* net/shr.el (shr-make-table-1): dom.el changes for table rendering.

	* dom.el (dom-by-tag): Use `equal' for comparisons so that tags
	can be strings.
	(dom-elements): Protect against non-text nodes.
	(dom-non-text-children): New function.

	* net/eww.el (eww-tag-title): Use `dom-text'.

2014-11-26  Sam Steingold  <sds@gnu.org>

	* textmodes/sgml-mode.el (sgml-validate-command): Pass -utf8 to tidy.

2014-11-26  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el (eww-highest-readability): More dom.el fixes.

2014-11-26  Ulf Jasper  <ulf.jasper@web.de>

	* net/newst-backend.el (newsticker--parse-generic-items):
	Take care of UIDs when adding elements to cache.

2014-11-26  Alan Mackenzie  <acm@muc.de>

	Remove spurious reference to symbol category_properties.
	* progmodes/cc-engine.el (c-state-pp-to-literal): Fix here.

2014-11-26  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el: Use the new dom.el accessors throughout.

	* net/shr.el: Ditto.

	* dom.el: New file.

2014-11-26  Glenn Morris  <rgm@gnu.org>

	* arc-mode.el (archive-visit-single-files): Add :version.

2014-11-25  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/nsm.el (nsm-format-certificate): Don't bug out on missing
	elements.
	(nsm-warnings-ok-p): The new version of this function always
	returned nil when everything was OK.

2014-11-25  Teodor Zlatanov  <tzz@lifelogs.com>

	* net/gnutls.el (gnutls): Set :group to 'comm so it's near NSM.

	* net/nsm.el (nsm-check-tls-connection, nsm-save-host)
	(nsm-warnings-ok-p): Use `gnutls-peer-status-warning-describe'.

2014-11-20  Nicolas Richard  <theonewiththeevillook@yahoo.fr>

	* emacs-lisp/byte-run.el (function-put): Match argument names to
	docstring.

2014-11-24  Sam Steingold  <sds@gnu.org>

	* vc/vc-hooks.el (vc-directory-exclusion-list):
	Fix a trivial typo (bug#19171).

2014-11-24  Stefan Monnier  <monnier@iro.umontreal.ca>

	* vc/vc-hooks.el (vc-state-base-face): Don't override
	mode-line-inactive.

2014-11-24  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el (eww-set-character-encoding): Use `read-coding-system'.
	(eww-process-text-input): Inhibit read only so that input fields
	don't get shortened (bug#19085).

2014-11-24  Leo Liu  <sdl.web@gmail.com>

	* emacs-lisp/macroexp.el (macroexp-let2*): New macro.

	* window.el (with-temp-buffer-window)
	(with-current-buffer-window, with-displayed-buffer-window):
	* emacs-lisp/cl-macs.el (cl--compiler-macro-adjoin):
	* emacs-lisp/cl-lib.el (substring):
	* emacs-lisp/cl-extra.el (cl-getf): Use it.

2014-11-24  Eli Zaretskii  <eliz@gnu.org>

	* isearch.el (isearch-update): Don't assume
	pos-visible-in-window-p will return nil when point is hscrolled
	out of view.  (Bug#19157)

2014-11-20  Andrey Kotlarski  <m00naticus@gmail.com>

	* net/eww.el (eww-browse-url): Optionally create new eww buffer.
	(eww-follow-link): Follow in new buffer in case of prefix
	argument, open externally with double prefix (bug#19130).

2014-11-23  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el (eww-display-html): Decode the document-defined charset.
	(eww): Pop to the *eww* buffer immediately after executing the
	`M-x eww' command to avoid having buffers pop up later.
	(eww-display-html): Don't pop the *eww* buffer.
	(eww-display-raw): Ditto.
	(eww-display-image): Ditto.
	(eww-follow-link): Make going to #targets in the page work again.

2014-11-23  Ivan Shmakov  <ivan@siamics.net>

	* net/eww.el (eww-suggest-uris): New variable.
	(eww-suggested-uris): New function.
	(eww): Default to URL under point.
	(eww-links-at-point): New function.

2014-11-20  Mark Oteiza  <mvoteiza@udel.edu>  (tiny change)

	* net/eww.el (eww-add-bookmark): Fix bookmark titles.

2014-11-17  Mark Oteiza  <mvoteiza@udel.edu>  (tiny change)

	* net/eww.el (eww-mode-map): Bind backtab to shr-previous-link.

2014-11-23  Kenjiro Nakayama  <nakayamakenjiro@gmail.com>

	* net/eww.el (eww-set-character-encoding): New command and keystroke.
	(eww-display-raw): Use it (bug#16225).

2014-11-23  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/nsm.el (network-security-level): Rename from
	`nsm-security-level' and documented.

	* mail/smtpmail.el (smtpmail-via-smtp): Warn unless encrypted and
	we're sending a password.

	* net/nsm.el: New file that implements a Network Security Manager.

	* net/network-stream.el (open-network-stream): Add a new
	:warn-unless-encrypted parameter.
	(network-stream-open-plain): Allow warning unless encrypted.
	(network-stream-open-starttls): Call the Network Security Manager.
	(network-stream-open-tls): Ditto.

2014-11-23  Leo Liu  <sdl.web@gmail.com>

	* calendar/cal-china.el (calendar-chinese-from-absolute-for-diary)
	(calendar-chinese-to-absolute-for-diary)
	(calendar-chinese-mark-date-pattern, diary-chinese-anniversary):
	Handle leap months in Chinese calendar.  (Bug#18953)

2014-11-22  Alan Mackenzie  <acm@muc.de>

	Fix error with `mark-defun' and "protected:" in C++ Mode.
	* progmodes/cc-cmds.el (c-where-wrt-brace-construct): Handle a
	return code of (label) from c-beginning-of-decl-1.  (Bug#19134)

2014-11-22  Ulf Jasper  <ulf.jasper@web.de>

	* net/newst-backend.el (newsticker--sentinel-work):
	Tell `libxml-parse-xml-region' to discard comments.  (Bug#18787)

2014-11-22  Michael Albinus  <michael.albinus@gmx.de>

        * net/tramp-sh.el (tramp-sh-handle-start-file-process)
	(tramp-sh-handle-process-file): Propagate `process-environment'.

	* vc/vc-hg.el (vc-hg-state): No special handling for remote files;
	Tramp propagates environment variables now.

2014-11-22  Eric S. Raymond  <esr@snark>

	* vc/vc-filewise.el: New file to isolate code used only by the
	file-oriented back ends (SCCS/RCS/CVS/SRC) which should not
	live in vc.el and certainly not in vc-hooks.el.

	* vc/vc-hooks.el, vc-rcs.el, vc-sccs.el: vc-name  -> vc-master-name.
	This is preparatory to isolating all the 'master' functions
	used only by the file-oriented back ends.  With this done first,
	the substantive diffs will be easier to read.

2014-11-21  Rüdiger Sonderfeld  <ruediger@c-plusplus.net>

	* play/morse.el (nato-alphabet): Mark URL in docstring in a way
	that is recognized by `help-mode'.

2014-11-21  Stefan Monnier  <monnier@iro.umontreal.ca>

	* desktop.el (desktop-create-buffer): Use activate-mark to set
	`mark-active' (bug#19058).

2014-11-21  Eric S. Raymond  <esr@snark>

	* vc/vc-src.el (vc-src-state): Fix bug that produced spurious
	nil state.

2014-11-21  Eli Zaretskii  <eliz@gnu.org>

	* vc/vc.el (vc-deduce-fileset): Support invocation from
	*vc-change-log* buffer.  (Bug#19084)

2014-11-13  Matthew Leach  <matthew@mattleach.net>

	* arc-mode.el (archive-visit-single-files): New.
	(archive-mode): Visit file if archive contains a single file.
	(Bug#1702)

2014-11-21  Ulrich Müller  <ulm@gentoo.org>

	* vc/vc.el: Fix a typo in the commentary.

2014-11-20  Eric S. Raymond  <esr@snark.thyrsus.com>

	* vc/vc-src.el, vc/vc.el: Added support for SRC.  Needs more
	testing and a real log-view mode.

	* vc/vc-bzr.el, vc/vc-cvs.el, vc/vc-dav.el, vc/vc-git.el:
	* vc/vc-hg.el, vc/vc-mtn.el, vc/vc-rcs.el, vc/vc-sccs.el:
	* vc/vc-svn.el, vc/vc.el: Remove editable argument from the backend
	checkout methods; where it matters (which is only in SCCS and RCS)
	files are always checked out editable.  This may actually have
	been dynamically true already - it looks like the vc-next-action
	code evolved past visiting the other case.  Tested with RCS.

	* vc/vc-arch.el, vc/vc-bzr.el, vc/vc-cvs.el, vc/vc-dav.el:
	* vc/vc-git.el, vc/vc-hg.el, vc/vc-mtn.el, vc/vc-rcs.el:
	* vc/vc-sccs.el, vc/vc-svn.el, vc/vc.el: Remove never-used rev
	argument from the backend checkin methods.  Only the RCS, SCCS,
	and CVS back ends tried to do anything with it, and that code was
	never exercised.  Chiseling away the cruft of decades...

2014-11-19  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el (eww-render): Remove a no-op :title setting.

2014-11-19  Ivan Shmakov  <ivan@siamics.net>

	* net/eww.el (eww-history-limit): New variable.
	(eww-save-history): Use it (bug#19105).
	(eww-reload): Reload the page in the right buffer.

2014-11-19  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el (eww-desktop-misc-data): Use `cl-remove-duplicates'.

2014-11-19  Ivan Shmakov  <ivan@siamics.net>

	* net/eww.el (eww-desktop-remove-duplicates)
	(eww-restore-desktop, eww-restore-reload-prompt): New variables.
	(eww-mode): Set up desktop mode (bug#18010).
	(eww-desktop-data-save, eww-desktop-data-1)
	(eww-desktop-history-duplicate, eww-desktop-misc-data)
	(eww-restore-desktop): New functions.

2014-11-19  Eli Zaretskii  <eliz@gnu.org>

	* vc/vc.el (vc-log-internal-common): Turn on log-view-mode in the
	correct buffer.  (Bug#19101)

2014-11-19  Rüdiger Sonderfeld  <ruediger@c-plusplus.net>

	* vc/vc-git.el (vc-git-diff): Use "difftool -x diff" with
	`diff-switches' if `vc-git-diff-switches' is nil.  (Bug#19099)

2014-11-19  Artur Malabarba  <bruce.connor.am@gmail.com>

	* ido.el (ido-bury-buffer-at-head): New command.
	(ido-buffer-completion-map): Bind it to C-S-b.

2014-11-18  Juri Linkov  <juri@linkov.net>

	* simple.el (next-line-or-history-element): Wrap next-line
	in with-no-warnings.
	(previous-line-or-history-element): Wrap previous-line
	in with-no-warnings.

2014-11-18  Juri Linkov  <juri@linkov.net>

	* progmodes/grep.el (grep-compute-defaults):
	Compute grep-highlight-matches before its use.

2014-11-18  Juri Linkov  <juri@linkov.net>

	* replace.el (query-replace-from-to-separator): Turn defvar into
	defcustom.  Wrap char-displayable-p in ignore-errors because an
	attempt to autoload char-displayable-p fails during pre-loading.
	Move (propertize "\0" ... 'separator t) out of customizable part
	to query-replace-read-from.
	(query-replace-read-from): Call custom-reevaluate-setting on
	query-replace-from-to-separator to reevaluate the separator
	depending on the return value of char-displayable-p.
	https://lists.gnu.org/r/emacs-devel/2014-11/msg00466.html

2014-11-18  Juri Linkov  <juri@linkov.net>

	* bindings.el (minibuffer-local-map): Rebind [down] from
	next-history-element to next-line-or-history-element, and [up]
	from previous-history-element to previous-line-or-history-element.

	* simple.el (next-line-or-history-element)
	(previous-line-or-history-element): New commands.
	https://lists.gnu.org/r/emacs-devel/2014-11/msg00822.html

2014-11-18  Leo Liu  <sdl.web@gmail.com>

	* emacs-lisp/nadvice.el (define-advice): New macro.
	* emacs-lisp/lisp-mode.el (lisp-imenu-generic-expression):
	Add define-advice.
	(lisp-font-lock-keywords-1): Add define-advice.

2014-11-18  Daiki Ueno  <ueno@gnu.org>

	* epg.el (epg-context): New slot EDIT-CALLBACK.
	(epg--process-filter): Call EDIT-CALLBACK when editing a key.
	(epg-reset): Reset EDIT-CALLBACK of the context.
	(epg-start-edit-key): New function.
	(epg-edit-key): New function.

2014-11-18  Paul Eggert  <eggert@cs.ucla.edu>

	Port new time stamp handling to Emacs 23.2.
	This fix is for Gnus.  Reported by Katsumi Yamaoka.
	* calendar/time-date.el (time-add, time-subtract, time-less-p):
	Use eval-and-compile, not eval-when-compile.

2014-11-18  Daiki Ueno  <ueno@gnu.org>

	* epg.el (epg-context-set-passphrase-callback)
	(epg-context-set-progress-callback): Check if the CALLBACK
	argument is a function, instead of a cons.

2014-11-18  Daiki Ueno  <ueno@gnu.org>

	* epa-file.el (epa-file-insert-file-contents)
	(epa-file-write-region): Remove redundant check of
	epa-pinentry-mode.
	* epa.el (epa-sign-file, epa-encrypt-file, epa-decrypt-region)
	(epa-sign-region, epa-encrypt-region): Remove redundant check of
	epa-pinentry-mode.

2014-11-18  Daiki Ueno  <ueno@gnu.org>

	* epa-file.el (epa-file-insert-file-contents): Don't show
	"*Error*" buffer if input file does not exist.
	Reported by Herbert J. Skuhra.

2014-11-18  Paul Pogonyshev  <pogonyshev@gmail.com>
	    Rüdiger Sonderfeld  <ruediger@c-plusplus.net>

	* progmodes/cc-langs.el: Support some of the new keywords in C++11.
	An alternative version of the patch from bug#13871.
	(c-operators): Add "alignof".
	(c-primitive-type-kwds): Add "char16_t", "char32_t".
	(c-type-modifier-kwds): Add "constexpr", "noexcept".
	(c-modifier-kwds): Add "thread_local".
	(c-constant-kwds): Add "nullptr".

2014-11-17  Michal Nazarewicz  <mina86@mina86.com>

	* textmodes/tildify.el (tildify-pattern, tildify-space-string):
	New variables for specifying tildify pattern and representation of
	a hard space -- a no-break space by default -- respectively.
	Being buffer-local they are much easier to handle than
	`tildify-string-alist' and `tildify-pattern-alist' respectively
	that have been used so far.  They also works better with derived
	modes.
	(tildify-foreach-region-function): New variable specifying
	a function determining portions of buffer that should be
	tildified.  It allows major modes to create a filtering function
	more elaborate than a set of regular expressions.  Initialized to
	`tildify--deprecated-ignore-evironments' by default to handle now
	deprecated `tildify-ignored-environments-alist' variable.
	(tildify--foreach-region): A new function that takes
	`tildify-foreach-region-function' into account and calls callback
	for regions of the buffer that should be tildified.
	(tildify-foreach-ignore-environments): A new function which can be
	partially applied and used as `tildify-foreach-region-function'.
	(tildify-ignored-environments-alist, tildify-pattern)
	(tildify-string-alist, tildify--pick-alist-entry): Mark as obsolete.
	(tildify--find-env): Rename from `tildify-find-env' and mark as
	obsolete.
	(tildify--deprecated-ignore-evironments): New function,
	immediately marked as obsolete, used to handle deprecated
	`tildify-ignored-environments-alist'.

	* textmodes/tex-mode.el (tex-common-initialization):
	Set `tildify-space-string' and `tildify-foreach-region-function'
	variables in all variants of TeX mode since `tildify-string-alist'
	and `tildify-ignored-environments-alist' are now empty by default.

	* nxml/nxml-mode.el (nxml-mode): Ditto in `nxml-mode'.
	If encoding supports it use no-break space instead of character
	entity; this changes previous default which used a numeric
	reference.

	* textmodes/sgml-mode.el (sgml-mode): ditto in `sgml-mode'.
	If encoding does not support no-break space, use numeric reference;
	this changes previous default which used named entity (“&nbsp;”)
	in HTML mode.

2014-11-17  Ulf Jasper  <ulf.jasper@web.de>

	* calendar/icalendar.el (icalendar-export-alarms):
	New customizable variable.  (Bug#5433)
	(icalendar-export-region): Export alarms as specified in
	`icalendar-export-alarms'.
	(icalendar--create-ical-alarm, icalendar--do-create-ical-alarm):
	New functions for exporting alarms.

2014-11-17  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* bindings.el (search-map): Move `eww-search-words' to `M-s M-w'.

2014-11-17  Paul Eggert  <eggert@cs.ucla.edu>

	Port new time stamp handling to old Emacs and to XEmacs.
	This is needed for Gnus, which copies time-date.el and which
	runs on older Emacs implementations.
	* calendar/time-date.el (with-decoded-time-value):
	Handle 'nil' and floating-point arg more compatibly with new Emacs.
	(encode-time-value, with-decoded-time-value):
	Obsolete only if new Emacs.
	(time-add, time-subtract, time-less-p): Define if not new Emacs.

	Improve time stamp handling, and be more consistent about it.
	This implements a suggestion made in:
	https://lists.gnu.org/r/emacs-devel/2014-10/msg00587.html
	Among other things, this means timer.el no longer needs to
	autoload the time-date module.
	* allout-widgets.el (allout-elapsed-time-seconds): Doc fix.
	* arc-mode.el (archive-ar-summarize):
	* calendar/time-date.el (seconds-to-time, days-to-time, time-since):
	* emacs-lisp/timer.el (timer-relative-time, timer-event-handler)
	(run-at-time, with-timeout-suspend, with-timeout-unsuspend):
	* net/tramp.el (tramp-time-less-p, tramp-time-subtract):
	* proced.el (proced-time-lessp):
	* timezone.el (timezone-time-from-absolute):
	* type-break.el (type-break-schedule, type-break-time-sum):
	Simplify by using new functionality.
	* calendar/cal-dst.el (calendar-next-time-zone-transition):
	Do not return time values in obsolete and undocumented (HI . LO)
	format; use (HI LO) instead.
	* calendar/time-date.el (with-decoded-time-value):
	Treat 'nil' as current time.  This is mostly for XEmacs.
	(encode-time-value, with-decoded-time-value): Obsolete.
	(time-add, time-subtract, time-less-p): Use no-op autoloads, for
	XEmacs.  Define only if XEmacs, as they're now C builtins in Emacs.
	* ldefs-boot.el: Update to match new time-date.el
	* proced.el: Do not require time-date.

2014-11-16  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el (eww-mode): Make the buffer read-only.
	(eww-form-text): Inhibit read-only-ness in text input fields
	(bug#16476).

2014-11-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	* simple.el (execute-extended-command--shorter): Cut search here.
	(execute-extended-command): Instead of here.

2014-11-16  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	* progmodes/python.el (python-mode): Avoid use of set-local to
	keep Emacs 24.x compatibility.

2014-11-16  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/shr.el (shr): Move to the new defgroup `web'.

	* net/eww.el (eww): Ditto.

	* simple.el (execute-extended-command): Don't show the help
	message if the binding isn't significantly shorter than the
	M-x command the user typed (bug#19013).

2014-11-16  Ulf Jasper  <ulf.jasper@web.de>

	* calendar/icalendar.el (icalendar--convert-tz-offset):
	Return complete cons when offsets of standard time and daylight saving
	time are equal.
	(icalendar-export-region): Fix unbound variable warning.

2014-11-16  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	* progmodes/python.el (run-python): Allow CMD to be optional and
	default it to a safe command, even for Windows.  (bug#18596)

2014-11-16  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	* progmodes/python.el (python-shell-calculate-command):
	Rename from python-shell-parse-command.  Cleanup.
	(run-python, run-python-internal): Use it.
	(python-shell-calculate-pythonpath): Rename from
	python-new-pythonpath.
	(python-shell-calculate-process-environment): Use it.
	(python-shell-calculate-exec-path): Add comment.

2014-11-16  Thierry Banel  <tbanelwebmin@free.fr>  (tiny change)

	* calc/calc-arith.el (math-max-list, math-min-list): Fix bug
	for date handling.

2014-11-16  Andreas Schwab  <schwab@linux-m68k.org>

	* version.el (emacs-repository-get-version): Use git rev-parse
	instead of git log.

2014-11-16  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	* progmodes/python.el (python-indent-calculate-levels):
	Fix indentation behavior multiline dedenter statement.  (Bug#18432)

2014-11-16  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	* progmodes/python.el (python-indent-region):
	Use python-indent-line and skip special cases.  (Bug#18843)

2014-11-16  Peder O. Klingenberg  <peder@klingenberg.no>

	* mail/emacsbug.el (report-emacs-bug): Make a better guess at
	  envelope-from when reporting through sendmail (bug#19054).

2014-11-16  Oscar Fuentes  <ofv@wanadoo.es>

	Add faces for the VC modeline state indicator.
	* vc/vc-hooks.el:
	(vc-state-faces, vc-state-base-face)
	(vc-up-to-date-state, vc-needs-update-state)
	(vc-locked-state, vc-locally-added-state)
	(vc-conflict-state, vc-removed-state)
	(vc-missing-state, vc-edited-state):
	New faces.
	(vc-default-mode-line-string): Use them

2014-11-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/backquote.el (backquote-process): Optimize away ",'".

2014-11-15  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el (eww-search-words): Mention `eww-search-prefix'.

2014-11-15  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	* progmodes/python.el (python-eldoc-setup-code): Enhance string
	type checks, simplify printing.  (Bug#18962)

2014-11-14  Ivan Andrus  <darthandrus@gmail.com>

	* progmodes/python.el (python-shell-font-lock-kill-buffer):
	(python-shell-font-lock-with-font-lock-buffer)
	(python-shell-get-buffer, python-ffap-module-path):
	Use `derived-mode-p' instead of equality test on `major-mode'.

2014-11-14  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	* progmodes/python.el (python-shell-virtualenv-root): Rename from
	python-shell-virtualenv-path.
	(python-shell-internal-get-process-name)
	(python-shell-calculate-process-environment)
	(python-shell-calculate-exec-path): Use it.

2014-11-14  Eli Zaretskii  <eliz@gnu.org>

	* bindings.el (search-map): Fix last change: don't use 'kbd' in
	bindings.el, since it is not yet loaded when bindings.el is
	preloaded.

2014-11-14  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	* progmodes/python.el (python-shell-completion-get-completions):
	Fix previous merge.

2014-11-14  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el (eww-render): Don't set the title to the URL.

2014-11-13  Ulrich Müller  <ulm@gentoo.org>

	* version.el (emacs-repository-get-version): Call `git log'
	command with proper format argument (bug#19049).

2014-11-14  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* bindings.el (search-map): Bind M-s M-s to `eww-search-words'.

2014-11-14  Kenjiro NAKAYAMA  <nakayamakenjiro@gmail.com>

	* net/eww.el (eww-search-words): New command (bug#16258).

2014-11-13  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/shr.el (shr-inhibit-images): Add a doc string.

	* net/eww.el (eww-after-render-hook): New variable.
	(eww-render): Use it.

	* net/shr.el (shr-descend): Don't descend further than
	`max-specpdl-size' allows (bug#16587).
	(shr-depth): New variable.
	(shr-warning): New variable.

2014-11-13  Ivan Shmakov  <ivan@siamics.net>

	* net/shr.el (shr-parse-base): Handle <base href=""> correctly.
	(shr-expand-url): Expand absolute URLs correctly (bug#17958).

2014-11-13  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el (eww): Add comment to clarify.

	* net/shr.el (shr-parse-image-data): Remove blocked bits from
	external SVG images.
	(shr-tag-object): Display images in <object> forms (bug#16244).
	(shr-tag-table): Also insert <objects> after the tables.

2014-11-13  Michael Albinus  <michael.albinus@gmx.de>

	* vc/vc-hg.el (vc-hg-state): Disable pager.  (Bug#18940)

2014-11-13  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el (eww-form-file): Fix version number.

2014-11-10  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el (eww-form-file): :type isn't a valid `defface' keyword.

2014-11-10  Kenjiro NAKAYAMA  <nakayamakenjiro@gmail.com>

	* net/eww.el(eww-form-file(defface)): New defface of file upload form.
	(eww-submit-file): New key map of file upload.
	(eww-form-file): New file upload button and file name context.
	(eww-select-file): Select file and display selected file name.
	(eww-tag-input): Handle input tag of file type.
	(eww-update-field): Add point offset.
	(eww-submit): Add submit with multipart/form-data.

2014-11-10  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el (eww-render, eww-display-html, eww-setup-buffer):
	Allow taking a buffer to render data in.  This allows using several
	eww buffers (bug#16211).

2014-11-10  Charles Rendleman  <carendle@gmail.com>  (tiny change)

	* net/eww.el (eww-download-callback): Save only the file contents,
	not the headers.

2014-11-10  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el (eww-data): New plist to store all the data relevant
	to a single page, used throughout the file instead of the
	variables `eww-current-url', `eww-current-dom',
	`eww-current-source', and `eww-current-title'.
	(eww-readable): Copy over pertinent data from the parent page.
	(eww-save-history): Don't let the history grow infinitely.

	* net/eww.el: Remove `eww-next-url', `eww-previous-url',
	`eww-up-url', `eww-home-url', `eww-start-url' and
	`eww-contents-url' and put the data into the `eww-data' plist.
	This allow restoring these values after going back in the history.

2014-11-10  Sylvain Chouleur  <sylvain.chouleur@gmail.com>  (tiny change)

	Allow VTIMEZONE where daylight and standard time zones are equal.
	See: https://lists.gnu.org/r/emacs-devel/2014-11/msg00494.html
	* calendar/icalendar.el (icalendar--convert-tz-offset):
	Support timezone without daylight saving time.

2014-11-10  Glenn Morris  <rgm@gnu.org>

	* startup.el (command-line): Handle nil elements in load-path.

2014-11-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* help.el (view-lossage): Include the actual commands run.

2014-11-10  Dmitry Gutov  <dgutov@yandex.ru>

	* vc/vc-dir.el (vc-dir-hide-state): Also hide `ignored' items when
	no state is specified.  (Bug#18964)

2014-11-09  Eric Ludlam  <zappo@gnu.org>

	* emacs-lisp/eieio-custom.el (eieio-customize-object):
	Set eieio-cog (current group) to g, which is an improved form of input
	group.

2014-11-09  Juri Linkov  <juri@jurta.org>

	* isearch.el (isearch-message-prefix): Show "Multi-file" and
	"Multi-buffer" instead of "Multi".  (Bug#13592)

	* misearch.el (multi-isearch-file-list):
	Autoload multi-isearch-buffer-list and multi-isearch-file-list.
	(multi-isearch-end): Reset multi-isearch-buffer-list and
	multi-isearch-file-list to nil.

2014-11-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/bytecomp.el (byte-compile-initial-macro-environment):
	Don't call byte-compile-preprocess since the result will go through
	cconv.
	(byte-compile-output-docform): Handle uninterned `name' correctly.
	* emacs-lisp/cl-macs.el (cl-define-compiler-macro): Use interned name
	to circumvent byte-compiler bug.

	* emacs-lisp/macroexp.el (macroexp--expand-all): Fix typo.
	(macroexp--compiler-macro): Remove left-over debug code.

	* emacs-lisp/cl-extra.el (cl-get): Silence compiler warning.

2014-11-08  Juri Linkov  <juri@jurta.org>

	* simple.el (shell-command): Use buffer-name when output-buffer is
	a buffer.  (Bug#18096)

2014-11-08  Juri Linkov  <juri@jurta.org>

	* minibuffer.el (minibuffer-completion-help): Compare this-command
	with completion-at-point.  (Bug#17809)

2014-11-08  Glenn Morris  <rgm@gnu.org>

	* emacs-lisp/bytecomp.el (byte-compile-report-error):
	Allow the argument to be a string.  Due to the vague doc,
	it was already being used this way.

2014-11-08  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp.el (tramp-check-cached-permissions): Include hop in
	the constructed Tramp file name.  (Bug#18943)

2014-11-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emulation/cua-base.el (cua--select-keymaps): Use region-active-p
	(bug#18952).
	(cua-set-mark, cua--post-command-handler-1):
	* emulation/cua-gmrk.el (cua-cancel-global-mark): Same.

2014-11-08  Michael Albinus  <michael.albinus@gmx.de>

	* files.el (file-name-non-special): Wrap the call of
	`insert-file-contents' by `unwind-protect', in order to set the
	buffer's file name anyway.  (Bug#18891)

2014-11-08  Alan Mackenzie  <acm@muc.de>

	Fix wrong bound to c-font-lock-declarators.
	* progmodes/cc-fonts.el (c-font-lock-declarations):
	Pass "(point-max)" as bound to c-font-lock-declarators, not "limit", as
	the buffer is sometimes narrowed to less than "limit" (e.g., in
	the presence of macros).  (Bug#18948)

2014-11-08  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp.el (tramp-error-with-buffer): Show connection buffer
	only when message appeared in minibuffer.  (Bug#18891)

	* net/tramp-adb.el (tramp-adb-handle-file-attributes):
	* net/tramp-gvfs.el (tramp-gvfs-handle-file-attributes):
	* net/tramp-sh.el (tramp-sh-handle-file-attributes): Return nil in
	case of errors.

2014-11-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/bytecomp.el (byte-compile-initial-macro-environment):
	Don't compile before eval in `eval-and-compile'.
	(byte-compile-arglist-warn): Add check for defining macros after their
	first use.  Check call use even if the function is fboundp.

2014-11-08  Richard Stallman  <rms@gnu.org>

	* mail/rmail.el (rmail-epa-decrypt): Detect armor with line prefixes.
	Check more carefully for mime-part specified character set.
	Check for mime-part Content Transfer Encoding.
	Notify if no armor found.

2014-11-08  Martin Rudalics  <rudalics@gmx.at>

	* faces.el (face-set-after-frame-default): Enable running
	`window-configuration-change-hook'.

2014-11-07  Juri Linkov  <juri@jurta.org>

	* replace.el: History for query replace pairs.
	(query-replace-defaults): Promote to a list of cons cell.  Doc fix.
	(query-replace-from-to-separator): New variable.
	(query-replace-read-from): Let-bind query-replace-from-to-history
	to a list of FROM-TO strings created from query-replace-defaults
	and separated by query-replace-from-to-separator.  Use it as
	the history while reading from the minibuffer.  Split the returned
	string by the separator to get FROM and TO parts, and add them
	to the history variables.
	(query-replace-read-to): Add FROM-TO pairs to query-replace-defaults.
	(query-replace-regexp-eval): Let-bind query-replace-defaults to nil.
	https://lists.gnu.org/r/emacs-devel/2014-11/msg00253.html

	* isearch.el (isearch-text-char-description): Keep characters
	intact and put formatted strings with the `display' property.

2014-11-07  Martin Rudalics  <rudalics@gmx.at>

	* cus-start.el (frame-resize-pixelwise): Fix group.
	(frame-inhibit-implied-resize): Add entry.

2014-11-07  Daiki Ueno  <ueno@gnu.org>

	* epa.el (epa-pinentry-mode): New user option.
	(epa-sign-file, epa-encrypt-file, epa-decrypt-region)
	(epa-sign-region, epa-encrypt-region): Respect epa-pinentry-mode.
	* epa-file.el (epa-file-insert-file-contents)
	(epa-file-write-region): Respect epa-pinentry-mode.

2014-11-07  Daiki Ueno  <ueno@gnu.org>

	* epg.el (epg--list-keys-1): Ignore fields after the 15th field
	(bug#18979).  Reported by Hideki Saito.

2014-11-06  Daiki Ueno  <ueno@gnu.org>

	* emacs-lisp/package.el (package--display-verify-error): New function.
	(package--check-signature): Use it to display output sent to stderr.

2014-11-06  Stefan Monnier  <monnier@iro.umontreal.ca>

	* subr.el (pop): Don't call the getter twice (bug#18968).

	* emacs-lisp/macroexp.el (macroexp--expand-all): Optimize away trivial
	uses of `funcall'.

2014-11-06  Daiki Ueno  <ueno@gnu.org>

	* epa.el (epa-error-buffer): New variable.
	(epa-display-error): New function.
	(epa-decrypt-file, epa-verify-file, epa-verify-region)
	(epa-delete-keys, epa-import-keys): Display output sent to stderr.
	(epa-sign-file, epa-sign-region, epa-encrypt-region)
	(epa-export-keys, epa-insert-keys): Display output sent to stderr.
	Use setf instead of epg-context-set-*.
	* epa-file.el (epa-file-insert-file-contents):
	Use epa-display-error instead of epa-display-info.  Mimic the behavior
	of jka-compr when decryption program is not found.
	(epa-file-write-region): Use epa-display-error instead of
	epa-display-info.

2014-11-05  Stefan Monnier  <monnier@iro.umontreal.ca>

	* vc/vc.el (vc-region-history): New command.
	(vc-print-log-internal): Use cl-some.

	* vc/vc-git.el (vc-git-region-history): New function.
	(vc-git-region-history-mode-map)
	(vc-git--log-view-long-font-lock-keywords)
	(vc-git-region-history-font-lock-keywords): New vars.
	(vc-git-region-history-font-lock): New function.
	(vc-git-region-history-mode): New major mode.

2014-11-05  Tassilo Horn  <tsdh@gnu.org>

	* net/eww.el (subr-x): Require subr-x at compile-time because eww
	uses string-trim.

2014-11-05  Daiki Ueno  <ueno@gnu.org>

	* epg.el (epg-context): Add new slot ERROR-OUTPUT.
	(epg-error-output): New buffer-local variable.
	(epg--start): Initialize epg-error-output.
	(epg--process-filter): Record output lines sent to stderr, in
	epg-error-output.
	(epg-wait-for-completion): Copy epg-error-output to ERROR-OUTPUT
	slot of context.
	* epa-file.el (epa-file-insert-file-contents): On error, display
	output sent to stderr.
	(epa-file-write-region): Likewise.

2014-11-05  Eli Zaretskii  <eliz@gnu.org>

	* jit-lock.el (jit-lock-stealth-fontify): Be tolerant to nil being
	returned by load-average.

2014-11-05  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp-sh.el (tramp-do-copy-or-rename-file-via-buffer): Don't use
	a local copy; setting `inhibit-file-name-handlers' proper might be
	more performant.  (Bug#18751)

2014-11-05  Glenn Morris  <rgm@gnu.org>

	* mail/emacsbug.el (report-emacs-bug): No longer include
	recent-keys in the report.  (Bug#18900)

2014-11-04  Paul Eggert  <eggert@cs.ucla.edu>

	* mouse.el (mouse-drag-line): Fix misspelling of "right-fringe".

2014-11-04  Teodor Zlatanov  <tzz@lifelogs.com>

	* net/eww.el (eww): Trim URL with `string-trim'.
	Suggested by Vibhav Pant <vibhavp@gmail.com>.

2014-11-03  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el (eww-score-readability): Don't count comments positively.

	* net/shr.el (shr-retransform-dom): Typo fix.

	* net/eww.el (eww-score-readability): Parse SVC images correctly.
	(eww-display-html): Don't leave point inside forms.

	* net/shr.el: Ditto.

2014-11-03  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/edebug.el (edebug-safe-prin1-to-string): Assume that
	edebug-prin1-to-string already handles circularity.

	* emacs-lisp/byte-run.el (defun-declarations-alist): Fix compiler-macro
	autoloading when specified as a lambda.

	* simple.el (execute-extended-command--last-typed): New var.
	(read-extended-command): Set it.
	Don't complete obsolete commands.
	(execute-extended-command--shorter-1)
	(execute-extended-command--shorter): New functions.
	(execute-extended-command): Use them to suggest shorter names.
	(indicate-copied-region, deactivate-mark): Use region-active-p.

2014-11-03  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp-sh.el (tramp-do-copy-or-rename-file-via-buffer): Use a
	local copy of FILENAME, when it is remote.  (Bug#18751)

	* net/tramp-adb.el (tramp-adb-handle-process-file): Do not raise
	an error when the command fails; the return code must indicate.
	(tramp-adb-send-command-and-check): Fix docstring.

2014-11-03  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/shr.el (shr-retransform-dom): Don't ignore elements that
	have no children like <br />.

	* net/eww.el (eww-display-html): Clear `url-queue'.
	(eww-display-pdf): New function.
	(eww-render): Display PDFs with `doc-view'.
	(url-queue): Require `url-queue' to avoid compilation warning.
	(eww-colorize-region): Remove duplicate function.
	(eww-tag-body): Use `shr-colorize-region'.

2014-11-03  Yoni Rabkin <yrk@gnu.org>

	* net/eww.el (eww-list-bookmarks): Autoload.

2014-11-03  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/shr.el (shr-retransform-dom): Allow several text sub-nodes.

	* net/eww.el (eww-display-html): The charset is called `utf-8',
	not `utf8'.
	(eww-readable): Decode the saved text correctly.
	(eww-readable): Save the history before displaying so that we can
	go back to the non-readable version.
	(eww-display-html): Don't try to decode the text if we've been
	passed in a pre-parsed DOM.
	(eww-tag-title): Remove newlines and extra whitespace from the
	displayed title.

2014-11-02  Lars Magne Ingebrigtsen  <larsi@gnus.org>

	* net/eww.el (eww-readable): New command and keystroke.

	* net/shr.el (shr-retransform-dom): New function.

	* net/eww.el (eww-display-html): Set `eww-current-source' in the
	correct buffer.
	(eww-view-source): Use it.

2014-11-02  Ivan Shmakov  <ivan@siamics.net>

	* net/eww.el (eww): Recognize colon-delimited IPv6 addresses.
	(Bug#18603).

2014-11-02  Brian McKenna  <brian@brianmckenna.org>  (tiny change)

	* net/eww.el (eww-submit): Encode empty form values as "".  (Bug#17785).

2014-11-02  Ivan Shmakov  <ivan@siamics.net>

	* net/eww.el (eww): Allow "file:/file/name" URLs.  (Bug#18825).

2014-11-02  Ivan Shmakov  <ivan@siamics.net>

	* net/eww.el (eww-mode-map): Remove mentions of `eww-quit'.
	(Bug#18834).

2014-11-02  Eric Abrahamsen  <eric@ericabrahamsen.net>

	* emacs-lisp/eieio.el (eieio-edebug-prin1-to-string): Adjust for
	use as advice.
	(edebug-setup-hook): Advise `edebug-prin1-to-string'.  (Bug#18897)

2014-11-02  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/pp.el (pp-macroexpand-expression): Use macroexpand-1
	(bug#18821).
	* progmodes/elisp-mode.el (emacs-lisp-macroexpand): Idem.

2014-11-01  Michael R. Mauger  <michael@mauger.com>

	* progmodes/sql.el (sql-mode-oracle-font-lock-keywords): Correct regexp
	syntax, add new keywords, and parse longer keywords first.
	(sql-redirect-one): Protect against empty command.
	(sql-mode, sql-interactive-mode): Set `custom-mode-group' property
	to SQL.  (Bug#14759)

2014-11-01  Michael R. Mauger  <michael@mauger.com>

	* progmodes/sql.el (sql-interactive-mode, sql-stop): Correct fix for
	Bug#16814 with let-bind of comint-input-ring variables around read
	and save functions.

2014-11-01  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp-cache.el (tramp-get-file-property)
	(tramp-set-file-property): Check that `tramp-cache-get-count-*'
	and `tramp-cache-set-count-*' are bound.  Otherwise, there might
	be compiler warnings.

	* net/tramp-sh.el (tramp-get-remote-uid, tramp-get-remote-gid):
	Return -1 respective "UNKNOWN", if uid or gid cannot be determined.

2014-11-01  Eli Zaretskii  <eliz@gnu.org>

	* progmodes/compile.el (compilation-mode): Turn off deferred
	fontifications locally.  (Bug#18856)

2014-11-01  Wolfgang Jenkner  <wjenkner@inode.at>

	* net/tramp-sh.el (tramp-send-command): Fix the case where the
	remote-echo connection property is non-nil (bug#18858).

2014-11-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	* simple.el (newline): Add assertions to try and help catch bug#18913.

	* emulation/cua-base.el (cua-delete-region): Use delete-active-region
	(bug#18886).
	(cua--last-deleted-region-pos, cua--last-deleted-region-text): Remove.

2014-11-01  Kim F. Storm  <storm@cua.dk>

	Restore cua-delete-copy-to-register-0 and M-v command (bug#18886).
	* delsel.el (delete-selection-save-to-register)
	(delsel--replace-text-or-position): New vars.
	(delete-active-region): Use them.
	(delete-selection-repeat-replace-region): New command, moved from
	cua-base.el.
	* emulation/cua-base.el (cua--repeat-replace-text): Remove var.
	(cua-repeat-replace-region): Move command to delsel.el.
	(cua--init-keymaps): Update binding accordingly.
	(cua-mode): Set delete-selection-save-to-register.

2014-11-01  Alan Mackenzie  <acm@muc.de>

	Make blink-parens work with a closing template delimiter.
	* progmodes/cc-cmds.el (c-electric-lt-gt): Cause a redisplay
	before calling blink-paren-function, so as to apply syntax-table
	properties to the ">".

2014-11-01  Jan Djärv  <jan.h.d@swipnet.se>

	* select.el (gui-get-selection): Comment: data-type ignored on NS.

2014-10-31  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/macroexp.el (macroexpand-1): New function (bug#18821).
	(macroexp--expand-all): Unrelated tweaks.

	* emacs-lisp/gv.el (gv-get): Use macroexpand-1.

2014-10-30  Glenn Morris  <rgm@gnu.org>

	* startup.el (command-line): Remove pointless attempt to avoid
	statting the file-system (which expand-file-name doesn't do).

2014-10-30  Daniel Colascione  <dancol@dancol.org>

	Add "enum class" support to C++ mode.
	* progmodes/cc-langs.el (c-after-brace-list-decl-kwds)
	(c-after-brace-list-key): New language consts/variables.
	* progmodes/cc-engine.el (c-looking-at-decl-block):
	Exclude spurious match of "enum struct" from decl-block recognition.
	(c-backward-colon-prefixed-type): New function.
	(c-backward-over-enum-header): Call above function to extend
	recognition of enum structure.

2014-10-30  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/cc-defs.el (c--macroexpand-all): New function (bug#18845).
	(c-lang-defconst):
	* progmodes/cc-langs.el (c-make-init-lang-vars-fun): Use it.

2014-10-30  Eli Zaretskii  <eliz@gnu.org>

	* progmodes/compile.el (compilation-start):
	If compilation-scroll-output is non-nil, don't force window-start of
	the compilation buffer to be at beginning of buffer.  (Bug#18874)

	* startup.el (fancy-about-text): Read the entire tutorial, not
	just its first 256 bytes.  (Bug#18760)

2014-10-30  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/bytecomp.el: Require cl-extra (bug#18804).
	* emacs-lisp/cl-extra.el: Add missing provide.

	* emacs-lisp/bytecomp.el (byte-compile-and-folded): Optimize case where
	all args are copyable (bug#18767).
	(=, <, >, <=, >=): Re-enable the optimization.

2014-10-29  Glenn Morris  <rgm@gnu.org>

	* net/rcirc.el (rcirc-fill-column): Unbump :version.  Mark :risky.

	* version.el (emacs-bzr-version, emacs-bzr-get-version):
	Revert 2014-10-26 change.

2014-10-29  Paul Eggert  <eggert@cs.ucla.edu>

	Simplify use of current-time and friends.
	* allout-widgets.el (allout-widgets-hook-error-handler):
	* calendar/appt.el (appt-display-message):
	* calendar/icalendar.el (icalendar--convert-float-to-ical):
	* calendar/timeclock.el (timeclock-in, timeclock-when-to-leave)
	(timeclock-last-period, timeclock-day-base):
	* eshell/em-ls.el (eshell-ls-file):
	* eshell/esh-util.el (eshell-parse-ange-ls):
	* generic-x.el (named-database-print-serial):
	* net/newst-backend.el (newsticker--get-news-by-url-callback)
	(newsticker-get-news, newsticker--sentinel-work)
	(newsticker--image-get, newsticker--image-sentinel):
	* net/tramp-sh.el (tramp-get-remote-touch):
	* progmodes/opascal.el (opascal-debug-log):
	* textmodes/remember.el (remember-mail-date)
	(remember-store-in-files):
	* vc/vc-annotate.el (vc-annotate-display-autoscale)
	(vc-default-annotate-current-time):
	* vc/vc-bzr.el (vc-bzr-shelve-snapshot):
	* vc/vc-cvs.el (vc-cvs-annotate-current-time):
	* vc/vc-rcs.el (vc-rcs-annotate-current-time):
	Omit unnecessary call to current-time.
	* calendar/time-date.el (time-to-seconds) [!float-time]:
	* vc/vc-annotate.el (vc-annotate-convert-time):
	Use current time if arg is nil, to be compatible with float-time.
	(time-date--day-in-year): New function, with most of the guts of
	the old time-to-day-in-year.
	(time-to-day-in-year): Use it.
	(time-to-days): Use it, to avoid decoding the same time stamp twice.
	* calendar/timeclock.el (timeclock-time-to-date):
	Arg is now optional, like current-time-string.
	(timeclock-update-mode-line):
	Don't call current-time twice to get the current time stamp,
	as this can lead to inconsistent results.
	* completion.el (cmpl-hours-since-origin):
	* ido.el (ido-time-stamp):
	* vc/vc-annotate.el (vc-annotate-convert-time):
	Simplify by using float-time.
	* completion.el (save-completions-to-file):
	Rename local var to avoid confusion.
	* net/rcirc.el (rcirc-float-time): Simplify to an alias because
	time-to-seconds now behaves like float-time with respect to nil arg.
	* subr.el (progress-reporter-do-update):
	Don't call float-time unless needed.

2014-10-29  Leo Liu  <sdl.web@gmail.com>

	* net/rcirc.el (rcirc-fill-column): Use function.
	(rcirc-markup-fill): Remove adjustment.

2014-10-28  Christopher Schmidt  <ch@ristopher.com>

	* calc/calc.el (quick-calc):
	* calc/calc-aent.el (calc-do-quick-calc): New argument INSERT.

2014-10-28  Sam Steingold  <sds@gnu.org>

	* net/rcirc.el (rcirc-fill-column): Allow any symbolic value for
	the sake of `window-body-width' (in addition to `frame-width').

2014-10-26  Eric S. Raymond  <esr@thyrsus.com>

	* version.el: Fix some fallback values to conform to the actual
	release number.

2014-10-25  Eric S. Raymond  <esr@thyrsus.com>

	* Makefile.in: Change some production names so they're neutral
	about the repository type.

2014-10-25  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp-gvfs.el (tramp-gvfs-methods-mounttracker)
	(tramp-gvfs-mountlocation-signature): Check `tramp-gvfs-enabled'
	during initialization.  (Bug#18774)

2014-10-25  Vincent Belaïche  <vincentb1@users.sourceforge.net>

	* ses.el (macroexp): Add require for this package, so that
	function `ses--cell' gets macroexp-quote --- this change was
	supposed to be in my previous commit, but left out by mistake.
	(ses--cell): Do not make formula a macroexp-quote of value when
	value, not formula, is *skip*.

2014-10-24  Vincent Belaïche  <vincentb1@users.sourceforge.net>

	* ses.el (macroexp): Add require for this package, so that function
	`ses--cell gets macroexp-quote.
	(ses--cell): Makes formula a macroexp-quote of value when formula
	is nil.  The rationale of this changr is to allow in the future
	shorter SES files, e.g. we could have only `(ses-cell A1 1.0)'
	instead of `(ses-cell A1 1.0 1.0 nil REFLIST)'.  In such a case
	reference list REFLIST would be re-computed after load --- thus
	trading off load time against file size.

	* emacs-lisp/package.el (package--alist-to-plist-args):
	Use macroexp-quote instead of a lambda expression which has the same
	content as macroexp-quote.
	(macroexp): Add require for this package, so that function
	`package--alist-to-plist-args' gets macroexp-quote.

	* emacs-lisp/macroexp.el (macroexp-quote): New defun.

2014-10-24  Stefan Monnier  <monnier@iro.umontreal.ca>

	* term/ns-win.el (ns-store-cut-buffer-internal)
	(ns-copy-including-secondary): Use gui-set-selection (bug#18816).

2014-10-24  Martin Rudalics  <rudalics@gmx.at>

	* mouse.el (mouse-drag-line): Don't use mouse-pixel-position.
	Calculate increment from last position instead of window edge.
	Add right- and bottom-divider bindings to transient map.

2014-10-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/cl-macs.el (cl-defstruct): Define an internal predicate
	even if :predicate was nil, for the benefit of typep.
	Record the name of the predicate for typep's use.
	(cl--make-type-test): Use pcase.  Obey new
	cl-deftype-satisfies property.

	* epg.el: Use cl-defstruct.
	(epg-make-data-from-file, epg-make-data-from-string, epg-data-file)
	(epg-data-string): Define via cl-defstruct.
	(epg--gv-nreverse): New macro.
	(epg-context--make): New constructor (provided vi cl-defstruct).
	(epg-make-context): Rewrite using it.
	(epg-context-protocol, epg-context-program)
	(epg-context-home-directory, epg-context-armor, epg-context-textmode)
	(epg-context-include-certs, epg-context-cipher-algorithm)
	(epg-context-digest-algorithm, epg-context-compress-algorithm)
	(epg-context-passphrase-callback, epg-context-progress-callback)
	(epg-context-signers, epg-context-sig-notations, epg-context-process)
	(epg-context-output-file, epg-context-result, epg-context-operation)
	(epg-context-pinentry-mode): Define using cl-defstruct.
	(epg-context-set-protocol, epg-context-set-program)
	(epg-context-set-include-certs, epg-context-set-cipher-algorithm)
	(epg-context-set-digest-algorithm)
	(epg-context-set-sig-notations, epg-context-set-process)
	(epg-context-set-output-file, epg-context-set-result)
	(epg-context-set-operation, epg-context-set-pinentry-mode)
	(epg-context-set-compress-algorithm): Remove.  Use setf instead.
	(epg-context-set-armor, epg-context-set-textmode)
	(epg-context-set-signers): Redefine using setf
	and declare as obsolete.
	(epg-context-set-passphrase-callback)
	(epg-context-set-progress-callback): Use setf.
	(epg-signature-notations): Rename from epg-sig-notations.
	(epg-make-signature, epg-signature-status, epg-signature-key-id)
	(epg-signature-validity, epg-signature-fingerprint)
	(epg-signature-creation-time, epg-signature-expiration-time)
	(epg-signature-pubkey-algorithm, epg-signature-digest-algorithm)
	(epg-signature-class, epg-signature-version): Define vi cl-defstruct.
	(epg-signature-set-status, epg-signature-set-key-id)
	(epg-signature-set-validity, epg-signature-set-fingerprint)
	(epg-signature-set-creation-time, epg-signature-set-expiration-time)
	(epg-signature-set-pubkey-algorithm)
	(epg-signature-set-digest-algorithm, epg-signature-set-class)
	(epg-signature-set-version, epg-signature-set-notations): Remove.
	Use setf instead.
	(epg-make-new-signature, epg-new-signature-type)
	(epg-new-signature-pubkey-algorithm)
	(epg-new-signature-digest-algorithm, epg-new-signature-class)
	(epg-new-signature-creation-time, epg-new-signature-fingerprint):
	Define using cl-defstruct.
	(epg-make-key, epg-key-owner-trust, epg-key-sub-key-list)
	(epg-key-user-id-list): Define using cl-defstruct.
	(epg-key-set-sub-key-list, epg-key-set-user-id-list): Remove.
	Use setf instead.
	(epg-make-sub-key, epg-sub-key-validity, epg-sub-key-capability)
	(epg-sub-key-secret-p, epg-sub-key-algorithm, epg-sub-key-length)
	(epg-sub-key-id, epg-sub-key-creation-time)
	(epg-sub-key-expiration-time, epg-sub-key-fingerprint): Define using
	cl-defstruct.
	(epg-sub-key-set-fingerprint): Remove.  Use setf instead.
	(epg-make-user-id, epg-user-id-validity, epg-user-id-string)
	(epg-user-id-signature-list): Define using cl-defstruct.
	(epg-user-id-set-signature-list): Remove.  Use setf instead.
	(epg-make-key-signature, epg-key-signature-validity)
	(epg-key-signature-pubkey-algorithm, epg-key-signature-key-id)
	(epg-key-signature-creation-time, epg-key-signature-expiration-time)
	(epg-key-signature-user-id, epg-key-signature-class)
	(epg-key-signature-exportable-p): Define using cl-defstruct.
	(epg-make-sig-notation, epg-sig-notation-name)
	(epg-sig-notation-value, epg-sig-notation-human-readable)
	(epg-sig-notation-critical): Define using cl-defstruct.
	(epg-sig-notation-set-value): Remove.  Use setf instead.
	(epg-make-import-status, epg-import-status-fingerprint)
	(epg-import-status-reason, epg-import-status-new)
	(epg-import-status-user-id, epg-import-status-signature)
	(epg-import-status-sub-key, epg-import-status-secret): Define using
	cl-defstruct.
	(epg-make-import-result, epg-import-result-considered)
	(epg-import-result-no-user-id, epg-import-result-imported)
	(epg-import-result-imported-rsa, epg-import-result-unchanged)
	(epg-import-result-new-user-ids, epg-import-result-new-sub-keys)
	(epg-import-result-new-signatures, epg-import-result-new-revocations)
	(epg-import-result-secret-read, epg-import-result-secret-imported)
	(epg-import-result-secret-unchanged, epg-import-result-not-imported)
	(epg-import-result-imports): Define using cl-defstruct.

	* emacs-lisp/package.el: Require EPG during macroexpansion.
	(package--check-signature, package-import-keyring): Use setf instead of
	epg-context-set-home-directory.

2014-10-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/bytecomp.el (byte-compile--use-old-handlers): Change default.

2014-10-23  Leo Liu  <sdl.web@gmail.com>

	* progmodes/cfengine.el (cfengine3-defun-full-re): New var.
	(cfengine3-create-imenu-index): Use it and use ` ' for separation.
	(cfengine3-current-defun): New function.
	(cfengine3-mode): Set add-log-current-defun-function.

2014-10-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	* select.el: Use lexical-binding.
	(gui-set-selection): Provide an implementation for non-GUI frames
	(bug#18791).
	* term/x-win.el: Use lexical-binding.
	(x-clipboard-yank): Fix up missed renamings.
	* term/w32-win.el (libgif-version, libjpeg-version): Silence compiler.
	(w32--set-selection): Fix up var names.
	* term/pc-win.el: Use lexical-binding.
	(w16-selection-exists-p): Silence compiler warning.
	(w16-selection-owner-p): Fix up missed renamings.

	* emacs-lisp/bytecomp.el (byte-compile-form): Remove left-over debug.

	* frame.el (frame-notice-user-settings): Fix excessive quoting.

2014-10-22  Tassilo Horn  <tsdh@gnu.org>

	* doc-view.el (doc-view-open-text): View the document's plain text
	in the current buffer instead of a new one.
	(doc-view-toggle-display): Handle the case where the current
	buffer contains the plain text contents of the document.
	(doc-view-initiate-display): Don't switch to fallback mode if the
	user wants to view the doc's plain text.
	(doc-view-set-doc-type): Use assoc-string instead of
	assoc-ignore-case.

2014-10-21  Stefan Monnier  <monnier@iro.umontreal.ca>

	* subr.el (read-key): Fix clicks on the mode-line.
	(set-transient-map): Return exit function.

	* mouse.el (mouse-drag-line): Use set-transient-map (bug#18015).
	(mouse--down-1-maybe-follows-link): Remove unused var `this-event'.
	(mouse-yank-secondary): Use gui-get-selection.
	(mouse--down-1-maybe-follows-link): Use read-key.

	* xt-mouse.el: Add `event-kind' property on the fly from
	xterm-mouse-translate-1 rather than statically at the outset.

2014-10-21  Daniel Colascione  <dancol@dancol.org>

	* vc/vc-dispatcher.el (vc-resynch-window): Tell view-mode not to
	change window configuration when we turn it off.

2014-10-21  Stefan Monnier  <monnier@iro.umontreal.ca>

	Get rid of backend-dependent selection-handling functions for kill/yank
	and make it generic instead by relying on the lower-level selection
	management functions.

	* select.el (select-enable-clipboard): Rename from
	gui-select-enable-clipboard.
	(select-enable-primary): Move from x-win.el and rename from
	x-select-enable-primary.
	(gui-last-selected-text): Remove.
	(gui--last-selected-text-clipboard, gui--last-selected-text-primary):
	New vars.
	(gui-select-text): Rewrite, based on x-win.el's old x-select-text.
	(gui-select-text-alist, gui-selection-value-alist): Remove.
	(x-select-request-type): Move from x-win.el.
	(gui--selection-value-internal): New function, taken from x-win's
	x-selection-value-internal.
	(gui-selection-value): Rewrite, based on x-win.el's old x-selection-value.
	(gui-set-selection-alist): Rename from gui-own-selection-alist and
	extend it to handle a nil value as a "disown" request.
	(gui-disown-selection-alist): Remove.
	(xselect-convert-to-delete): Adjust accordingly.
	(gui-set-selection): Simplify accordingly as well.  Use dotimes.

	* term/x-win.el (x-last-selected-text-primary)
	(x-select-enable-primary): Remove (moved to select.el).
	(x-select-request-type): Move to select.el.
	(x-selection-value-internal, x--selection-value): Remove functions.
	(gui-selection-value, gui-select-text): Remove moethods.
	(gui-set-selection): Merge own and disown methods.

	* term/w32-win.el (w32--select-text, w32--get-selection-value):
	Delete function (move functionality into w32--set-selection and
	w32--get-selection).
	(gui-select-text, gui-selection-value): Don't define methods.
	(w32--set-selection, w32--get-selection, w32--selection-owner-p):
	New functions.
	(gui-get-selection, gui-selection-owner-p, gui-selection-exists-p):
	Use them.
	(gui-selection-exists-p): Adjust to new name of C primitive.

	* term/pc-win.el (w16-get-selection-value): Add dummy argument and drop
	test of gui-select-enable-clipboard, to make it usable as
	a gui-get-selection method.
	(gui-selection-exists-p): Adjust to new name of C primitive.
	(gui-set-selection): Merge own and disown methods.
	(gui-select-text, gui-selection-value): Delete methods.
	(w16--select-text): Delete function.

	* term/ns-win.el (ns-get-pasteboard, ns-set-pasteboard)
	(ns-selection-value): Remove functions.
	(gui-select-text, gui-selection-value): Don't define method any more.
	(gui-set-selection): Merge the old own and disown methods.
	(gui-selection-exists-p, gui-get-selection): Adjust to new name of
	underlying C primitive.

	* startup.el (command-line): Adjust now that `gui-method' expects nil
	for ttys.

	* frame.el (gui-method): Use window-system rather than framep.
	(gui-method-declare): The tty case is now nil rather than t.
	(make-frame): Adjust accordingly.

2014-10-21  Stefan Monnier  <monnier@iro.umontreal.ca>

	* net/newst-reader.el (newsticker--image-read): Simplify.
	(newsticker--icon-read): Use dolist and fix free var error.

	* imenu.el (imenu--menubar-keymap): New var.
	(imenu-add-to-menubar): Set it to remember the keymap we used.
	(imenu-update-menubar): Use it instead of asking lookup-key.

	* obsolete/cc-compat.el: Make obsolete (bug#18561).

	* epg-config.el (epg-gpg-program): Don't use absolute names by default.

	* emacs-lisp/bytecomp.el (=, <, >, <=, >=): Don't optimize multi-arg
	case (bug#18767).

2014-10-21  Glenn Morris  <rgm@gnu.org>

	* Merge in all changes up to version 24.4 release.

2014-10-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/bytecomp.el (=, <, >, <=, >=): Don't optimize multi-arg
	case (bug#18767).

2014-10-20  Glenn Morris  <rgm@gnu.org>

	* Merge in all changes up to 24.4 release.

2014-10-20  Ulf Jasper  <ulf.jasper@web.de>

	* net/newst-backend.el
	(newsticker--image-download-by-url-callback): Make this function
	actually work: Check status properly, then save image.

2014-10-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* mouse.el (mouse--down-1-maybe-follows-link): Remove unused var
	`this-event'.
	(mouse-drag-line): Unless there's no actual mouse, use the event's
	position info.

2014-10-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* textmodes/css-mode.el (scss-mode): New major-mode.
	(css-mode-syntax-table): Use d style comment, to ease the scss case.
	(css-ident-re): Allow things like @-moz-keyframes.
	(scss--hash-re): New const.
	(css--font-lock-keywords): New function, extracted from
	css-font-lock-keywords.

2014-10-19  Ulf Jasper  <ulf.jasper@web.de>

	* net/newst-backend.el: Require url-parse.
	(newsticker--get-news-by-wget): Store feed name as process property.
	(newsticker--sentinel): Read feed name from process property.
	(newsticker--sentinel-work): Rename argument name to feed-name.
	Rename variable imageurl to image-url.  Pick icon url from Atom
	1.0 data.  Launch download of feed icon.
	(newsticker--get-icon-url-atom-1.0): New.
	(newsticker--unxml)
	(newsticker--unxml-node)
	(newsticker--unxml-attribute): Documentation.
	(newsticker--icons-dir): New.
	(newsticker--image-get): New arguments FILENAME and DIRECTORY.
	Use `url-retrieve' if `newsticker-retrieval-method' is 'intern.
	(newsticker--image-download-by-wget): New.  Use process properties
	for storing information.
	(newsticker--image-sentinel): Read information from process properties.
	(newsticker--image-save)
	(newsticker--image-remove)
	(newsticker--image-download-by-url)
	(newsticker--image-download-by-url-callback): New.
	(newsticker-opml-export): Handle url list entries containing a
	function instead of an url string.

	* net/newst-reader.el (newsticker-html-renderer): Whitespace.
	(newsticker--print-extra-elements)
	(newsticker--do-print-extra-element):
	Documentation (newsticker--image-read): Optionally limit image height.
	Use imagemagick if possible.
	(newsticker--icon-read): New.

	* net/newst-treeview.el (newsticker--treeview-item-show): Limit height of feed logo.
	(newsticker--treeview-tree-expand): Use feed icons in treeview.
	(newsticker--tree-widget-icon-create): New.  Set the tree widget icon.
	(newsticker--tree-widget-leaf-icon): Use feed icon.

2014-10-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/eieio-opt.el (eieio-lambda-arglist): Remove.
	Use help-function-arglist instead.

	* emacs-lisp/eieio-core.el (eieio-compiled-function-arglist): Remove.
	(eieio--with-scoped-class): Use `declare'.
	(eieio-defclass): Remove compatibility code.
	(no-method-definition, no-next-method, inconsistent-class-hierarchy)
	(invalid-slot-type, unbound-slot, invalid-slot-name): Use define-error.

2014-10-18  Jan Djärv  <jan.h.d@swipnet.se>

	* cus-start.el (x-gtk-whole-detached-tool-bar): Remove.

	* term/x-win.el (x-gtk-stock-map): Add icon names suggested as
	replacements to stock names before stock names in a list.
	Cdr may be a list, each name is tried in turn until one is found.

2014-10-18  Alan Mackenzie  <acm@muc.de>

	Check that a "macro" found near point-min isn't a ## operator.
	* progmodes/cc-engine.el (c-macro-is-genuine-p): New function.
	(c-beginning-of-macro): Use the above new function.  (Bug#18749)

2014-10-18  Teodor Zlatanov  <tzz@lifelogs.com>

	* net/gnutls.el (gnutls-negotiate): Don't use cl-mapcan; pass
	correct data to `gnutls-boot' (Bug#18664).
	Reported by Toke Høiland-Jørgensen <toke@toke.dk>.

2014-10-18  Michal Nazarewicz  <mina86@mina86.com>

	* whitespace.el (whitespace-style, whitespace-big-indent)
	(whitespace-big-indent-regexp, whitespace-style-value-list)
	(whitespace-toggle-option-alist, whitespace-interactive-char)
	(whitespace-toggle-options)
	(global-whitespace-toggle-options, whitespace-help-text)
	(whitespace-style-face-p, whitespace-color-on): Add a 'big-indent
	style to `whitespace-mode' to indicate that the line indentation
	is too deep.  By default, 32 SPACEs or four TABs are considered
	too many but `whitespace-big-indent-regexp' can be configured.

2014-10-17  Michal Nazarewicz  <mina86@mina86.com>

	* textmodes/tildify.el (tildify--pick-alist-entry): Rename from
	tildify-mode-alist.

2014-10-17  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/eieio.el: Use lexical-binding drop non-GV fallback.
	(defclass, defgeneric, defmethod): Add doc-string position.
	(with-slots): Require cl-lib.

	* emacs-lisp/eieio-core.el: Use lexical-binding and cl-lib.
	(list-of): New type.
	(eieio--typep): Remove.
	(eieio-perform-slot-validation): Use cl-typep instead.

	* emacs-lisp/eieio-base.el: Use lexical-binding and cl-lib.

	* emacs-lisp/cl-macs.el (cl--make-type-test): Avoid ((lambda ..) ..).

2014-10-16  Alan Mackenzie  <acm@muc.de>

	Trigger showing when point is in the "periphery" of a line or just
	inside a paren.
	* paren.el (show-paren-style, show-paren-delay)
	(show-paren-priority, show-paren-ring-bell-on-mismatch):
	Remove superfluous :group specifications.
	(show-paren-when-point-inside-paren)
	(show-paren-when-point-in-periphery): New customizable variables.
	(show-paren-highlight-openparen): Make into a defcustom.
	(show-paren--unescaped-p, show-paren--categorize-paren)
	(show-paren--locate-near-paren): New defuns.
	(show-paren--default): Refaactor and trigger on more paren
	positions.
	(show-paren-function): Small consequential changes.

2014-10-16  Tom Tromey  <tom@tromey.com>

	* files.el (auto-mode-alist): Use javascript-mode for .jsm
	(bug #18719).

2014-10-16  Eli Zaretskii  <eliz@gnu.org>

	* international/characters.el (bracket-type): Force pre-loading of
	uni-brackets.el.

2014-10-16  Alan Mackenzie  <acm@muc.de>

	* cus-edit.el (custom-command-apply): Specify the return value in
	the doc string.
	(Custom-reset-standard): Save custom-file (e.g. .emacs) only when
	custom-command-apply has returned non-nil.

2014-10-15  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/eldoc.el (global-eldoc-mode): Enable by default.
	Remove incorrect handling of eldoc-print-after-edit.
	(eldoc-message-commands, eldoc-last-data): Use defvar.
	* loadup.el (emacs-lisp/eldoc): Load it.

	* progmodes/m4-mode.el (m4-syntax-propertize): New var.
	(m4-mode): Use it.
	(m4--quoted-p): New function.
	(m4-font-lock-keywords): Don't handle #..\n comments any more.
	(m4-mode-syntax-table): Use punctuation syntax (according to m4 manual)
	for most special characters.

	* progmodes/compile.el (compilation--previous-directory): Simplify.
	(compilation-next-error): Ensure the parse before we look at
	compilation-message property.

2014-10-15  Eli Zaretskii  <eliz@gnu.org>

	* simple.el (what-cursor-position):
	* descr-text.el (describe-char): Update to support the new bidi
	characters.

	* emacs-lisp/tabulated-list.el (tabulated-list-mode):
	Force bidi-paragraph-direction to 'left-to-right'.  This fixes
	buffer-menu display when the first buffer happens to start with
	R2L letter.

2014-10-15  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/elisp-mode.el (elisp--local-variables-1):
	Handle quoted expressions (bug#18688).

2014-10-14  Jérémy Compostella  <jeremy.compostella@intel.com>
	    Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp-sh.el (tramp-open-connection-setup-interactive-shell):
	Reduce the amount of set environment variable commands.

2014-10-12  Fabián Ezequiel Gallina  <fgallina@gnu.org>

	Fix import completion.  (Bug#18582)
	* progmodes/python.el (python-shell-completion-get-completions):
	Fix import case regexp.

2014-10-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* progmodes/bat-mode.el (bat-font-lock-keywords): Fix \\<_ typo
	(bug#18622).  Reported by Arni Magnusson <arnima@hafro.is>.
	* progmodes/prolog.el (prolog-electric--underscore): Same.

2014-10-12  Michael Albinus  <michael.albinus@gmx.de>

	* net/tramp-sh.el (tramp-get-remote-id): Check also for "gid".

2014-10-11  Jan Djärv  <jan.h.d@swipnet.se>

	* cus-start.el (all): Add missing ns and boolean to
	ns-use-fullscreen-animation.

2014-10-11  Leo Liu  <sdl.web@gmail.com>

	* progmodes/cfengine.el (cfengine3-defuns, cfengine3-vartypes):
	Use strings.
	(cfengine3-create-imenu-index): New function.
	(cfengine3-mode): Use it for `imenu-create-index-function'.
	(cfengine-auto-mode): Improve and prefer cfengine3-mode when
	buffer is empty.

2014-10-11  Jan Djärv  <jan.h.d@swipnet.se>

	* cus-start.el (all): Add ns-use-fullscreen-animation.

2014-10-11  Glenn Morris  <rgm@gnu.org>

	* calendar/diary-lib.el (diary-display-function):
	Drop support for deprecated nil and list forms.
	(diary-list-entries): Update for the above.
	* calendar/cal-x.el (calendar-dedicate-diary): Simplify accordingly.

2014-10-10  Leo Liu  <sdl.web@gmail.com>

	* window.el (temp-buffer-window-show): Make BUFFER a required arg.
	(Bug#18656)

2014-10-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* select.el (gui-selection-exists-p-alist): New method.
	* menu-bar.el (menu-bar-edit-menu, clipboard-yank):
	* simple.el (deactivate-mark): Use it.
	* term/x-win.el (gui-selection-exists-p):
	* term/w32-win.el (gui-selection-exists-p):
	* term/pc-win.el (gui-selection-exists-p):
	* term/ns-win.el (gui-selection-exists-p): Provide a backend instance.

2014-10-10  Glenn Morris  <rgm@gnu.org>

	* info.el (Info-fontify-maximum-menu-size): Bump to 400k.  (Bug#16227)
	Fix :type.  Allow t to mean no limit.
	(Info-fontify-node): Handle Info-fontify-maximum-menu-size = t.

2014-10-09  Glenn Morris  <rgm@gnu.org>

	* frame.el (display-monitor-attributes-list): Doc tweaks.

2014-10-09  Eli Zaretskii  <eliz@gnu.org>

	* faces.el (display-grayscale-p): Mention in the doc string that
	the argument can be either a display name or a frame.

	* frame.el (display-pixel-height, display-pixel-width)
	(display-mm-height, display-mm-width, display-backing-store)
	(display-save-under, display-planes, display-color-cells)
	(display-visual-class, display-monitor-attributes-list)
	(display-screens): Mention in the doc string that the argument can
	be either a display name or a frame.  Improve the docs of the
	monitor attributes.  (Bug#18636)

2014-10-09  Martin Rudalics  <rudalics@gmx.at>

	* term.el (term-window-width): Subtract 1 from the width when
	any fringe has zero width, not just the right fringe.  (Bug#18601)

2014-10-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	* frame.el (make-frame): Use t rather than nil for `w' (bug#18653).

2014-10-08  Leo Liu  <sdl.web@gmail.com>

	* emacs-lisp/cl-extra.el (cl-fresh-line): New function.

2014-10-08  Glenn Morris  <rgm@gnu.org>

	* calendar/cal-x.el (calendar-dedicate-diary):
	Drop support for recently deleted aliases.

2014-10-08  Leo Liu  <sdl.web@gmail.com>

	* progmodes/cfengine.el (cfengine3-make-syntax-cache):
	Always return a syntax.  Replace call-process-shell-command with
	process-file.  Ensure cfengine-mode-syntax-functions-regex is
	always set.  Ensure cache when cfengine-cf-promises fails.
	(Bug#18620)

2014-10-07  Glenn Morris  <rgm@gnu.org>

	* font-lock.el (font-lock-fontify-buffer): Fix interactive-only markup.

2014-10-07  Wilson Snyder  <wsnyder@wsnyder.org>

	Sync with upstream verilog-mode revision c075a492.
	* progmodes/verilog-mode.el (verilog-mode-version): Bump.
	(verilog-menu): Add AUTOINSERTLAST.
	(verilog-no-indent-begin-re): When `verilog-indent-begin-after-if'
	is nil, fix indenting initial/final to match always statements, bug825.
	Reported by Tim Clapp.
	(verilog-extended-complete-re): Fix indentation of DPI-C imports,
	bug557.  Reported by ZeDong Mao and Jason Forkey.
	(verilog-read-decls): Fix parsing typed interfaces.
	Fix AUTOINOUTMODPORT missing types.  Reported by Stephan Bourduas.
	(verilog-auto-arg-ports): Fix verilog-auto-arg-format single.
	(verilog-auto-output-every): Add regexp to AUTOOUTPUTEVERY, bug793.
	Reported by Pierre-David Pfister.
	(verilog-auto-insert-lisp): Doc fix.
	(verilog-auto-insert-last, verilog-auto): Add AUTOINSERTLAST to
	allow post-AUTO user fixups, bug826.  Reported by Dennis Muhlestein.
	(verilog-sk-ovm-class, verilog-sk-uvm-object)
	(verilog-sk-uvm-component): Fix missing string keyword in class
	skeletons, bug824.  Reported by eldad faruhi.

2014-10-06  Stefan Monnier  <monnier@iro.umontreal.ca>

	* term/w32-win.el: Move all code from 32-common-fns.el here.
	(gui-select-text, gui-selection-value): Use w32 handlers in the w32
	console as well (bug#18629).
	* w32-common-fns.el: Remove.
	* loadup.el: Don't load w32-common-fns.el.
	* w32-fns.el: Don't require w32-common-fns.

	* icomplete.el: Move Iswitchb autoload here.  Much simpler.
	* obsolete/iswitchb.el (iswitchb-mode): Use normal autoload cookie.
	Remove redundant obsolescence thingy.
	* loadup.el: Don't load obsolete/loaddefs.el.
	* Makefile.in (obsolete-autoloads): Remove.
	(AUTOGENEL): Remove obsolete/loaddefs.el.

2014-10-06  Glenn Morris  <rgm@gnu.org>

	* Makefile.in (obsolete-autoloads): Write to a separate file,
	to workaround autoloads bug.  (Bug#17407)
	(AUTOGENEL): Add obsolete/loaddefs.el.
	* loadup.el: Load obsolete/loaddefs.el if present.
	* subr.el (do-after-load-evaluation):
	Don't warn about obsolete/loaddefs.el.

	* menu-bar.el (menu-bar-games-menu): Remove landmark.
	It has zero relationship to a game.

2014-10-06  Leo Liu  <sdl.web@gmail.com>

	* imenu.el (imenu): Re-write for clarity.

2014-10-06  Glenn Morris  <rgm@gnu.org>

	Remove calendar code obsolete since at least version 23.1.
	* calendar/cal-bahai.el (calendar-absolute-from-bahai)
	(calendar-print-bahai-date, calendar-bahai-prompt-for-date)
	(calendar-goto-bahai-date, list-bahai-diary-entries)
	(mark-bahai-calendar-date-pattern, mark-bahai-diary-entries)
	(insert-bahai-diary-entry, insert-monthly-bahai-diary-entry)
	(insert-yearly-bahai-diary-entry):
	* calendar/cal-china.el (chinese-calendar-time-zone)
	(chinese-calendar-location-name)
	(chinese-calendar-daylight-time-offset)
	(chinese-calendar-standard-time-zone-name)
	(chinese-calendar-daylight-time-zone-name)
	(chinese-calendar-daylight-savings-starts)
	(chinese-calendar-daylight-savings-ends)
	(chinese-calendar-daylight-savings-starts-time)
	(chinese-calendar-daylight-savings-ends-time)
	(chinese-calendar-celestial-stem)
	(chinese-calendar-terrestrial-branch)
	(calendar-absolute-from-chinese, calendar-print-chinese-date)
	(calendar-goto-chinese-date):
	* calendar/cal-coptic.el (calendar-absolute-from-coptic)
	(calendar-print-coptic-date, coptic-prompt-for-date)
	(calendar-goto-coptic-date, calendar-absolute-from-ethiopic)
	(calendar-print-ethiopic-date, calendar-goto-ethiopic-date):
	* calendar/cal-french.el (calendar-absolute-from-french)
	(calendar-print-french-date, calendar-goto-french-date):
	* calendar/cal-hebrew.el (diary-sabbath-candles-minutes)
	(calendar-absolute-from-hebrew, calendar-print-hebrew-date)
	(hebrew-calendar-yahrzeit, calendar-goto-hebrew-date)
	(holiday-rosh-hashanah-etc, holiday-hanukkah)
	(holiday-passover-etc, holiday-tisha-b-av-etc)
	(list-hebrew-diary-entries, mark-hebrew-calendar-date-pattern)
	(mark-hebrew-diary-entries, insert-hebrew-diary-entry)
	(insert-monthly-hebrew-diary-entry)
	(insert-yearly-hebrew-diary-entry, list-yahrzeit-dates)
	(diary-omer, diary-yahrzeit, diary-rosh-hodesh, diary-parasha)
	(diary-sabbath-candles):
	* calendar/cal-islam.el (calendar-absolute-from-islamic)
	(calendar-print-islamic-date, calendar-goto-islamic-date)
	(list-islamic-diary-entries, mark-islamic-calendar-date-pattern)
	(mark-islamic-diary-entries, insert-islamic-diary-entry)
	(insert-monthly-islamic-diary-entry)
	(insert-yearly-islamic-diary-entry):
	* calendar/cal-iso.el (calendar-absolute-from-iso)
	(calendar-print-iso-date, calendar-iso-read-args)
	(calendar-goto-iso-date, calendar-goto-iso-week):
	* calendar/cal-julian.el (calendar-absolute-from-julian)
	(calendar-print-julian-date, calendar-goto-julian-date)
	(calendar-absolute-from-astro, calendar-print-astro-day-number)
	(calendar-goto-astro-day-number):
	* calendar/cal-mayan.el (calendar-print-mayan-date)
	(calendar-next-haab-date, calendar-previous-haab-date)
	(calendar-next-tzolkin-date, calendar-previous-tzolkin-date)
	(calendar-next-calendar-round-date)
	(calendar-previous-calendar-round-date)
	(calendar-absolute-from-mayan-long-count)
	(calendar-goto-mayan-long-count-date):
	* calendar/cal-move.el (scroll-calendar-left)
	(scroll-calendar-right, scroll-calendar-left-three-months)
	(scroll-calendar-right-three-months):
	* calendar/cal-persia.el (calendar-absolute-from-persian)
	(calendar-print-persian-date, persian-prompt-for-date)
	(calendar-goto-persian-date):
	* calendar/cal-x.el (calendar-after-frame-setup-hooks):
	* calendar/calendar.el (view-diary-entries-initially)
	(mark-diary-entries-in-calendar, calendar-today-face)
	(diary-face, holiday-face, view-calendar-holidays-initially)
	(mark-holidays-in-calendar, initial-calendar-window-hook)
	(today-visible-calendar-hook, today-invisible-calendar-hook)
	(hebrew-diary-entry-symbol, islamic-diary-entry-symbol)
	(bahai-diary-entry-symbol, american-date-diary-pattern)
	(european-date-diary-pattern, european-calendar-display-form)
	(american-calendar-display-form, holidays-in-diary-buffer)
	(all-hebrew-calendar-holidays, all-christian-calendar-holidays)
	(all-islamic-calendar-holidays, all-bahai-calendar-holidays)
	(fancy-diary-buffer, increment-calendar-month)
	(extract-calendar-month, extract-calendar-day)
	(extract-calendar-year, exit-calendar, calendar-date-is-legal-p)
	(mark-visible-calendar-date, calendar-version):
	* calendar/diary-lib.el (diary-button-face, sexp-diary-entry-symbol)
	(diary-display-hook, list-diary-entries-hook)
	(mark-diary-entries-hook, nongregorian-diary-listing-hook)
	(nongregorian-diary-marking-hook, print-diary-entries-hook)
	(abbreviated-calendar-year, number-of-diary-entries)
	(view-other-diary-entries, add-to-diary-list)
	(include-other-diary-files, simple-diary-display)
	(fancy-diary-display, print-diary-entries, mark-diary-entries)
	(mark-sexp-diary-entries, mark-included-diary-files)
	(mark-calendar-days-named, mark-calendar-month)
	(mark-calendar-date-pattern, sort-diary-entries)
	(list-sexp-diary-entries, make-diary-entry, insert-diary-entry)
	(insert-weekly-diary-entry, insert-monthly-diary-entry)
	(insert-yearly-diary-entry, insert-anniversary-diary-entry)
	(insert-block-diary-entry, insert-cyclic-diary-entry)
	(fancy-diary-font-lock-keywords, fancy-diary-display-mode):
	* calendar/holidays.el (general-holidays, oriental-holidays)
	(local-holidays, other-holidays, hebrew-holidays)
	(christian-holidays, islamic-holidays, bahai-holidays)
	(solar-holidays, list-calendar-holidays)
	(check-calendar-holidays, mark-calendar-holidays)
	(filter-visible-calendar-holidays):
	* calendar/lunar.el (calendar-phases-of-moon, phases-of-moon)
	(diary-phases-of-moon): Remove obsolete aliases.
	* calendar/cal-menu.el (cal-menu-load-hook): Remove obsolete hook.
	* calendar/cal-x.el (calendar-one-frame-setup)
	(calendar-only-one-frame-setup, calendar-two-frame-setup):
	Remove obsolete functions.
	(cal-x-load-hook): Remove obsolete hook.
	* calendar/calendar.el (european-calendar-style):
	Remove obsolete variable.
	(calendar-date-style): No longer consult european-calendar-style.
	* calendar/calendar.el (european-calendar, american-calendar):
	Remove obsolete commands.
	* calendar/calendar.el (calendar-for-loop): Remove obsolete macro.
	* calendar/diary-lib.el (diary-face): Remove obsolete variable.
	(diary-font-lock-date-forms, diary-fancy-font-lock-keywords):
	Use the face `diary' instead of the variable `diary-face'.
	* calendar/holidays.el (hebrew-holidays-1, hebrew-holidays-2)
	(hebrew-holidays-3, hebrew-holidays-4): Remove obsolete variables.
	* calendar/icalendar.el (icalendar--date-style): Remove function.
